Package: crisprBase
Version: 1.17.0
Date: 2025-10-27
Title: Base functions and classes for CRISPR gRNA design
Authors@R: person("Jean-Philippe", "Fortin", email = "fortin946@gmail.com", role = c("aut", "cre"))
Depends: utils, methods, R (>= 4.1)
Imports: BiocGenerics, Biostrings, GenomicRanges, graphics, IRanges,
        S4Vectors, stringr
Suggests: BiocStyle, knitr, rmarkdown, testthat
biocViews: CRISPR, FunctionalGenomics
Description: Provides S4 classes for general nucleases, CRISPR nucleases,
    CRISPR nickases, and base editors.Several CRISPR-specific genome
    arithmetic functions are implemented to help extract genomic coordinates
    of spacer and protospacer sequences. Commonly-used CRISPR nuclease objects
    are provided that can be readily used in other packages.
    Both DNA- and RNA-targeting nucleases are supported.
License: MIT + file LICENSE
Encoding: UTF-8
RoxygenNote: 7.3.3
VignetteBuilder: knitr
BugReports: https://github.com/crisprVerse/crisprBase/issues
URL: https://github.com/crisprVerse/crisprBase
Collate: 'AllGenerics.R' 'rebase.R' 'Nuclease-class.R'
        'Nickase-class.R' 'CrisprNuclease-class.R'
        'CrisprNickase-class.R' 'BaseEditor-class.R' 'arithmetics.R'
        'data.R' 'utils.R' 'converters.R' 'annotateMismatches.R'
LazyData: true
git_url: https://git.bioconductor.org/packages/crisprBase
git_branch: devel
git_last_commit: f896dbd
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 22:02:43 UTC; biocbuild
Author: Jean-Philippe Fortin [aut, cre]
Maintainer: Jean-Philippe Fortin <fortin946@gmail.com>

Base functions and classes for CRISPR gRNA design
================

-   <a href="#overview" id="toc-overview">Overview</a>
-   <a href="#installation" id="toc-installation">Installation</a>
    -   <a href="#software-requirements" id="toc-software-requirements">Software
        requirements</a>
        -   <a href="#os-requirements" id="toc-os-requirements">OS Requirements</a>
    -   <a href="#installation-1" id="toc-installation-1">Installation</a>
        -   <a href="#getting-started" id="toc-getting-started">Getting started</a>
-   <a href="#nuclease-class" id="toc-nuclease-class">Nuclease class</a>
    -   <a href="#examples" id="toc-examples">Examples</a>
    -   <a href="#accessor-functions" id="toc-accessor-functions">Accessor
        functions</a>
-   <a href="#crisprnuclease-class"
    id="toc-crisprnuclease-class">CrisprNuclease class</a>
    -   <a href="#crisprnuclease-objects-provided-in-crisprbase"
        id="toc-crisprnuclease-objects-provided-in-crisprbase">CrisprNuclease
        objects provided in CrisprBase</a>
-   <a href="#crispr-arithmetics" id="toc-crispr-arithmetics">CRISPR
    arithmetics</a>
    -   <a href="#crispr-terminology" id="toc-crispr-terminology">CRISPR
        terminology</a>
    -   <a href="#cut-site" id="toc-cut-site">Cut site</a>
    -   <a href="#obtaining-spacer-and-pam-sequences-from-target-sequences"
        id="toc-obtaining-spacer-and-pam-sequences-from-target-sequences">Obtaining
        spacer and PAM sequences from target sequences</a>
    -   <a
        href="#obtaining-genomic-coordinates-of-protospacer-sequences-using-pam-site-coordinates"
        id="toc-obtaining-genomic-coordinates-of-protospacer-sequences-using-pam-site-coordinates">Obtaining
        genomic coordinates of protospacer sequences using PAM site
        coordinates</a>
-   <a href="#baseeditor-class" id="toc-baseeditor-class">BaseEditor
    class</a>
-   <a href="#crisprnickase-class"
    id="toc-crisprnickase-class">CrisprNickase class</a>
-   <a href="#rna-targeting-nucleases"
    id="toc-rna-targeting-nucleases">RNA-targeting nucleases</a>
-   <a href="#additional-notes" id="toc-additional-notes">Additional
    notes</a>
    -   <a href="#dcas9-and-other-dead-nucleases"
        id="toc-dcas9-and-other-dead-nucleases">dCas9 and other “dead”
        nucleases</a>
-   <a href="#license" id="toc-license">License</a>
-   <a href="#reproducibility" id="toc-reproducibility">Reproducibility</a>
-   <a href="#references" id="toc-references">References</a>

Authors: Jean-Philippe Fortin

Date: July 5, 2022

# Overview

The `crisprBase` package is a core package of the [crisprVerse
ecosystem](https://github.com/crisprVerse) that provides S4 classes for
representing CRISPR nucleases and base editors. It also provides
arithmetic functions to extract genomic ranges to help with the design
and manipulation of CRISPR guide-RNAs (gRNAs). The classes and functions
are designed to work with a broad spectrum of nucleases and
applications, including PAM-free CRISPR nucleases, RNA-targeting
nucleases, and the more general class of restriction enzymes. It also
includes functionalities for CRISPR nickases.

It provides a language and convention for our gRNA design ecosystem
described in our recent bioRxiv preprint: [“The crisprVerse: a
comprehensive Bioconductor ecosystem for the design of CRISPR guide RNAs
across nucleases and
technologies”](https://www.biorxiv.org/content/10.1101/2022.04.21.488824v3)

# Installation

## Software requirements

### OS Requirements

This package is supported for macOS, Linux and Windows machines. It was
developed and tested on R version 4.2.1

## Installation

`crisprBase` can be installed from the Bioconductor devel branch by
typing the following commands inside of an R session:

``` r
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install(version="devel")
BiocManager::install("crisprBase")
```

The complete documentation for the package can be found
[here](https://bioconductor.org/packages/devel/bioc/manuals/crisprBase/man/crisprBase.pdf).

### Getting started

We load `crisprBase` in the usual way:

``` r
library(crisprBase)
```

# Nuclease class

The `Nuclease` class is designed to store minimal information about the
recognition sites of general nucleases, such as restriction enzymes. The
`Nuclease` class has 5 fields: `nucleaseName`, `targetType`, `metadata`,
`motifs` and `weights`. The `nucleaseName` field is a string specifying
a name for the nuclease. The `targetType` specifies if the nuclease
targets “DNA” (deoxyribonucleases) or “RNA” (ribonucleases). The
`metadata` field is a `list` of arbitrary length to store additional
information about the nuclease.

The `motifs` field is a character vector that specify one of several DNA
sequence motifs that are recognized by the nuclease for cleavage (always
in the 5’ to 3’ direction). The optional `weights` field is a numeric
vector specifying relative cleavage probabilities corresponding to the
motifs specified by `motifs`. Note that we use DNA to represent motifs
irrespectively of the target type for simplicity.

We use the Rebase convention to represent motif sequences (Roberts et
al. 2010). For enzymes that cleave within the recognition site, we add
the symbol `^` within the recognition sequence to specify the cleavage
site, always in the 5’ to 3’ direction. For enzymes that cleave away
from the recognition site, we specify the distance of the cleavage site
using a `(x/y)` notation where `x` represents the number of nucleotides
away from the recognition sequence on the original strand, and `y`
represents the number of nucleotides away from the recognition sequence
on the reverse strand.

## Examples

The EcoRI enzyme recognizes the palindromic motif `GAATTC`, and cuts
after the first nucleotide, which is specified using the `^` below:

``` r
library(crisprBase)

EcoRI <- Nuclease("EcoRI",
                  targetType="DNA",
                  motifs=c("G^AATTC"),
                  metadata=list(description="EcoRI restriction enzyme"))
```

The HgaI enzyme recognizes the motif `GACGC`, and cleaves DNA at 5
nucleotides downstream of the recognition sequence on the original
strand, and at 10 nucleotides downstream of the recognition sequence on
the reverse strand:

``` r
HgaI <- Nuclease("HgaI",
                 targetType="DNA",
                 motifs=c("GACGC(5/10)"),
                 metadata=list(description="HgaI restriction enzyme"))
```

In case the cleavage site was upstream of the recognition sequence, we
would instead specify `(5/10)GACGC`.

Note that any nucleotide letter that is part of the extended IUPAC
nucleic acid code can be used to represent recognition motifs. For
instance, we use `Y` and `R` (pyrimidine and purine, respectively) to
specify the possible recognition sequences for PfaAI:

``` r
PfaAI <- Nuclease("PfaAI",
                  targetType="DNA",
                  motifs=c("G^GYRCC"),
                  metadata=list(description="PfaAI restriction enzyme"))
```

## Accessor functions

The accessor function `motifs` retrieve the motif sequences:

``` r
motifs(PfaAI)
```

    ## DNAStringSet object of length 1:
    ##     width seq
    ## [1]     6 GGYRCC

To expand the motif sequence into all combinations of valid sequences
with only A/C/T/G nucleotides, users can use `expand=TRUE`.

``` r
motifs(PfaAI, expand=TRUE)
```

    ## DNAStringSet object of length 4:
    ##     width seq                                               names               
    ## [1]     6 GGCACC                                            GGYRCC
    ## [2]     6 GGTACC                                            GGYRCC
    ## [3]     6 GGCGCC                                            GGYRCC
    ## [4]     6 GGTGCC                                            GGYRCC

![Examples of restriction enzymes](vignettes/figures/enzymes.svg)

# CrisprNuclease class

CRISPR nucleases are examples of RNA-guided nucleases. For cleavage, it
requires two binding components. For CRISPR nucleases targeting DNA, the
nuclease needs to first recognize a constant nucleotide motif in the
target DNA called the protospacer adjacent motif (PAM) sequence. Second,
the guide-RNA (gRNA), which guides the nuclease to the target sequence,
needs to bind to a complementary sequence adjacent to the PAM sequence
(protospacer sequence). The latter can be thought of a variable binding
motif that can be specified by designing corresponding gRNA sequences.
For CRISPR nucleases targeting RNA, the equivalent of the PAM sequence
is called the Protospacer Flanking Sequence (PFS). We use the terms PAM
and PFS interchangeably as it should be clear from context.

The `CrisprNuclease` class allows to characterize both binding
components by extending the `Nuclease` class to contain information
about the gRNA sequences.The PAM sequence characteristics, and the
cleavage distance with respect to the PAM sequence, are specified using
the motif nomenclature described in the Nuclease section above.

3 additional fields are required: `pam_side`, `spacer_length` and
`spacer_gap`. The `pam_side` field can only take 2 values, `5prime` and
`3prime`, and specifies on which side the PAM sequence is located with
respect to the protospacer sequence. While it would be more appropriate
to use the terminology `pfs_side` for RNA-targeting nucleases, we still
use the term `pam_side` for simplicity.

The `spacer_length` specifies a default spacer length, and the
`spacer_gap` specifies a distance (in nucleotides) between the PAM (or
PFS) sequence and spacer sequence. For most nucleases,`spacer_gap=0` as
the spacer sequence is located directly next to the PAM/PFS sequence.

We show how we construct a `CrisprNuclease` object for the commonly-used
Cas9 nuclease (Streptococcus pyogenes Cas9):

``` r
SpCas9 <- CrisprNuclease("SpCas9",
                         targetType="DNA",
                         pams=c("(3/3)NGG", "(3/3)NAG", "(3/3)NGA"),
                         weights=c(1, 0.2593, 0.0694),
                         metadata=list(description="Wildtype Streptococcus pyogenes Cas9 (SpCas9) nuclease"),
                         pam_side="3prime",
                         spacer_length=20)
SpCas9
```

    ## Class: CrisprNuclease
    ##   Name: SpCas9
    ##   Target type: DNA
    ##   Metadata: list of length 1
    ##   PAMs: NGG, NAG, NGA
    ##   Weights: 1, 0.2593, 0.0694
    ##   Spacer length: 20
    ##   PAM side: 3prime
    ##     Distance from PAM: 0
    ##   Prototype protospacers: 5'--SSSSSSSSSSSSSSSSSSSS[NGG]--3', 5'--SSSSSSSSSSSSSSSSSSSS[NAG]--3', 5'--SSSSSSSSSSSSSSSSSSSS[NGA]--3'

Similar to the `Nuclease` class, we can specify PAM sequences using the
extended nucleotide code. SaCas9 serves as a good example:

``` r
SaCas9 <- CrisprNuclease("SaCas9",
                         targetType="DNA",
                         pams=c("(3/3)NNGRRT"),
                         metadata=list(description="Wildtype Staphylococcus 
                         aureus Cas9 (SaCas9) nuclease"),
                         pam_side="3prime",
                         spacer_length=21)
SaCas9
```

    ## Class: CrisprNuclease
    ##   Name: SaCas9
    ##   Target type: DNA
    ##   Metadata: list of length 1
    ##   PAMs: NNGRRT
    ##   Weights: 1
    ##   Spacer length: 21
    ##   PAM side: 3prime
    ##     Distance from PAM: 0
    ##   Prototype protospacers: 5'--SSSSSSSSSSSSSSSSSSSSS[NNGRRT]--3'

Here is another example where we construct a `CrisprNuclease` object for
the commonly-used Cas12a nuclease (AsCas12a):

``` r
AsCas12a <- CrisprNuclease("AsCas12a",
                           targetType="DNA",
                           pams="TTTV(18/23)",
                           metadata=list(description="Wildtype Acidaminococcus
                           Cas12a (AsCas12a) nuclease."),
                           pam_side="5prime",
                           spacer_length=23)
AsCas12a
```

    ## Class: CrisprNuclease
    ##   Name: AsCas12a
    ##   Target type: DNA
    ##   Metadata: list of length 1
    ##   PAMs: TTTV
    ##   Weights: 1
    ##   Spacer length: 23
    ##   PAM side: 5prime
    ##     Distance from PAM: 0
    ##   Prototype protospacers: 5'--[TTTV]SSSSSSSSSSSSSSSSSSSSSSS--3'

## CrisprNuclease objects provided in CrisprBase

Several already-constructed `crisprNuclease` objects are available in
`crisprBase`, see `data(package="crisprBase")`.

# CRISPR arithmetics

## CRISPR terminology

The terms **spacer** and **protospacer** are not interchangeable.
**spacer** refers to the sequence used in the gRNA construct to guide
the Cas nuclease to the target **protospacer** sequence in the host
genome / transcriptome. The **protospacer** sequence is adjacent to the
PAM sequence / PFS sequence. We use the terminology **target** sequence
to refer to the protospacer and PAM sequence taken together. For
DNA-targeting nucleases such as Cas9 and Cas12a, the spacer and
protospacer sequences are identical from a nucleotide point of view. For
RNA-targeting nucleases such as Cas13d, the spacer and protospacer
sequences are the reverse complement of each other.

An gRNA spacer sequence does not always uniquely target the host genome
(a given sgRNA spacer can map to multiple protospacers in the genome).
However, for a given reference genome, protospacer sequences can be
uniquely identified using a combination of 3 attributes:

-   **chr**: chromosome name
-   **strand**: forward (+) or reverse (-)
-   **pam_site**: genomic coordinate of the first nucleotide of the
    nuclease-specific PAM sequence. For SpCas9, this corresponds to the
    genomic coordinate of N in the NGG PAM sequence. For AsCas12a, this
    corresponds to the genomic coordinate of the first T nucleotide in
    the TTTV PAM sequence. For RNA-targeting nucleases, this corresponds
    to the first nucleotide of the PFS (we do not use `pfs_site` for
    simplicity).

![Examples of CRISPR nucleases](vignettes/figures/nucleases.svg)

## Cut site

For convention, we used the nucleotide directly downstream of the DNA
cut to represent the cut site nucleotide position. For instance, for
SpCas9 (blunt-ended dsDNA break), the cut site occurs at position -3
with respect to the PAM site. For AsCas12a, the 5nt overhang dsDNA break
occurs at 18 nucleotides after the PAM sequence on the targeted strand.
Therefore the cute site on the forward strand occurs at position 22 with
respect to the PAM site, and at position 27 on the reverse strand.

The convenience function `cutSites` extracts the cut site coordinates
relative to the PAM site:

``` r
data(SpCas9, package="crisprBase")
data(AsCas12a, package="crisprBase")
cutSites(SpCas9)
```

    ## [1] -3

``` r
cutSites(SpCas9, strand="-")
```

    ## [1] -3

``` r
cutSites(AsCas12a)
```

    ## [1] 22

``` r
cutSites(AsCas12a, strand="-")
```

    ## [1] 27

Below is an illustration of how different motif sequences and cut
patterns translate into cut site coordinates with respect to a PAM
sequence NGG:

![Examples of cut site coordinates](vignettes/figures/cut_sites.svg)

## Obtaining spacer and PAM sequences from target sequences

Given a list of target sequences (protospacer + PAM) and a
`CrisprNuclease` object, one can extract protospacer and PAM sequences
using the functions `extractProtospacerFromTarget` and
`extractPamFromTarget`, respectively.

``` r
targets <- c("AGGTGCTGATTGTAGTGCTGCGG",
             "AGGTGCTGATTGTAGTGCTGAGG")
extractPamFromTarget(targets, SpCas9)
```

    ## [1] "CGG" "AGG"

``` r
extractProtospacerFromTarget(targets, SpCas9)
```

    ## [1] "AGGTGCTGATTGTAGTGCTG" "AGGTGCTGATTGTAGTGCTG"

## Obtaining genomic coordinates of protospacer sequences using PAM site coordinates

Given a PAM coordinate, there are several functions in `crisprBase` that
allows to get get coordinates of the full PAM sequence, protospacer
sequence, and target sequence: `getPamRanges`, `getTargetRanges`, and
`getProtospacerRanges`, respectively. The output objects are `GRanges`:

``` r
chr      <- rep("chr7",2)
pam_site <- rep(200,2)
strand   <- c("+", "-")
gr_pam <- getPamRanges(seqnames=chr,
                       pam_site=pam_site,
                       strand=strand,
                       nuclease=SpCas9)
gr_protospacer <- getProtospacerRanges(seqnames=chr,
                                       pam_site=pam_site,
                                       strand=strand,
                                       nuclease=SpCas9)
gr_target <- getTargetRanges(seqnames=chr,
                             pam_site=pam_site,
                             strand=strand,
                             nuclease=SpCas9)
gr_pam
```

    ## GRanges object with 2 ranges and 0 metadata columns:
    ##       seqnames    ranges strand
    ##          <Rle> <IRanges>  <Rle>
    ##   [1]     chr7   200-202      +
    ##   [2]     chr7   198-200      -
    ##   -------
    ##   seqinfo: 1 sequence from an unspecified genome; no seqlengths

``` r
gr_protospacer
```

    ## GRanges object with 2 ranges and 0 metadata columns:
    ##       seqnames    ranges strand
    ##          <Rle> <IRanges>  <Rle>
    ##   [1]     chr7   180-199      +
    ##   [2]     chr7   201-220      -
    ##   -------
    ##   seqinfo: 1 sequence from an unspecified genome; no seqlengths

``` r
gr_target
```

    ## GRanges object with 2 ranges and 0 metadata columns:
    ##       seqnames    ranges strand
    ##          <Rle> <IRanges>  <Rle>
    ##   [1]     chr7   180-202      +
    ##   [2]     chr7   198-220      -
    ##   -------
    ##   seqinfo: 1 sequence from an unspecified genome; no seqlengths

and for AsCas12a:

``` r
gr_pam <- getPamRanges(seqnames=chr,
                       pam_site=pam_site,
                       strand=strand,
                       nuclease=AsCas12a)
gr_protospacer <- getProtospacerRanges(seqnames=chr,
                                       pam_site=pam_site,
                                       strand=strand,
                                       nuclease=AsCas12a)
gr_target <- getTargetRanges(seqnames=chr,
                             pam_site=pam_site,
                             strand=strand,
                             nuclease=AsCas12a)
gr_pam
```

    ## GRanges object with 2 ranges and 0 metadata columns:
    ##       seqnames    ranges strand
    ##          <Rle> <IRanges>  <Rle>
    ##   [1]     chr7   200-203      +
    ##   [2]     chr7   197-200      -
    ##   -------
    ##   seqinfo: 1 sequence from an unspecified genome; no seqlengths

``` r
gr_protospacer
```

    ## GRanges object with 2 ranges and 0 metadata columns:
    ##       seqnames    ranges strand
    ##          <Rle> <IRanges>  <Rle>
    ##   [1]     chr7   204-226      +
    ##   [2]     chr7   174-196      -
    ##   -------
    ##   seqinfo: 1 sequence from an unspecified genome; no seqlengths

``` r
gr_target
```

    ## GRanges object with 2 ranges and 0 metadata columns:
    ##       seqnames    ranges strand
    ##          <Rle> <IRanges>  <Rle>
    ##   [1]     chr7   200-226      +
    ##   [2]     chr7   174-200      -
    ##   -------
    ##   seqinfo: 1 sequence from an unspecified genome; no seqlengths

# BaseEditor class

Base editors are inactive Cas nucleases coupled with a specific
deaminase. For instance, the first cytosine base editor (CBE) was
obtained by coupling a cytidine deaminase with dCas9 to convert Cs to Ts
(Komor et al. 2016).

![Examples of base editors.](vignettes/figures/nucleasesBaseEditor.svg)

We provide in `crisprBase` a S4 class, `BaseEditor`, to represent base
editors. It extends the `CrisprNuclase` class with 3 additional fields:

-   `baseEditorName`: string specifying the name of the base editor.
-   `editingStrand`: strand where the editing happens with respect to
    the target protospacer sequence (“original” or “opposite”).
-   `editingWeights`: a matrix of experimentally-derived editing
    weights.

We now show how to build a `BaseEditor` object with the CBE base editor
BE4max with weights obtained from Arbab et al. (2020).

We first obtain a matrix of weights for the BE4max editor stored in the
package `crisprBase`:

``` r
# Creating weight matrix
weightsFile <- system.file("be/b4max.csv",
                           package="crisprBase",
                           mustWork=TRUE)
ws <- t(read.csv(weightsFile))
ws <- as.data.frame(ws)
```

The row names of the matrix must correspond to the nucleotide
substitutions Nucleotide substitutions that are not present in the
matrix will have weight assigned to 0.

``` r
rownames(ws)
```

    ## [1] "Position" "C2A"      "C2G"      "C2T"      "G2A"      "G2C"

The column names must correspond to the relative position with respect
to the PAM site.

``` r
colnames(ws) <- ws["Position",]
ws <- ws[-c(match("Position", rownames(ws))),,drop=FALSE]
ws <- as.matrix(ws)
head(ws)
```

    ##     -36 -35 -34 -33 -32 -31 -30 -29 -28 -27 -26 -25 -24 -23 -22 -21 -20  -19
    ## C2A 0.0 0.0 0.0 0.7 0.1 0.2 0.0 0.2 0.3 0.0 0.2 0.0 0.9 0.0 0.1 0.2 0.1  0.3
    ## C2G 0.9 0.1 0.1 0.0 0.3 0.7 0.1 0.1 0.7 0.0 0.4 0.1 0.1 0.1 0.1 0.1 0.0  0.5
    ## C2T 0.7 0.7 0.8 1.8 1.0 2.0 1.4 1.2 2.3 1.3 2.4 2.2 3.4 2.2 2.1 3.5 5.8 16.2
    ## G2A 0.0 0.0 0.5 0.0 0.0 0.3 0.4 1.1 0.9 0.6 0.3 1.7 0.7 0.8 0.1 0.3 0.1  0.0
    ## G2C 0.1 0.0 0.0 0.0 0.6 2.8 0.0 0.0 0.3 0.2 0.2 0.1 0.0 0.3 0.0 0.0 0.0  0.0
    ##      -18  -17  -16    -15  -14  -13  -12  -11  -10  -9  -8  -7  -6  -5  -4  -3
    ## C2A  1.0  2.0  2.7   3.00  2.7  1.9  0.8  0.6  0.3 0.0 0.1 0.1 0.1 0.0 0.0 0.0
    ## C2G  1.3  2.7  4.7   5.40  5.6  3.9  1.7  0.6  0.6 0.4 0.5 0.1 0.0 0.1 0.0 0.0
    ## C2T 31.8 63.2 90.3 100.00 87.0 62.0 31.4 16.3 10.0 5.6 3.3 1.9 1.8 2.4 1.7 0.5
    ## G2A  0.0  0.0  0.1   0.01  0.0  0.0  0.0  0.0  0.0 0.0 0.0 0.0 0.0 0.2 0.2 0.0
    ## G2C  0.0  0.0  0.2   0.00  0.0  0.1  0.1  0.2  0.2 0.0 0.0 0.0 0.1 0.0 0.0 0.0
    ##      -2  -1
    ## C2A 0.0 0.0
    ## C2G 0.0 0.0
    ## C2T 0.2 0.1
    ## G2A 0.0 0.1
    ## G2C 0.0 0.0

Since BE4max uses Cas9, we can use the SpCas9 `CrisprNuclease` object
available in `crisprBase` to build the `BaseEditor` object:

``` r
data(SpCas9, package="crisprBase")
BE4max <- BaseEditor(SpCas9,
                     baseEditorName="BE4max",
                     editingStrand="original",
                     editingWeights=ws)
metadata(BE4max)$description_base_editor <- "BE4max cytosine base editor."
BE4max
```

    ## Class: BaseEditor
    ##   CRISPR Nuclease name: SpCas9
    ##       Target type: DNA
    ##       Metadata: list of length 2
    ##       PAMs: NGG, NAG, NGA
    ##       Weights: 1, 0.2593, 0.0694
    ##       Spacer length: 20
    ##       PAM side: 3prime
    ##         Distance from PAM: 0
    ##       Prototype protospacers: 5'--SSSSSSSSSSSSSSSSSSSS[NGG]--3', 5'--SSSSSSSSSSSSSSSSSSSS[NAG]--3', 5'--SSSSSSSSSSSSSSSSSSSS[NGA]--3'
    ##   Base editor name: BE4max
    ##       Editing strand: original
    ##       Maximum editing weight: C2T at position -15

One can quickly visualize the editing weights using the function
`plotEditingWeights`:

``` r
plotEditingWeights(BE4max)
```

![](README_files/figure-gfm/unnamed-chunk-23-1.png)<!-- -->

# CrisprNickase class

CRISPR nickases can be created by mutating one of the two nuclease
domains of a CRISPR nuclease. They create single-strand breaks instead
of double-strand breaks.

For instance, the D10A mutation of SpCas9 inactivates the RuvC domain,
and the resulting CRISPR nickase (Cas9D10A) cleaves only the strand
opposite to the protospacer sequence. The H840A mutation of SpCas9
inactivates the HNN domain, and the resulting CRISPR nickase (Cas9H840A)
cleaves only the strand that contains the protospacer sequence. See
Figure below.

![Examples of CRISPR nickases.](vignettes/figures/nickases.svg)

The `CrisprNickase` class in `crisprBase` works similar to the
`CrisprNuclease` class:

``` r
Cas9D10A <- CrisprNickase("Cas9D10A",
                           nickingStrand="opposite",
                           pams=c("(3)NGG", "(3)NAG", "(3)NGA"),
                           weights=c(1, 0.2593, 0.0694),
                           metadata=list(description="D10A-mutated Streptococcus
                                         pyogenes Cas9 (SpCas9) nickase"),
                           pam_side="3prime",
                           spacer_length=20)
 
Cas9H840A <- CrisprNickase("Cas9H840A",
                            nickingStrand="original",
                            pams=c("(3)NGG", "(3)NAG", "(3)NGA"),
                            weights=c(1, 0.2593, 0.0694),
                            metadata=list(description="H840A-mutated Streptococcus
                                          pyogenes Cas9 (SpCas9) nickase"),
                            pam_side="3prime",
                            spacer_length=20)
```

The `nickingStrand` field indicates which strand is being cleaved by the
nickase.

# RNA-targeting nucleases

RNA-targeting CRISPR nucleases, such as the Cas13 family of nucleases,
target single-stranded RNA (ssRNA) instead of dsDNA as the name
suggests. The equivalent of the PAM sequence is called Protospacer
Flanking Sequence (PFS).

For RNA-targeting CRISPR nucleases, the spacer sequence is the reverse
complement of the protospacer sequence. This differs from DNA-targeting
CRISPR nucleases, for which the spacer and protospacer sequences are
identical.

We can construct an RNA-targeting nuclease in way similar to a
DNA-targeting nuclease by specifying `target="RNA"`. As an example, we
construct below a CrisprNuclease object for the CasRx nuclease (Cas13d
from Ruminococcus flavefaciens strain XPD3002):

``` r
CasRx <- CrisprNuclease("CasRx",
                        targetType="RNA",
                        pams="N",
                        metadata=list(description="CasRx nuclease"),
                        pam_side="3prime",
                        spacer_length=23)
CasRx
```

    ## Class: CrisprNuclease
    ##   Name: CasRx
    ##   Target type: RNA
    ##   Metadata: list of length 1
    ##   PFS: N
    ##   Weights: 1
    ##   Spacer length: 23
    ##   PFS side: 3prime
    ##     Distance from PFS: 0
    ##   Prototype protospacers: 5'--SSSSSSSSSSSSSSSSSSSSSSS[N]--3'

# Additional notes

## dCas9 and other “dead” nucleases

The CRISPR inhibition (CRISPRi) and CRISPR activation (CRISPRa)
technologies uses modified versions of CRISPR nucleases that lack
endonuclease activity, often referred to as “dead Cas” nucleases, such
as the dCas9.

While fully-active Cas nucleases and dCas nucleases differ in terms of
applications and type of genomic perturbations, the gRNA design remains
unchanged in terms of spacer sequence search and genomic coordinates.
Therefore it is convenient to use the fully-active version of the
nuclease throughout `crisprBase`.

# License

The project as a whole is covered by the MIT license.

# Reproducibility

``` r
sessionInfo()
```

    ## R version 4.2.1 (2022-06-23)
    ## Platform: x86_64-apple-darwin17.0 (64-bit)
    ## Running under: macOS Catalina 10.15.7
    ## 
    ## Matrix products: default
    ## BLAS:   /Library/Frameworks/R.framework/Versions/4.2/Resources/lib/libRblas.0.dylib
    ## LAPACK: /Library/Frameworks/R.framework/Versions/4.2/Resources/lib/libRlapack.dylib
    ## 
    ## locale:
    ## [1] en_US.UTF-8/en_US.UTF-8/en_US.UTF-8/C/en_US.UTF-8/en_US.UTF-8
    ## 
    ## attached base packages:
    ## [1] stats     graphics  grDevices utils     datasets  methods   base     
    ## 
    ## other attached packages:
    ## [1] crisprBase_1.1.6
    ## 
    ## loaded via a namespace (and not attached):
    ##  [1] rstudioapi_0.14        knitr_1.40             XVector_0.37.1        
    ##  [4] magrittr_2.0.3         GenomicRanges_1.49.1   BiocGenerics_0.43.4   
    ##  [7] zlibbioc_1.43.0        IRanges_2.31.2         rlang_1.0.5           
    ## [10] fastmap_1.1.0          highr_0.9              stringr_1.4.1         
    ## [13] GenomeInfoDb_1.33.7    tools_4.2.1            xfun_0.32             
    ## [16] cli_3.4.0              htmltools_0.5.3        yaml_2.3.5            
    ## [19] digest_0.6.29          crayon_1.5.1           GenomeInfoDbData_1.2.8
    ## [22] S4Vectors_0.35.3       bitops_1.0-7           RCurl_1.98-1.8        
    ## [25] evaluate_0.16          rmarkdown_2.16         stringi_1.7.8         
    ## [28] compiler_4.2.1         Biostrings_2.65.3      stats4_4.2.1

# References

<div id="refs" class="references csl-bib-body hanging-indent">

<div id="ref-behive" class="csl-entry">

Arbab, Mandana, Max W Shen, Beverly Mok, Christopher Wilson, Żaneta
Matuszek, Christopher A Cassa, and David R Liu. 2020. “Determinants of
Base Editing Outcomes from Target Library Analysis and Machine
Learning.” *Cell* 182 (2): 463–80.

</div>

<div id="ref-komor" class="csl-entry">

Komor, Alexis C, Yongjoo B Kim, Michael S Packer, John A Zuris, and
David R Liu. 2016. “Programmable Editing of a Target Base in Genomic DNA
Without Double-Stranded DNA Cleavage.” *Nature* 533 (7603): 420–24.

</div>

<div id="ref-rebase" class="csl-entry">

Roberts, Richard J, Tamas Vincze, Janos Posfai, and Dana Macelis. 2010.
“REBASE—a Database for DNA Restriction and Modification: Enzymes, Genes
and Genomes.” *Nucleic Acids Research* 38 (suppl_1): D234–36.

</div>

</div>

library(devtools)
load("pams/cas9/cas9.pams.rda")
load("pams/cas12a/cas12a.pams.rda")
load("genomes/genomes.rda")
use_data(cas9.pams, 
         cas12a.pams,
         genomes,
         internal=TRUE,
         overwrite=TRUE)

#' @title Annotate mismatches between spacer and protospacer sequences
#' @description Annotate mismatches between spacer and protospacer sequences.
#' 
#' @param spacers A character vector specifying spacer sequences (gRNA).
#' @param protospacers A character vector specifying protospacer sequences
#'     (target DNA).
#' @param rnase Is it for an RNAse? FALSE by default.
#'     If TRUE, spacers and protospacers are expected to be
#'     the reverse complement of each other. 
#' 
#' @return A data.frame storing spacer and protospacer columns,
#'     as well as number of mismatches, and positions for 
#'     the different mismatches, if any.
#'     Positions are relative to the 5' end of the 
#'     spacer sequences. For RNAses (e.g. CasRx), this means
#'     that a mismatch at position 1 corresponds to the last
#'     nucleotide of the protospacer sequence. 
#' 
#' 
#' @examples
#' spacers <- c("CCGGAGCGAGTTGCAGTAAGCAG",
#'     "GCCGGAGCGAGTTGCAGTAAGCA", 
#'     "GGCCGGAGCGAGTTGCAGTAAGC")
#' 
#' protospacers=c("CTGCTTACTGCAACTCGCTCTGG",
#'     "TGCTTAATGCAACCCGCTCCGGC", 
#'     "GCTTACTGCAACTCGCTCCGGCC")
#' 
#' ann <- annotateMismatches(spacers,
#'     protospacers,
#'     rnase=TRUE)
#' 
#' @author Jean-Philippe Fortin
#' 
#' @export
#' @importFrom Biostrings DNAStringSet reverseComplement
annotateMismatches <- function(spacers,
                               protospacers,
                               rnase=FALSE
){

    if (is(spacers, "DNAStringSet")){
        spacers <- as.character(spacers)
    }
    if (is(protospacers, "DNAStringSet")){
        protospacers <- as.character(protospacers)
    }
    if (length(spacers)!=length(protospacers)){
        stop("spacers and protospacers must have the same length.")
    }
    if (!all.equal(nchar(spacers),nchar(protospacers))){
        stop("spacers and protospacers must have words of the same length.")
    }

    max_mismatches <- 3
    results <- data.frame(spacer=spacers,
                          protospacer=protospacers)
    words1 <- spacers
    words2 <- protospacers
    if (rnase){
        words2 <- reverseComplement(DNAStringSet(words2))
        words2 <- as.character(words2)
    }
    results$n_mismatches <- vapply(seq_along(words1), function(i){
        cost <- c(sub=1, del=1000, ins=1000)
        utils::adist(words1[i],
                     words2[i],
                     cost=cost)[[1]]
    }, FUN.VALUE=1)


    max_mismatches <- max(max(results$n_mismatches),
                          max_mismatches)
    words1 <- Biostrings::DNAStringSet(words1)
    words2 <- Biostrings::DNAStringSet(words2)
    x1 <- as.matrix(words1)
    x2 <- as.matrix(words2)
    whs <- apply(x1!=x2,1,which, simplify=FALSE)
    mm <- lapply(whs, function(wh){
        wh <- c(wh, rep(NA, max_mismatches-length(wh)))
        return(wh)
    }) 
    mm <- do.call(rbind, mm)
    cols <- paste0("mm", seq_len(max_mismatches))
    colnames(mm) <- cols
    results <- cbind(results, mm)
    return(results)
}

load("cas12a.pams.rda")
load("doench/encas12a.scores.doench.rda")
wh <- match(cas12a.pams$PAM, encas12a.scores.doench$PAM)
cas12a.pams$Score_Doench <- encas12a.scores.doench$Score[wh]

# Rescaling Doench score:
#common <- which(!is.na(cas12a.pams$Score) & !is.na(cas12a.pams$Score_Doench))
#top    <- max(1-cas12a.pams$Score_Doench[common], na.rm=TRUE)
#bottom <- max(1-cas12a.pams$Score[common], na.rm=TRUE)
#factor <- top/bottom
#temp=1-cas12a.pams$Score_Doench
#temp <- temp/factor
#temp <- 1-temp
#cas12a.pams$Score_Doench <- temp


#Filling the gaps:
#wh <- which(is.na(cas12a.pams$Score_Doench))
#cas12a.pams$Score_Doench[wh] <- cas12a.pams$Score[wh]
save(cas12a.pams, file="cas12a.pams.rda")

#col <- as.numeric(as.factor(cas12a.pams$Tier))
#plot(cas12a.pams$Score,cas12a.pams$Score_Doench,col=col, pch=20)
#abline(a=0,b=1)

###Create all possibilities for 2 genes:
prefix1 <- "ACCACC"
prefix2 <- "ATGACC"
suffix1 <- "GCTGATTGCTAGGACAGCTAGAGGTCG"
suffix2 <- "GCTGATTGCTAGGAGGGCTAAGAGCCG"
pams <- expand.grid(rep(list(c('A', 'G', 'T', 'C')), 4))
pams <- do.call(paste0, pams)
seqs1 <- paste0(prefix1, pams,suffix1)
seqs2 <- paste0(prefix2, pams,suffix2)
names1 <- paste0(">MYL1", 1:length(seqs1))
names2 <- paste0(">MYC1_", 1:length(seqs2))
df1 <- cbind(names1,seqs1)
df2 <- cbind(names2,seqs2)
df1 <- as.vector(t(df1))
df2 <- as.vector(t(df2))
writeLines(df1[1:256], "files/myl1_myc1_11.fasta")
writeLines(df1[1:256+256], "files/myl1_myc1_12.fasta")
writeLines(df2[1:256], "files/myl1_myc1_21.fasta")
writeLines(df2[1:256+256], "files/myl1_myc1_22.fasta")

###Reading results in:
cols <- c("spacer", "score", "pam")
results11 <- read.csv("files/results11.txt", sep="\t")
results12 <- read.csv("files/results12.txt", sep="\t")
results1 <- rbind(results11, results12)
results1 <- results1[,c("sgRNA.Sequence","On.Target.Efficacy.Score","PAM.Sequence")]
colnames(results1) <- cols
results1 <- results1[results1$spacer=="GCTGATTGCTAGGACAGCTAGAG",]
results1 <- results1[order(results1$pam),]

results21 <- read.csv("files/results21.txt", sep="\t")
results22 <- read.csv("files/results22.txt", sep="\t")
results2 <- rbind(results21, results22)
results2 <- results2[,c("sgRNA.Sequence","On.Target.Efficacy.Score","PAM.Sequence")]
colnames(results2) <- cols
results2 <- results2[results2$spacer=="GCTGATTGCTAGGAGGGCTAAGA",]
results2 <- results2[order(results2$pam),]

results1$score <- results1$score/max(results1$score)
results2$score <- results2$score/max(results2$score)
#plot(results1$score, results2$score, ylim=c(0,1), xlim=c(0,1))
#abline(a=0,b=1, lty=3)
results1 <- results1[,c("score", "pam")]
results2 <- results2[,c("score", "pam")]
results <- results1
results$score <- (results1$score+results2$score)/2 
colnames(results) <- c("Score", "PAM")
results <- results[,2:1]
results <- results[order(-results$Score),]
rownames(results) <- NULL
encas12a.scores.doench <- results
save(encas12a.scores.doench, file="encas12a.scores.doench.rda")

library(crisprBase)
library(devtools)

SpCas9 <- CrisprNuclease("SpCas9",
                         pams=c("(3/3)NGG", "(3/3)NAG", "(3/3)NGA"),
                         weights=c(1, 0.2593, 0.0694),
                         metadata=list(description="Wildtype Streptococcus pyogenes Cas9 (SpCas9) nuclease"),
                         pam_side="3prime",
                         spacer_length=20)


SaCas9 <- CrisprNuclease("SaCas9",
                         pams=c("(3/3)NNGRRA","(3/3)NNGRRC", "(3/3)NNGRRG", "(3/3)NNGRRT"),
                         weights=c(0.1666, 0.1666, 0.1666, 0.5),
                         metadata=list(description="Wildtype Staphylococcus aureus Cas9 (SaCas9) nuclease"),
                         pam_side="3prime",
                         spacer_length=21)


AsCas12a <- CrisprNuclease("AsCas12a",
                           pams="TTTV(18/23)",
                           metadata=list(description="Wildtype Acidaminococcus Cas12a (AsCas12a) nuclease."),
                           pam_side="5prime",
                           spacer_length=23)

MAD7 <- CrisprNuclease("MAD7",
                       pams="YTTV(18/23)",
                       metadata=list(description="MAD7 nuclease (Cas12a-like family)."),
                       pam_side="5prime",
                       spacer_length=23)


### RNA-targeting nucleases:
CasRx <- CrisprNuclease("CasRx",
                        targetType="RNA",
                        pams="N",
                        metadata=list(description="Cas13d-NLS from Ruminococcus flavefaciens strain XPD3002.",
                                      doi="10.1016/j.cell.2018.02.033"),
                        pam_side="3prime",
                        spacer_length=23)

Csm <- CrisprNuclease("Csm",
                      targetType="RNA",
                      pams="N",
                      metadata=list(description="RNA-targeting Csm complex from Streptococcus thermophilus",
                                    doi="10.1038/s41587-022-01649-9"),
                      pam_side="3prime",
                      spacer_length=32)


# SpG nuclease:
load("pams/spg/spg.pams.rda")
pams <- spg.pams[, c("PAM", "Score")]
pams <- pams[order(-pams$Score),,]
motifs <- paste0("(3/3)", pams$PAM)
SpG <- CrisprNuclease("SpG",
                             pams=motifs,
                             weights=pams$Score,
                             metadata=list(description="Engineered Streptococcus pyogenes Cas9 nuclease SpCas9-NG (SpG)."),
                             pam_side="3prime",
                             spacer_length=20)


load("pams/cas12a/cas12a.pams.rda")
pams <- cas12a.pams[, c("PAM", "Score_Doench")]
pams <- pams[!is.na(pams$Score_Doench),]
pams$Score_Doench[pams$PAM %in% c("TTTC","TTTA", "TTTG")] <- 1
pams <- pams[order(-pams$Score_Doench),,]
motifs <- paste0(pams$PAM, "(18/23)")
enAsCas12a <- CrisprNuclease("enAsCas12a",
                             pams=motifs,
                             weights=pams$Score_Doench,
                             metadata=list(description="Enhanced Acidaminococcus Cas12a (AsCas12a) nuclease."),
                             pam_side="5prime",
                             spacer_length=23)


#Generate base editor
ws <- t(read.csv("../inst/be/b4max.csv"))
colnames(ws) <- ws["Position",]
ws <- ws[-c(match("Position", rownames(ws))),]
load("../data/SpCas9.rda")
BE4max <- BaseEditor(SpCas9,
                     baseEditorName="BE4max",
                     editingStrand="original",
                     editingWeights=ws)
metadata(BE4max)$description_base_editor <- "BE4max cytosine base editor."


#dir.create("../data")
use_data(SpCas9,
         SaCas9,
         SpG,
         AsCas12a,
         enAsCas12a,
         MAD7,
         CasRx,
         Csm,
         BE4max,
         compress="xz", internal=FALSE, overwrite=TRUE)





# Enzymes:
# EcoRI <- Nuclease("EcoRI",
#                   motifs=c("G^AATTC"),
#                   metadata="EcoRI restriction enzyme")

# SmaI <- Nuclease("SmaI",
#                   motifs=c("CCC^GGG"),
#                   metadata="SmaI restriction enzyme")

# HgaI <- Nuclease("HgaI",
#                  motifs=c("GACGC(5/10)"),
#                  metadata="HgaI restriction enzyme")

# PfaAI <- Nuclease("PfaAI",
#                   motifs=c("G^GYRCC"),
#                   metadata="PfaAI restriction enzyme")

#' @import methods
NULL




#' @export
#' @importFrom S4Vectors metadata
S4Vectors::metadata


#' @export
#' @importFrom S4Vectors metadata<-
S4Vectors::`metadata<-`




.checkDNAAlphabet <- function(x){
    chars <- unlist(strsplit(x, split=""))
    choices <- names(Biostrings::IUPAC_CODE_MAP)
    if (!all(chars %in% choices)){
        stop("Some characters are not part of the extended ",
             "nucleotide alphabet.")
    }
}



.validateStrand <- function(strand,
                            values=c("+","-")
){
    if (!all(strand %in% values) | is.null(strand)){
        choices <- paste0(values, collapse=", ")
        stop("strand must have one of the following values: ",
             choices)
    }
    return(strand)
}




.isNuclease <- function(object){
    is(object, "Nuclease")
}

.isCrisprNuclease <- function(object){
    is(object, "CrisprNuclease")
}


.isBaseEditor <- function(object){
    is(object, "BaseEditor")
}


.isNucleaseOrStop <- function(object) {
    if (!is(object, "Nuclease")) {
        stop("object is of class '", class(object), "', but needs to be of ",
             "class 'Nuclease'")
    }
}

.isCrisprNucleaseOrStop <- function(object) {
    if (!is(object, "CrisprNuclease")) {
        stop("object is of class '", class(object), "', but needs to be of ",
             "class 'CrisprNuclease'")
    } 
}

.isBaseEditorOrStop <- function(object) {
    if (!is(object, "BaseEditor")) {
        stop("object is of class '", class(object), "', but needs to be of ",
             "class 'BaseEditor'")
    } 
}



# convert values in scientific notation to integers
.makeLongInteger <- function(n){
    as.integer(format(n, scientific=FALSE))
}



.validateNonNegativeInteger <- function(x){
    x  <- .validateInteger(x)
    if (x < 0){
        stop("x must be 0 or positive")
    }
    return(as.integer(x))
}
.validateNonNegativeInteger <- Vectorize(.validateNonNegativeInteger)

.validateInteger <- function(x){
    tol = .Machine$double.eps^0.5
    check <- abs(x - as.integer(x)) < tol
    if (!check){
        stop("x must be an integer")
    } 
    return(as.integer(x))
}



.printVectorNicely <- function(x){
    if (length(x)<=3){
        x <- paste0(x, collapse=", ")
    } else {
        x.last <- x[length(x)]
        x <- paste0(x[seq_len(2)], collapse=", ")
        x <- paste0(x, ",..., ", x.last)
    }
    return(x)
}

.printMatrixNicely <- function(x){
    if (length(x)<=3){
        x <- paste0(x, collapse=", ")
    } else {
        x.last <- x[length(x)]
        x <- paste0(x[seq_len(2)], collapse=", ")
        x <- paste0(x, ",..., ", x.last)
    }
    return(x)
}






.validateGROrNull <- function(gr){
    if (is.null(gr)){
        return(gr)
    }
    if (!is(gr, "GRanges")){
        stop("gr must be a GenomicRanges object")
    }
    return(gr)
}

#' @importFrom BiocGenerics width
.validatePosGrOrNull <- function(gr){
    .validateGROrNull(gr)
    if (is.null(gr)){
        return(gr)
    }
    ws <- width(gr)
    if (!all(ws==1)){
        stop("Supplied GRanges must have ranges of width 1.")
    } 
    return(gr)
}




#' @importFrom GenomicRanges GRanges
#' @importFrom IRanges IRanges
.buildGRFromPamSite <- function(seqnames,
                                pam_site,
                                strand
){
    len1  <- length(seqnames)
    len2  <- length(pam_site)
    len3  <- length(strand)
    lens  <- unique(c(len1, len2, len3))
    cond1 <- length(lens)==3
    cond2 <- length(lens)==2 & !(1 %in% lens)

    if (cond1 | cond2){
        stop("seqnames, pam_site, strand must all have",
             " the same length if not of length 1")
    } 
    pam_site <- .validateNonNegativeInteger(pam_site)
    strand   <- .validateStrand(strand)
    seqnames <- as.character(seqnames)

    gr <- GRanges(seqnames,
                  IRanges(start=pam_site, width=1),
                  strand=strand)
    return(gr)
}



.resetGRCoordinates <- function(gr){
    start(gr) <- rep(1, length(gr))
    end(gr)   <- rep(1, length(gr))
    return(gr)
}


#' @title Return list of available CrisprNuclease objects in crisprBase
#' @description Return list of available CrisprNuclease objects in crisprBase. 
#'     
#' @return Character vector of available \code{CrisprNuclease} objects found
#'     in \code{crisprBase}.
#' 
#' @author Jean-Philippe Fortin
#'
#' @examples
#' getAvailableCrisprNucleases()
#' 
#' @importFrom utils data
#' @export
getAvailableCrisprNucleases <- function(){
    results <- data(package="crisprBase")[["results"]]
    results <- as.data.frame(results)
    results <- results[, c("Item", "Title")]
    results <- results[grepl("CrisprNuclease", results[["Title"]]),]
    as.character(results[["Item"]])
}

## ----echo=FALSE, results="hide"-----------------------------------------------
options("knitr.graphics.auto_pdf"=TRUE, eval=TRUE)

## ----warnings=FALSE, message=FALSE--------------------------------------------
library(crisprBase)

## ----warning=FALSE, message=FALSE---------------------------------------------
library(crisprBase)

EcoRI <- Nuclease("EcoRI",
                  targetType="DNA",
                  motifs=c("G^AATTC"),
                  metadata=list(description="EcoRI restriction enzyme"))

## -----------------------------------------------------------------------------
HgaI <- Nuclease("HgaI",
                 targetType="DNA",
                 motifs=c("GACGC(5/10)"),
                 metadata=list(description="HgaI restriction enzyme"))

## -----------------------------------------------------------------------------
PfaAI <- Nuclease("PfaAI",
                  targetType="DNA",
                  motifs=c("G^GYRCC"),
                  metadata=list(description="PfaAI restriction enzyme"))

## -----------------------------------------------------------------------------
motifs(PfaAI)

## -----------------------------------------------------------------------------
motifs(PfaAI, expand=TRUE)

## ----echo=FALSE, fig.cap="Examples of restriction enzymes"--------------------
knitr::include_graphics("./figures/enzymes.svg")

## -----------------------------------------------------------------------------
SpCas9 <- CrisprNuclease("SpCas9",
                         targetType="DNA",
                         pams=c("(3/3)NGG", "(3/3)NAG", "(3/3)NGA"),
                         weights=c(1, 0.2593, 0.0694),
                         metadata=list(description="Wildtype Streptococcus pyogenes Cas9 (SpCas9) nuclease"),
                         pam_side="3prime",
                         spacer_length=20)
SpCas9

## -----------------------------------------------------------------------------
SaCas9 <- CrisprNuclease("SaCas9",
                         targetType="DNA",
                         pams=c("(3/3)NNGRRT"),
                         metadata=list(description="Wildtype Staphylococcus 
                         aureus Cas9 (SaCas9) nuclease"),
                         pam_side="3prime",
                         spacer_length=21)
SaCas9

## -----------------------------------------------------------------------------
AsCas12a <- CrisprNuclease("AsCas12a",
                           targetType="DNA",
                           pams="TTTV(18/23)",
                           metadata=list(description="Wildtype Acidaminococcus
                           Cas12a (AsCas12a) nuclease."),
                           pam_side="5prime",
                           spacer_length=23)
AsCas12a

## ----echo=FALSE, fig.cap="Examples of CRISPR nucleases"-----------------------
knitr::include_graphics("./figures/nucleases.svg")

## -----------------------------------------------------------------------------
data(SpCas9, package="crisprBase")
data(AsCas12a, package="crisprBase")
cutSites(SpCas9)
cutSites(SpCas9, strand="-")
cutSites(AsCas12a)
cutSites(AsCas12a, strand="-")

## ----echo=FALSE, fig.cap="Examples of cut site coordinates"-------------------
knitr::include_graphics("./figures/cut_sites.svg")

## -----------------------------------------------------------------------------
targets <- c("AGGTGCTGATTGTAGTGCTGCGG",
             "AGGTGCTGATTGTAGTGCTGAGG")
extractPamFromTarget(targets, SpCas9)
extractProtospacerFromTarget(targets, SpCas9)

## -----------------------------------------------------------------------------
chr      <- rep("chr7",2)
pam_site <- rep(200,2)
strand   <- c("+", "-")
gr_pam <- getPamRanges(seqnames=chr,
                       pam_site=pam_site,
                       strand=strand,
                       nuclease=SpCas9)
gr_protospacer <- getProtospacerRanges(seqnames=chr,
                                       pam_site=pam_site,
                                       strand=strand,
                                       nuclease=SpCas9)
gr_target <- getTargetRanges(seqnames=chr,
                             pam_site=pam_site,
                             strand=strand,
                             nuclease=SpCas9)
gr_pam
gr_protospacer
gr_target

## -----------------------------------------------------------------------------
gr_pam <- getPamRanges(seqnames=chr,
                       pam_site=pam_site,
                       strand=strand,
                       nuclease=AsCas12a)
gr_protospacer <- getProtospacerRanges(seqnames=chr,
                                       pam_site=pam_site,
                                       strand=strand,
                                       nuclease=AsCas12a)
gr_target <- getTargetRanges(seqnames=chr,
                             pam_site=pam_site,
                             strand=strand,
                             nuclease=AsCas12a)
gr_pam
gr_protospacer
gr_target

## ----echo=FALSE, fig.cap="Examples of base editors."--------------------------
knitr::include_graphics("./figures/nucleasesBaseEditor.svg")

## -----------------------------------------------------------------------------
# Creating weight matrix
weightsFile <- system.file("be/b4max.csv",
                           package="crisprBase",
                           mustWork=TRUE)
ws <- t(read.csv(weightsFile))
ws <- as.data.frame(ws)

## -----------------------------------------------------------------------------
rownames(ws)

## -----------------------------------------------------------------------------
colnames(ws) <- ws["Position",]
ws <- ws[-c(match("Position", rownames(ws))),,drop=FALSE]
ws <- as.matrix(ws)
head(ws)

## -----------------------------------------------------------------------------
data(SpCas9, package="crisprBase")
BE4max <- BaseEditor(SpCas9,
                     baseEditorName="BE4max",
                     editingStrand="original",
                     editingWeights=ws,
                     scale=TRUE)
metadata(BE4max)$description_base_editor <- "BE4max cytosine base editor."
BE4max

## -----------------------------------------------------------------------------
plotEditingWeights(BE4max)

## ----echo=FALSE, fig.cap="Examples of CRISPR nickases."-----------------------
knitr::include_graphics("./figures/nickases.svg")

## -----------------------------------------------------------------------------
Cas9D10A <- CrisprNickase("Cas9D10A",
                           nickingStrand="opposite",
                           pams=c("(3)NGG", "(3)NAG", "(3)NGA"),
                           weights=c(1, 0.2593, 0.0694),
                           metadata=list(description="D10A-mutated Streptococcus
                                         pyogenes Cas9 (SpCas9) nickase"),
                           pam_side="3prime",
                           spacer_length=20)
 
Cas9H840A <- CrisprNickase("Cas9H840A",
                            nickingStrand="original",
                            pams=c("(3)NGG", "(3)NAG", "(3)NGA"),
                            weights=c(1, 0.2593, 0.0694),
                            metadata=list(description="H840A-mutated Streptococcus
                                          pyogenes Cas9 (SpCas9) nickase"),
                            pam_side="3prime",
                            spacer_length=20)

## -----------------------------------------------------------------------------
CasRx <- CrisprNuclease("CasRx",
                        targetType="RNA",
                        pams="N",
                        metadata=list(description="CasRx nuclease"),
                        pam_side="3prime",
                        spacer_length=23)
CasRx

## -----------------------------------------------------------------------------
sessionInfo()

#' An S4 class to represent a CRISPR nickase.
#' 
#' @slot pam_side String specifying the side of the PAM sequence
#'     with respect to the protospacer sequence. Must be either 
#'     '3prime' (e.g. SpCas9) or '5prime' (e.g. AsCas12a)
#' @slot spacer_length Integer specifying the
#'     length of the spacer sequence
#' @slot spacer_gap Integer specifying the length (in nucleotides)
#'     between the spacer sequence and the PAM sequence
#'     (e.g. 0 for SpCas9 and AsCas12a).
#' 
#' @section Constructors:
#'     Use the constructor \code{link{CrisprNickase}} to create
#'         a CrisprNickase object.
#' 
#' @section Accessors:
#' \describe{
#'     \item{\code{nickaseName}:}{To get the name of the CRISPR nickase.} 
#'     \item{\code{spacerLength}:}{To return the length of the
#'         spacer sequence.}
#'     \item{\code{targetLength}:}{To return the length of the
#'         target sequence (protospacer + pam).}
#'     \item{\code{pamLength}:}{To return the length of the PAM sequence.}
#'     \item{\code{pamSide}:}{To return the side of the PAM sequence with
#'         respect to the spacer sequence.}
#'     \item{\code{spacerGap}:}{To return the length of the gap between the
#'         PAM and spacer sequences.}
#'     \item{\code{pams}:}{To return the list of PAM sequences.}
#' }
#' 
#' @section Setters:
#' \describe{
#'     \item{\code{spacerGap<-}:}{To change the length of the gap between the
#'         PAM and spacer sequences.}
#'     \item{\code{pamSide<-}:}{To change the side of the PAM sequence
#'         with respect to the protospacer sequence.}
#'     \item{\code{spacerLength<-}:}{To change the length of the spacer
#'         sequence.}
#' }
#' 
#' @section Utility functions for genomic arithmetics:
#' \describe{
#'     \item{\code{pamIndices}:}{To return the relative coordinates of the
#'         PAM sequence within the protospacer sequence.}
#'     \item{\code{spacerIndices}:}{To return the relatiive coordinates of
#'         the spacer sequence within the protospacer sequence.}
#' }
#' @examples
#' Cas9D10A <- CrisprNickase("Cas9D10A",
#'                           nickingStrand="opposite",
#'                           pams=c("(3)NGG", "(3)NAG", "(3)NGA"),
#'                           weights=c(1, 0.2593, 0.0694),
#'                           metadata=list(description="D10A-mutated  Streptococcus
#'                                         pyogenes Cas9 (SpCas9) nickase"),
#'                           pam_side="3prime",
#'                           spacer_length=20)
#' 
#' Cas9H840A <- CrisprNickase("Cas9H840A",
#'                            nickingStrand="original",
#'                            pams=c("(3)NGG", "(3)NAG", "(3)NGA"),
#'                            weights=c(1, 0.2593, 0.0694),
#'                            metadata=list(description="H840A-mutated  Streptococcus
#'                                          pyogenes Cas9 (SpCas9) nickase"),
#'                            pam_side="3prime",
#'                            spacer_length=20)
#' 
#' @return A CrisprNickase object
#' 
#' @export
setClass("CrisprNickase", 
    contains = "Nickase", 
    slots = c(
        pam_side = "character",
        spacer_gap = "integer",
        spacer_length = "integer"),
    prototype = list(
        pam_side = NA_character_,
        spacer_gap = 0L,
        spacer_length =NA_integer_
    )
)



#' @describeIn CrisprNickase Create a \linkS4class{CrisprNickase} object
#' @param nickaseName Name of the CRISPR nickase.
#' @param nickingStrand String specifying with strand with respect
#'     to the motif sequence (5' to 3') is nicked.
#'     Must be either "original" (default) or "opposite".
#' @param pams Character vector of PAM sequence motifs
#'           written from 5' to 3. If the point of cleavage has
#'           been determined, the precise site is marked with ^.
#'           Only letters in the IUPAC code are accepted.
#'           For nickases that cleave away from their
#'           recognition sequence, the cleavage sites are indicated
#'           in parentheses. See details for more information.
#' @param weights Optional numeric vector specifying relative weights
#'           of the PAM sequences to specify cleavage probabilities. 
#' @param metadata Optional list providing global metadata information.
#' @param pam_side String specifying the side of the PAM sequence
#'     sequence with respect to the protospacer sequence. Must be either 
#'     '3prime' (e.g. Cas9) or '5prime' (e.g. Cas12a)
#' @param spacer_length Integer specifying the length of the spacer sequence
#' @param spacer_gap Integer specifying the length (in nucleotides) between
#'     the spacer sequence and the PAM sequence (e.g. 0 for Cas9 and Cas12a).
#' @export
CrisprNickase <- function(nickaseName,
                          nickingStrand = c("original", "opposite"),
                          pams = NA_character_,
                          weights = rep(1, length(pams)),
                          metadata = list(),
                          pam_side = NA_character_,
                          spacer_gap = 0L,
                          spacer_length = NA_integer_
){
    nickingStrand <- match.arg(nickingStrand)
    nick <- Nickase(nickaseName=nickaseName,
                    nickingStrand=nickingStrand,
                    motifs=pams,
                    weights=weights,
                    metadata=metadata)
    new("CrisprNickase",
        nick,
        pam_side = as.character(pam_side),
        spacer_gap = as.integer(spacer_gap),
        spacer_length = as.integer(spacer_length))
}



#' @rdname CrisprNickase-class
#' @export
setMethod("show", "CrisprNickase", function(object) {
    len <- length(metadata(object))
    pams.line <- ("  PAMs: ")
    pams.line.distance <- "    Distance from PAM: "
    pam.side.line <- "  PAM side: "
    
    cat(paste0("Class: ", is(object)[[1]]), "\n",
        "  Name: ", nickaseName(object), "\n",
        "  Nicking strand: ", nickingStrand(object), "\n",
        "  Metadata: list of length ", len, "\n",
        pams.line, .printVectorNicely(motifs(object)), "\n",
        "  Weights: ", .printVectorNicely(weights(object)), "\n",
        "  Spacer length: ",  spacerLength(object), "\n",
        pam.side.line,  pamSide(object), "\n",
        pams.line.distance, spacerGap(object), "\n",
        "  Prototype protospacers: ",
        .printVectorNicely(prototypeSequence(object, primary=FALSE)),
        "\n",
        sep = "")
})






setValidity("CrisprNickase", function(object) {
    out <- TRUE
    if (length(pamSide(object))!=1){
        out <- "Slot pam_side must be a character vector of length 1."
    } 
    if (!pamSide(object) %in% c("5prime", "3prime")){
        out <- "Slot pam_side must be either '5prime' or '3prime'."
    } 
    if (length(spacerLength(object))!=1){
        out <- "Slot spacer_length must be an integer vector of length 1."
    } 
    if (spacerLength(object)<0){
        out <- "Slot spacer_length must be a positive integer."
    } 
    if (length(spacerGap(object))!=1){
        out <- "Slot spacer_gap must be an integer vector of length 1."
    } 
    if (spacerGap(object)<0){
        out <- "Slot spacer_gap must be either 0 or a positive integer."
    } 
    return(out)
})











############################################################
##############       Getter and setters   ##################
#' @rdname CrisprNickase-class
#' @param object \linkS4class{CrisprNickase} object.
#' @export
setMethod("pamLength",
          "CrisprNickase",function(object){
    len <- motifLength(object)[1]
    names(len) <- NULL
    return(len)
})

#' @rdname CrisprNickase-class
#' @export
setMethod("spacerLength", "CrisprNickase", function(object){
    return(object@spacer_length)
})


#' @rdname CrisprNickase-class
#' @param value For \code{spacerLength<-} and \code{gapLength<-}, must be 
#'     a non-negative integer. For \code{pamSide}, must be either
#'     '5prime' or '3prime'.
#' 
#' @export
setMethod("spacerLength<-", "CrisprNickase", function(object, value){
    value <- .validateNonNegativeInteger(value)
    object@spacer_length <- value
    return(object)
})


#' @rdname CrisprNickase-class
#' @export
setMethod("pamSide",
          "CrisprNickase",function(object){
    return(object@pam_side)
})

#' @rdname CrisprNickase-class
#' @export
setMethod("pamSide<-", "CrisprNickase", function(object, value){
    if (!value %in% c("5prime", "3prime")){
        stop("value must be either '5prime' or '3prime'")
    }
    object@pam_side <- value
    return(object)
})





#' @rdname CrisprNickase-class
#' @export
setMethod("spacerGap",
          "CrisprNickase",function(object){
    return(object@spacer_gap)
})


#' @rdname CrisprNickase-class
#' @export
setMethod("spacerGap<-", "CrisprNickase", function(object, value){
    value <- .validateNonNegativeInteger(value)
    object@spacer_gap <- value
    return(object)
})

#' @rdname CrisprNickase-class
#' @export
setMethod("hasSpacerGap",
          "CrisprNickase",function(object){
    object@spacer_gap>0
})




#' @rdname CrisprNickase-class
#' @export
setMethod("targetLength",
          "CrisprNickase",function(object){
    pamLength(object) + spacerLength(object) + spacerGap(object)
})






#' @rdname CrisprNickase-class
#' @param primary Should only the PAM sequence with the heighest weight
#'     be returned? If no cleavage weights are stored in the
#'     \linkS4class{CrisprNickase} object, all sequences are returned.
#'     TRUE by default.
#' @param ignore_pam Should all possible k-mer sequences for a given PAM length
#'     be returned, irrespetively of the PAM sequence motifs stored in the
#'     \linkS4class{CrisprNickase} object? FALSE by default.
#' @param as.character Should the PAM sequences be returned as a 
#'     character vector? FALSE by default.
#' @export
setMethod("pams", "CrisprNickase",
    function(object,
             primary=TRUE,
             ignore_pam=FALSE,
             as.character=FALSE
){
    pam_length <- pamLength(object)
    if (ignore_pam){
        motif <- paste0(rep("N", pam_length), collapse="")
        pams <- .expandMotifs(motif)
    } else {
        pams <- motifs(object,
                       expand=TRUE,
                       primary=primary)
    } 
    if (as.character){
        pams <- as.character(pams)
    }
    return(pams)
})









############################################################
##############        Coordinates         ##################
#' @rdname CrisprNickase-class
#' @export
setMethod("pamIndices", "CrisprNickase",
    function(object){
    indices  <- seq_len(targetLength(object))
    pam_len  <- pamLength(object)
    pam_side <- pamSide(object)
    if (pam_side=="5prime"){
        indices <- indices[seq_len(pam_len)]
    } else {
        indices <- rev(rev(indices)[seq_len(pam_len)])
    }
    return(indices)
})


#' @rdname CrisprNickase-class
#' @export
setMethod("spacerIndices", "CrisprNickase", 
    function(object){
    indices <- seq_len(targetLength(object))
    spacer_len <- spacerLength(object)
    pam_side <- pamSide(object)
    if (pam_side=="3prime"){
        indices <- indices[seq_len(spacer_len)]
    } else {
        indices <- rev(rev(indices)[seq_len(spacer_len)])
    }
    return(indices)
})

#' @rdname CrisprNickase-class
#' @export
setMethod("prototypeSequence",
          "CrisprNickase",
          function(object, primary=TRUE){
    pam_len    <- pamLength(object)
    spacer_len <- spacerLength(object)
    gap_len    <- spacerGap(object)
    pam_side   <- pamSide(object)
    # Building sequence:
    spacer <- paste0(rep("S", spacer_len), collapse="")
    gap <- paste0(rep("-", gap_len), collapse="")
    pam <- motifs(object, primary=primary)
    if (pam_side=="3prime"){
        seq <- paste0(spacer, gap, "[" , pam, "]")
    } else {
        seq <- paste0("[", pam, "]", gap, spacer)
    }
    seq <- paste0("5'--", seq, "--3'")
    return(seq)
})  

library(stringr)
library(crisprBase)
data <- readLines("allenz.txt")
wh   <- which(grepl("References", data))
data <- data[1:wh]
wh1 <- which(grepl("<1>", data))
wh5 <- which(grepl("<5>", data))
enzymes <- data.frame(name=data[wh1])
enzymes$motif <- data[wh5] 
enzymes$name  <- gsub("<1>","", enzymes$name)
enzymes$motif <- gsub("<5>","", enzymes$motif)
enzymes <- enzymes[!grepl("\\?",enzymes$motif),]
enzymes <- enzymes[!grepl("\\-",enzymes$motif),]
good <- str_count(pattern="\\(",enzymes$motif)<=1
enzymes <- enzymes[good,]
enzymes <- enzymes[!grepl(",", enzymes$motif),]


checks <- lapply(enzymes$motif, function(x){
    crisprBase:::.checkRebaseMotif(x)
})
#valid <- vapply(checks, function(x) x$valid, FUN.VALUE=TRUE)
#enzymes <- enzymes[valid,]
enzymes$motifSequence <- gsub("\\^", "", enzymes$motif)
enzymes$motifSequence <- gsub("\\([0-9]+/[0-9]+\\)", "",
                              enzymes$motifSequence)
resEnzymes <- enzymes


nucs <- lapply(1:nrow(resEnzymes), function(i){
    Nuclease(nucleaseName=resEnzymes$name[i],
             metadata=list(description=paste0(resEnzymes$name[i], " from REBASE.")),
             motifs=resEnzymes$motif[i])
})
names(nucs) <- resEnzymes$name
restrictionEnzymes <- nucs
save(restrictionEnzymes,
     file="../../data/restrictionEnzymes.rda")

#' An S4 class to represent a nuclease.
#' 
#' @slot nucleaseName Name of the nuclease.
#' @slot targetType Character string indicationg target type ("DNA" or "RNA").
#' @slot motifs DNAStringSet of recognition sequence motifs
#'           written from 5' to 3'.
#' @slot cutSites Matrix with 2 rows (+ and - strand, respectively)
#'     specifying the cleavage coordinates relative to the first
#'     nucleotide of the motif sequence. Each column corresponds
#'     to a motif specified in the \code{motifs} slot. 
#' @slot weights Optional numeric vector specifying relative weights
#'           for the motifs corresponding to cleavage probabilities. 
#' @slot metadata Optional string providing a description of the nuclease.
#' 
#' @seealso See the \linkS4class{CrisprNuclease} for CRISPR-specific nucleases.
#' 
#' @section Constructors:
#'     Use the constructor \code{link{Nuclease}} to create a Nuclease object.
#' 
#' @section Accessors:
#' \describe{
#'     \item{\code{nucleaseName}:}{To get the name of the nuclease.} 
#'     \item{\code{targetType}:}{To get the target type ("DNA" or "RNA").}
#'     \item{\code{metadata}:}{To get the metadata list of the nuclease.} 
#'     \item{\code{motifs}:}{To get the recognition mofif
#'          nucleotide sequences.}
#'     \item{\code{weights}:}{To get nuclease weights.} 
#'     \item{\code{cutSites}:}{To get nuclease cut sites.} 
#' }
#' 
#' @examples
#' EcoRI <- Nuclease("EcoRI",
#'                   motifs=c("G^AATTC"),
#'                   metadata=list(description="EcoRI restriction enzyme"))
#' 
#' @return A Nuclease object
#' @export
#' @importFrom Biostrings DNAStringSet
#' @importClassesFrom S4Vectors Annotated
setClass("Nuclease",
    contains = "Annotated",
    slots = c(
        nucleaseName = "character", 
        targetType = "character",
        motifs = "DNAStringSet",
        cutSites = "matrix",
        weights = "numeric"),
    prototype = list(
        nucleaseName = NA_character_,
        targetType = NA_character_,
        motifs = NULL,
        cutSites = NULL,
        weights = NA_real_)
)










setValidity("Nuclease", function(object){
    out <- TRUE
    if (length(nucleaseName(object))!=1){
       out <- "Slot nucleaseName must be a character vector of length 1."
    } 
  
    if (!targetType(object) %in% c("DNA", "RNA")){
        out <- "Slot targetType must be either 'DNA' or 'RNA'"
    }

    if (length(weights(object))>1){
        if (length(weights(object)) != length(motifs(object))){
            out <- "Slots weights and motifs must be of the same length."
        } 
    } 

    sites <- cutSites(object,
                      strand="both",
                      combine=FALSE)
    if (ncol(sites) != length(motifs(object))){
        out <- "Number of columns in cutSites must be equal to the length of motifs."
    }
    if (nrow(sites)!=2){
        out <- "Number of rows in cutSites must be equal to 2."
    }

    return(out)
})







#' @describeIn Nuclease Create a \linkS4class{Nuclease} object
#' @param nucleaseName Name of the nuclease.
#' @param targetType String specifying target type ("DNA" or "RNA").
#' @param motifs Character vector of recognition sequence motifs
#'           written from 5' to 3' written in Rebase convention.
#'           If the point of cleavage has been determined, the
#'           precise site is marked with ^. Only letters in the
#'           IUPAC code are accepted. For nucleases that cleave
#'           away from their recognition sequence, the cleavage
#'           sites are indicated in parentheses. See details for
#'           more information. 
#' @param cutSites Matrix with 2 rows (+ and - strand, respectively)
#'     specifying the cleavage coordinates relative to the first
#'     nucleotide of the motif sequence. Each column corresponds
#'     to a motif specified in the \code{motifs} slot. 
#' @param weights Optional numeric vector specifying relative weights
#'           for the recognition motifs to specify cleavage probabilities. 
#' @param metadata Optional list providing global metadata information.
#' @export
#' @importFrom S4Vectors metadata metadata<-
Nuclease <- function(nucleaseName,
                     targetType=c("DNA", "RNA"),
                     motifs = NULL,
                     cutSites = NULL,
                     weights = rep(1, length(motifs)),
                     metadata = list()
){

    targetType <- match.arg(targetType)
    nucleaseName <- as.character(nucleaseName)
    weights <- as.numeric(weights)

    if (is(motifs, "DNAStringSet")){    
        if (is.null(cutSites)){
            stop("When 'motifs' is provided as a DNAStringset, ",
                 "'cutSites' must be provided. ")
        }
        sequences <- motifs
    } else if (is.character(motifs) & !is.null(cutSites)){
        .checkDNAAlphabet(motifs)
        sequences <- DNAStringSet(motifs)
    } else if (is.character(motifs) & is.null(cutSites)){
        .checkRebaseMotifs(motifs)
        sequences <- .extractSequencesFromRebaseMotifs(motifs)
        cutSites  <- .extractCutSitesFromRebaseMotifs(motifs)
    } else {
        stop("'motifs' must be either a character vector or a ",
             "DNAStringSet.")
    }
    
    if (!is.list(metadata)){
        stop("metadata must be a list.")
    }
    out <- new("Nuclease",
               nucleaseName=nucleaseName,
               targetType=targetType,
               motifs=sequences,
               cutSites=cutSites,
               weights=weights)
    metadata(out) <- metadata
    return(out)
}


#' @rdname Nuclease-class
#' @param object \linkS4class{Nuclease} object.
setMethod("show", "Nuclease", function(object){
    len <- length(metadata(object))
    cat(paste0("Class: ", is(object)[[1]]), "\n",
      "  Name: ", nucleaseName(object), "\n",
      "  Target type: ", targetType(object), "\n",
      "  Metadata: list of length ", len, "\n",
      "  Motifs: ", .printVectorNicely(motifs(object)), "\n",
      "  Weights: ", .printVectorNicely(weights(object)), "\n",
      sep = "")
})





#' @rdname Nuclease-class
#' @export
setMethod("nucleaseName", "Nuclease", 
    function(object){
    return(object@nucleaseName)
})

#' @rdname Nuclease-class
#' @param value New value to pass to the setter functions.
#' @export
setMethod("nucleaseName<-", "Nuclease", 
    function(object, value){
    object@nucleaseName <- as.character(value)
    return(object)
})


#' @rdname Nuclease-class
#' @export
setMethod("targetType", "Nuclease", 
    function(object){
    return(object@targetType)
})


#' @rdname Nuclease-class
#' @export
setMethod("targetType<-", "Nuclease", 
    function(object, value){
    object@targetType <- as.character(value)
    return(object)
})







#' @rdname Nuclease-class
#' @export
setMethod("weights", "Nuclease", 
    function(object,
             expand=FALSE
){
    ws <- object@weights
    names(ws) <- motifs(object)
    if (expand){
        motifs <- .expandMotifs(names(ws))
        ws <- ws[names(motifs)]
        names(ws) <- as.character(motifs)
    }
    return(ws)
})

#' @rdname Nuclease-class
#' @export
setMethod("weights<-", "Nuclease", 
    function(object, value){
    if (is.null(value)){
        object@weights <- NA
    } 
    object@weights <- value
    return(object)
})



#' @rdname Nuclease-class
#' @export
setMethod("isCutting", "Nuclease", 
    function(object){
    cuts <- cutSites(object)
    !all(is.na(c(cuts)))
})


#' @rdname Nuclease-class
#' @export
setMethod("isRnase", "Nuclease", 
    function(object){
    target <- targetType(object)
    target=="RNA"
})


#' @rdname Nuclease-class
#' @export
setMethod("isDnase", "Nuclease", 
    function(object){
    target <- targetType(object)
    target=="DNA"
})





#' @rdname Nuclease-class
#' @param primary Should only the motif with the highest weight be returned?
#'     FALSE by default. Only relevant if weights are stored in the 
#'     \linkS4class{Nuclease} object.
#' @param expand Should sequences be expanded to only contain ATCG nucleotides?
#'     FALSE by default.
#' @param strand Strand to allow reverse complementation of the motif.
#'     "+" by default. 
#' @param as.character Should the motif sequences be returned as a 
#'     character vector? FALSE by default.
#' @importFrom Biostrings reverseComplement
#' @export
setMethod("motifs", "Nuclease", 
    function(object,
             primary=FALSE,
             strand=c("+", "-"),
             expand=FALSE,
             as.character=FALSE
){
    strand <- match.arg(strand)
    motifs  <- object@motifs
    weights <- object@weights

    if (length(weights)>1 & primary){
        w <- max(weights, na.rm=TRUE)
        motifs <- motifs[which(weights==w)]
    }

    if (strand=="-"){
        motifs <- reverseComplement(motifs)
    }
    if (expand){
        motifs <- .expandMotifs(motifs)
    }
    if (as.character){
        motifs <- as.character(motifs)
    }
    return(motifs)
})





#' @rdname Nuclease-class
#' @param object \linkS4class{Nuclease} object.
#' @importFrom BiocGenerics width
#' @export
setMethod("motifLength",
          "Nuclease",function(object) {
    seqs <- motifs(object, primary=TRUE)[1]
    names(seqs) <- NULL
    return(BiocGenerics::width(seqs))
})






.expandMotifs <- function(motifs){
    if (is.null(motifs)){
        return(NULL)
    }
    motifs <- as.character(motifs)
    if (length(motifs)==1){
        if (is.na(motifs)){
            return(character(0))    
        }
    }
    nucs <- strsplit(motifs, split="")
   
    nucs <- lapply(nucs, function(x){
        x <- strsplit(Biostrings::IUPAC_CODE_MAP[x], split="")
        x <- expand.grid(x)
        x <- apply(x, 1, paste0, collapse="")
        return(x)
    })
    for (i in seq_along(nucs)){
        names(nucs[[i]]) <- rep(motifs[i], length(nucs[[i]]))
    }
    nucs <- unlist(nucs)
    nucs <- DNAStringSet(nucs)
    return(nucs)
}






#' @rdname Nuclease-class
#' @param middle For staggered cuts, should the middle point between
#'     the cut on the forward strand and the cut on the reverse strand
#'     be considered as the cut site? FALSE by default.
#' @param combine Should only unique values be considered?
#'     TRUE by default. 
#' @export
setMethod("cutSites", "Nuclease", 
    function(object,
             strand=c("+", "-", "both"),
             combine=TRUE,
             middle=FALSE
){
    sites  <- object@cutSites
    motifs <- object@motifs
    strand <- match.arg(strand)

    if (middle){
        sites <- floor((sites[1,]+sites[2,])/2)
    } else if (strand=="+"){
        sites <- sites["fwd",]
    } else if (strand=="-"){
        sites <- sites["rev",]
    } 
    
    if (strand!="both"){
        names(sites) <- motifs
        if (combine){
            choices <- unique(sites)
            if (length(choices)==1){
                sites <- choices
                names(sites) <- NULL
            }
        }
    }
    return(sites)
})

context('Testing Nuclease class')

data(SpCas9, package="crisprBase")
data(AsCas12a, package="crisprBase")
data(enAsCas12a, package="crisprBase")

test_that('Motif representations', {
    expect_error(crisprBase:::.checkRebaseMotif("(9/10)AHT^HCT(9/10)"))
    expect_error(crisprBase:::.checkRebaseMotif("AHT^^HCT"))
    expect_error(crisprBase:::.checkRebaseMotif("(9/10)AHT^HCT"))
    expect_error(crisprBase:::.checkRebaseMotif("AHTU"))
    expect_null(crisprBase:::.checkRebaseMotif("(9/10)AHTHCT"))
    expect_null(crisprBase:::.checkRebaseMotif("AHTHCT(9/10)"))
    expect_null(crisprBase:::.checkRebaseMotif("AHTHCT"))
    expect_null(crisprBase:::.checkRebaseMotif("AHT^HCT"))
})


test_that('Motif sequences', {
    cas9_pams <- c("AGG", "CGG", "GGG", "TGG")
    cas12a_pams <- c("TTTA", "TTTC", "TTTG")
    names(cas9_pams)   <- rep("NGG",4)
    names(cas12a_pams) <- rep("TTTV",3)
    expect_equal(motifs(SpCas9, primary=TRUE, expand=TRUE, as.character=TRUE), cas9_pams)
    expect_equal(motifs(AsCas12a, primary=TRUE, expand=TRUE, as.character=TRUE), cas12a_pams)
})



 
# # Outside
# (3/3) A^AAA[NGG]CGG -3
# (2/2) AA^AA[NGG]CGG -2
# (1/1) AAA^A[NGG]CGG -1
# # Within
# AAAA^[NGG]CGG 0
# AAAA[N^GG]CGG 1
# AAAA[NG^G]CGG 2
# AAAA[NGG]^CGG 3
# # Outside
# (1/1) AAAA[NGG]C^GG 4 (pam_length+1)
# (2/2) AAAA[NGG]CG^G 5 (pam_length+2)
# (3/3) AAAA[NGG]CGG^ 6 (pam_length+3)





test_that('Extracting motif cut sites (upstream)', {

    motifs <- c("(3/3)AGG",
                "(2/2)AGG",
                "(1/1)AGG",
                "(3/1)AGG",
                "(3/2)AGG",
                "(3/5)AGG")
    nucleases <- lapply(motifs,
                        function(motif){
        Nuclease(nucleaseName="",
                 metadata=list(),
                 motifs=motif)
    })
    expectedCutSitesFwdStrand <- c(-3,-2,-1,-3,-3,-3)
    expectedCutSitesRevStrand <- c(-3,-2,-1,-1,-2,-5)

    expect_equal(expectedCutSitesFwdStrand,
                 vapply(nucleases,
                        cutSites,
                        combine=FALSE,
                        middle=FALSE,
                        FUN.VALUE=0))
    expect_equal(expectedCutSitesRevStrand,
                 vapply(nucleases,
                        cutSites,
                        combine=FALSE,
                        strand="-",
                        middle=FALSE,
                        FUN.VALUE=0))
})



test_that('Extracting motif cut sites (downstream)', {

    motifs <- c("AGG(1/1)",
                "AGG(2/2)",
                "AGG(3/3)",
                "AGG(3/2)",
                "AGG(3/1)",
                "AGG(3/5)")
    nucleases <- lapply(motifs,
                        function(motif){
        Nuclease(nucleaseName="",
                 metadata=list(),
                 motifs=motif)
    })
    expectedCutSitesFwdStrand <- c(4,5,6,6,6,6)
    expectedCutSitesRevStrand <- c(4,5,6,5,4,8)

    expect_equal(expectedCutSitesFwdStrand,
                 vapply(nucleases,
                        cutSites,
                        combine=FALSE,
                        middle=FALSE,
                        FUN.VALUE=0))
    expect_equal(expectedCutSitesRevStrand,
                 vapply(nucleases,
                        cutSites,
                        combine=FALSE,
                        middle=FALSE,
                        strand="-",
                        FUN.VALUE=0))
})



test_that('Extracting motif cut sites (within)', {

    motifs <- c("^AGG",
                "A^GG",
                "AA^G",
                "AAG^")
    nucleases <- lapply(motifs,
                        function(motif){
        Nuclease(nucleaseName="",
                 metadata=list(),
                 motifs=motif)
    })
    expectedCutSitesFwdStrand <- c(0,1,2,3)
    expectedCutSitesRevStrand <- c(3,2,1,0)

    expect_equal(expectedCutSitesFwdStrand,
                 vapply(nucleases,
                        cutSites,
                        combine=FALSE,
                        middle=FALSE,
                        FUN.VALUE=0))
    expect_equal(expectedCutSitesRevStrand,
                 vapply(nucleases,
                        cutSites,
                        combine=FALSE,
                        middle=FALSE,
                        strand="-",
                        FUN.VALUE=0))
})

#Script to create Cas9 PAMs:
pams <- c("AGG", "AAG", "AGA", "CGG",
          "CAG", "CGA", "GGG", "GAG", 
          "GGA", "TGG", "TAG", "TGA")
cas9.pams <- data.frame(PAM=pams,
                        Tier="Tier1",
                        stringsAsFactors=FALSE)
# Now let's generate the second tier:
choices <- expand.grid(rep(list(c('A', 'G', 'T', 'C')), 3))
choices <- do.call(paste0, choices)
choices <- setdiff(choices, pams)
temp <- data.frame(PAM=choices,
                   Tier="Tier2",
                   stringsAsFactors=FALSE)
cas9.pams <- rbind(cas9.pams, temp)
save(cas9.pams,
     file="cas9.pams.rda")

#' List of Nuclease objects representing common restriction enzymes
#'
#' List of Nuclease objects representing common restriction enzymes
#'     from REBASE database. 
#' 
#' @format List of Nuclease objects. 
#' 
#' @details List of Nuclease objects representing common restriction enzymes
#'     from REBASE database. 
#' @usage data(restrictionEnzymes, package="crisprBase")
"restrictionEnzymes"


#' SpCas9 CrisprNuclease object
#'
#' CrisprNuclease object for the wildtype Streptococcus pyogenes Cas9 (SpCas9)
#'     nuclease.
#' 
#' @format CrisprNuclease object.
#' 
#' @details The SpCas9 nuclease recognizes NGG PAM sequences. Spacer
#'     sequences must be located upstream of PAM sequences.
#' @usage data(SpCas9, package="crisprBase")
"SpCas9"




#' SaCas9 CrisprNuclease object
#'
#' CrisprNuclease object for the wildtype Staphylococcus aureus Cas9 (SaCas9)
#'     nuclease.
#' 
#' @format CrisprNuclease object.
#' 
#' @details The AsCas9 nuclease recognizes NNGRRT PAM sequences. Spacer
#'     sequences must be located upstream of PAM sequences. Editing weights 
#'     were obtained from \url{doi:10.1038/nature14299}.
#' 
#' @usage data(SaCas9, package="crisprBase")
"SaCas9"


#' SpG CrisprNuclease object
#'
#' CrisprNuclease object for the engineered Streptococcus pyogenes Cas9
#'     SpG nuclease.
#' 
#' @format CrisprNuclease object.
#' 
#' @details The SpG nuclease recognizes NGN PAM sequences. Spacer
#'     sequences must be located upstream of PAM sequences. Editing weights 
#'     were obtained from \url{doi:10.1038/s41467-022-28884-7}.
#' @usage data(SpG, package="crisprBase")
"SpG"


#' AsCas12a CrisprNuclease object
#'
#' CrisprNuclease object for the Wildtype Acidaminococcus Cas12a (AsCas12a)
#'     nuclease.
#' 
#' @format CrisprNuclease object.
#' @details The AsCas12a nuclease recognizes TTTV PAM sequences. Spacer
#'     sequences must be located downstream of PAM sequences.
#' @usage data(AsCas12a, package="crisprBase")
"AsCas12a"


 

#' enAsCas12a CrisprNuclease object
#'
#' CrisprNuclease object for the Enhanced Acidaminococcus Cas12a (AsCas12a)
#'     nuclease.
#' 
#' @format CrisprNuclease object.
#' @details The enAsCas12a nuclease recognizes an extended set of PAM sequences
#'     beyong the canonical TTTV sequence for AsCas12a. Spacer sequences must 
#'     be located downstream of PAM sequences.
#' @usage data(enAsCas12a, package="crisprBase")
"enAsCas12a"





#' MAD7 CrisprNuclease object
#'
#' CrisprNuclease object for the MAD7 nuclease (Cas12a-like nuclease)
#' 
#' @format CrisprNuclease object.
#' @details The MAD7 nuclease recognizes YTTV PAM sequences. Spacer
#'     sequences must be located downstream of PAM sequences.
#' @usage data(MAD7, package="crisprBase")
"MAD7"





#' CasRx CrisprNuclease object
#'
#' CrisprNuclease object for the Cas13d-NLS from Ruminococcus
#'     flavefaciens strain XPD3002 nuclease (RNase). 
#' 
#' @format CrisprNuclease object.
#' @details The CasRx nuclease was derived from Cas13d Ruminococcus
#'     flavefaciens string XPD3002. See \url{10.1016/j.cell.2018.02.033}.
#' @usage data(CasRx, package="crisprBase")
"CasRx"


#' Csm CrisprNuclease object
#'
#' CrisprNuclease object for the RNA-targeting
#'     Csm complex from Streptococcus thermophilus 
#' 
#' @format CrisprNuclease object.
#' @details The specific Csm complex is an RNA-targeting nuclease derived from 
#'     Streptococcus thermophilus. There is no preferred PAM sequences,
#'     and the default (optimal) spacer length is 32nt. 
#'     See \url{https://doi.org/10.1038/s41587-022-01649-9}.
#' @usage data(Csm, package="crisprBase")
"Csm"




#' BE4max BaseEditor object
#'
#' BaseEditor for the cytosine base editor CRISPR/Cas9 system
#'     BE4max. Editing weights were obtained from
#'     https://doi.org/10.1016/j.cell.2020.05.037
#' 
#' @format BaseEditor object.
#' @details  BaseEditor for the cytosine base editor
#'     CRISPR/Cas9 system BE4max. Editing weights were obtained from
#'     \url{https://doi.org/10.1016/j.cell.2020.05.037}.
#' @usage data(BE4max, package="crisprBase")
"BE4max"

#' @importFrom methods validObject
.nickaseToNuclease <- function(x){
    out <- new("Nuclease")
    targetType(out) <- "DNA"
    nucleaseName(out) <- paste0(nickaseName(x),
                                " converted to nuclease.")
    metadata(out) <- metadata(x)
    out@motifs <- motifs(x)
    weights(out) <- weights(x)
    cuts <- rbind(cutSites(x),cutSites(x))
    rownames(cuts) <- c("fwd", 'rev')
    colnames(cuts) <- motifs(x, as.character=TRUE)
    out@cutSites <- cuts
    stopifnot(validObject(out))
    return(out)
}


#' @importFrom methods validObject
.crisprNickaseToCrisprNuclease <- function(x){
    out <- new("CrisprNuclease")
    targetType(out) <- "DNA"
    nucleaseName(out) <- paste0(nickaseName(x),
                                " converted to a CrisprNuclease.")
    metadata(out) <- metadata(x)
    out@motifs <- motifs(x)
    weights(out) <- weights(x)
    cuts <- rbind(cutSites(x),cutSites(x))
    rownames(cuts) <- c("fwd", 'rev')
    colnames(cuts) <- motifs(x, as.character=TRUE)
    out@cutSites <- cuts

    pamSide(out) <- pamSide(x)
    spacerGap(out) <- spacerGap(x)
    spacerLength(out) <- spacerLength(x)
    return(out)
}

getBowtiePaths <- function(){
	bowtieIndicesPath    <- file.path(.getCrisprIndicesPath(), "bowtie")	
	bowtieIndexHuman     <- file.path(bowtieIndicesPath, "GRCh38/GRCh38")
	bowtieIndexHumanMaj  <- file.path(bowtieIndicesPath, "GRCh38_major/GRCh38_major")
	bowtieIndexHumanMin  <- file.path(bowtieIndicesPath, "GRCh38_minor/GRCh38_minor")
	bowtieIndexMouse     <- file.path(bowtieIndicesPath, "GRCm38/GRCm38")
    bowtieIndexRat       <- file.path(bowtieIndicesPath, "Rnor6/Rnor6")
    bowtieIndexFruitfly  <- file.path(bowtieIndicesPath, "BDGP6/BDGP6")
	bowtieIndexHumanTx   <- file.path(bowtieIndicesPath, "gencode.v34.human/gencode.v34.human")
	bowtieIndexMouseTx   <- file.path(bowtieIndicesPath, "gencode.vM25.mouse/gencode.vM25.mouse")
	bowtieIndexHumanExon <- file.path(bowtieIndicesPath, "igis4.human/exons.igis4.human")
	bowtieIndexMouseExon <- file.path(bowtieIndicesPath, "igis4.mouse/exons.igis4.mouse")
	list(bowtieIndexHuman=bowtieIndexHuman, 
	   bowtieIndexHumanMaj=bowtieIndexHumanMaj,
	   bowtieIndexHumanMin=bowtieIndexHumanMin,
	   bowtieIndexMouse=bowtieIndexMouse,
       bowtieIndexRat=bowtieIndexRat,
       bowtieIndexFruitfly=bowtieIndexFruitfly,
	   bowtieIndexHumanTx=bowtieIndexHumanTx,
	   bowtieIndexMouseTx=bowtieIndexMouseTx,
	   bowtieIndexHumanExon=bowtieIndexHumanExon,
	   bowtieIndexMouseExon=bowtieIndexMouseExon
	)
}

#' An S4 class to represent a nickase
#' 
#' @slot nickaseName Name of the nickase
#' @slot motifs DNAStringSet of recognition sequence motifs
#'           written from 5' to 3'.
#' @slot nickingStrand String specifying with strand with respect
#'     to the motif sequence (5' to 3') is nicked.
#'     Must be either "original" (default) or "opposite".
#' @slot cutSites Vector specifying the cleavage coordinates relative
#'     to the first nucleotide of the motif sequence.
#'     Each column corresponds to a motif specified in the \code{motifs} slot. 
#' @slot weights Optional numeric vector specifying relative weights
#'           for the motifs corresponding to cleavage probabilities. 
#' @slot metadata Optional string providing a description of the nickase.
#' 
#' @seealso See the \linkS4class{CrisprNickase} for CRISPR-specific nickases.
#' 
#' @section Constructors:
#'     Use the constructor \code{link{Nickase}} to create a Nickase object.
#' 
#' @section Accessors:
#' \describe{
#'     \item{\code{nickaseName}:}{To get the name of the nickase.} 
#'     \item{\code{nickingStrand}:}{To get the nicking strand.} 
#'     \item{\code{metadata}:}{To get the metadata list of the nickase} 
#'     \item{\code{motifs}:}{To get the recognition mofif
#'          nucleotide sequences.}
#'     \item{\code{weights}:}{To get nickase weights.} 
#'     \item{\code{cutSites}:}{To get nickase cut sites.} 
#' }
#' 
#' @examples
#' Nb.BsmI <- Nickase("Nb.BsmI",
#'                    motifs=c("GAATG^C"),
#'                    nickingStrand="opposite",
#'                    metadata=list(description="Nb.BsmI nicking enzyme."))
#' 
#' @return A Nickase object
#' @export
#' @importFrom Biostrings DNAStringSet
#' @importClassesFrom S4Vectors Annotated
setClass("Nickase",
    contains = "Annotated",
    slots = c(
        nickaseName = "character", 
        nickingStrand = "character", 
        motifs = "DNAStringSet",
        cutSites = "vector",
        weights = "numeric"),
    prototype = list(
        nickaseName = NA_character_,
        nickingStrand = NA_character_,
        motifs = NULL,
        cutSites = NULL,
        weights = NA_real_)
)




#' @describeIn Nickase Create a \linkS4class{Nickase} object
#' @param nickaseName Name of the nickase.
#' @param nickingStrand String specifying with strand with respect
#'     to the motif sequence (5' to 3') is nicked.
#'     Must be either "original" (default) or "opposite".
#' @param motifs Character vector of recognition sequence motifs
#'           written from 5' to 3' written in Rebase convention.
#'           If the point of cleavage has been determined, the
#'           precise site is marked with ^. Only letters in the
#'           IUPAC code are accepted. For nickases that cleave
#'           away from their recognition sequence, the cleavage
#'           sites are indicated in parentheses. See details for
#'           more information. 
#' @param cutSites Vector specifying the cleavage coordinates relative
#'     to the first nucleotide of the motif sequence. Each column corresponds
#'     to a motif specified in the \code{motifs} slot. 
#' @param weights Optional numeric vector specifying relative weights
#'           for the recognition motifs to specify cleavage probabilities. 
#' @param metadata Optional list providing global metadata information.
#' @export
#' @importFrom S4Vectors metadata metadata<-
Nickase <- function(nickaseName,
                    nickingStrand=c("original", "opposite"),
                    motifs = NULL,
                    cutSites = NULL,
                    weights = rep(1, length(motifs)),
                    metadata = list()
){
    nickingStrand <- match.arg(nickingStrand)
    nickaseName <- as.character(nickaseName)
    weights <- as.numeric(weights)

    if (is(motifs, "DNAStringSet")){    
        if (is.null(cutSites)){
            stop("When 'motifs' is provided as a DNAStringset, ",
                 "'cutSites' must be provided. ")
        }
        sequences <- motifs
    } else if (is.character(motifs) & !is.null(cutSites)){
        .checkDNAAlphabet(motifs)
        sequences <- DNAStringSet(motifs)
    } else if (is.character(motifs) & is.null(cutSites)){
        .checkRebaseMotifs(motifs, type="nickase")
        sequences <- .extractSequencesFromRebaseMotifs(motifs)
        rebaseStrand <- ifelse(nickingStrand=="original", "fwd", "rev")
        cutSites  <- .extractCutSitesFromRebaseMotifs(motifs,
                                                      type="nickase",
                                                      strand=rebaseStrand)
    } else {
        stop("'motifs' must be either a character vector or a ",
             "DNAStringSet.")
    }
    
    if (!is.list(metadata)){
        stop("metadata must be a list.")
    }
    out <- new("Nickase",
               nickaseName=nickaseName,
               nickingStrand=nickingStrand,
               motifs=sequences,
               cutSites=cutSites,
               weights=weights)
    metadata(out) <- metadata
    return(out)
}





setValidity("Nickase", function(object){
    out <- TRUE
    if (length(nickaseName(object))!=1){
       out <- "Slot nickaseName must be a character vector of length 1."
    } 
  
    if (length(weights(object))>1){
        if (length(weights(object)) != length(motifs(object))){
            out <- "Slots weights and motifs must be of the same length."
        } 
    } 

    sites <- cutSites(object, combine=FALSE)
    if (length(sites) != length(motifs(object))){
        out <- "Length in cutSites must be equal to the length of motifs."
    }

    return(out)
})




#' @rdname Nickase-class
#' @param object \linkS4class{Nickase} object.
setMethod("show", "Nickase", function(object){
    len <- length(metadata(object))
    cat(paste0("Class: ", is(object)[[1]]), "\n",
      "  Name: ", nickaseName(object), "\n",
      "  Nicking strand: ", nickingStrand(object), "\n",
      "  Metadata: list of length ", len, "\n",
      "  Motifs: ", .printVectorNicely(motifs(object)), "\n",
      "  Weights: ", .printVectorNicely(weights(object)), "\n",
      sep = "")
})



#' @rdname Nickase-class
#' @export
setMethod("nickaseName", "Nickase", 
    function(object){
    return(object@nickaseName)
})

#' @rdname Nickase-class
#' @param value New value to pass to the setter functions.
#' @export
setMethod("nickaseName<-", "Nickase", 
    function(object, value){
    object@nickaseName <- as.character(value)
    return(object)
})


#' @rdname Nickase-class
#' @export
setMethod("nickingStrand", "Nickase", 
    function(object){
    return(object@nickingStrand)
})

#' @rdname Nickase-class
#' @param value New value to pass to the setter functions.
#' @export
setMethod("nickingStrand<-", "Nickase", 
    function(object, value){
    if (!value %in% c("original", "opposite")){
        stop("value must be either 'original' or 'opposite'.")
    }
    object@nickingStrand <- as.character(value)
    return(object)
})



#' @rdname Nickase-class
#' @export
setMethod("weights", "Nickase", 
    function(object,
             expand=FALSE
){
    ws <- object@weights
    names(ws) <- motifs(object)
    if (expand){
        motifs <- .expandMotifs(names(ws))
        ws <- ws[names(motifs)]
        names(ws) <- as.character(motifs)
    }
    return(ws)
})


#' @rdname Nickase-class
#' @export
setMethod("weights<-", "Nickase", 
    function(object, value){
    seqs <- object@motifs
    if (is.null(value)){
        object@motifs <- NA
    } else if (length(value)==1){
        object@motifs <- value
    } else if (length(value)==length(seqs)){
        object@motifs <- value
    } 
    object@weights <- value
    return(object)
})



#' @rdname Nickase-class
#' @export
setMethod("isCutting", "Nickase", 
    function(object){
    cuts <- cutSites(object)
    !all(is.na(c(cuts)))
})



#' @rdname Nickase-class
#' @param primary Should only the motif with the highest weight be returned?
#'     FALSE by default. Only relevant if weights are stored in the 
#'     \linkS4class{Nickase} object.
#' @param expand Should sequences be expanded to only contain ATCG nucleotides?
#'     FALSE by default.
#' @param strand Strand to allow reverse complementation of the motif.
#'     "+" by default. 
#' @param as.character Should the motif sequences be returned as a 
#'     character vector? FALSE by default.
#' @importFrom Biostrings reverseComplement
#' @export
setMethod("motifs", "Nickase", 
    function(object,
             primary=FALSE,
             strand=c("+", "-"),
             expand=FALSE,
             as.character=FALSE
){
    strand <- match.arg(strand)
    motifs  <- object@motifs
    weights <- object@weights

    if (length(weights)>1 & primary){
        w <- max(weights, na.rm=TRUE)
        motifs <- motifs[which(weights==w)]
    }

    if (strand=="-"){
        motifs <- reverseComplement(motifs)
    }
    if (expand){
        motifs <- .expandMotifs(motifs)
    }
    if (as.character){
        motifs <- as.character(motifs)
    }
    return(motifs)
})





#' @rdname Nickase-class
#' @param object \linkS4class{Nickase} object.
#' @importFrom BiocGenerics width
#' @export
setMethod("motifLength",
          "Nickase",function(object) {
    seqs <- motifs(object, primary=TRUE)[1]
    names(seqs) <- NULL
    return(BiocGenerics::width(seqs))
})



#' @rdname Nickase-class
#' @param combine Should only unique values be considered?
#'     TRUE by default. 
#' @export
setMethod("cutSites",
          "Nickase", function(object, combine=TRUE)
{
    sites  <- object@cutSites
    motifs <- object@motifs
    names(sites) <- motifs
    if (combine){
        choices <- unique(sites)
        if (length(choices)==1){
            sites <- choices
            names(sites) <- NULL
        }
    }
    return(sites)
})

#### Generics for Nuclease object

#' @description Return motif string representations of recognition sites.
#' @rdname Nuclease-class
#' @param object Object of class \linkS4class{Nuclease} or
#'     \linkS4class{CrisprNuclease}
#' @param ... Additional arguments for class-specific methods
#' 
#' @export
setGeneric("motifs", function(object, ...) standardGeneric("motifs"))


#' @description Return length of the recognition sites sequences.
#' @rdname Nuclease-class
#' @export
setGeneric("motifLength",
           function(object, ...) standardGeneric("motifLength"))


#' @rdname Nuclease-class
#' @export
setGeneric("nucleaseName", function(object) standardGeneric("nucleaseName"))



#' @rdname Nuclease-class
#' @export
setGeneric("targetType", function(object) standardGeneric("targetType"))





#' @rdname Nuclease-class
#' @export
setGeneric("weights", function(object) standardGeneric("weights"))



#' @rdname Nuclease-class
#' @export
setGeneric("nucleaseName<-", function(object, value) standardGeneric("nucleaseName<-"))


#' @rdname Nuclease-class
#' @export
setGeneric("targetType<-", function(object, value) standardGeneric("targetType<-"))



#' @rdname Nuclease-class
#' @export
setGeneric("weights<-", function(object, value) standardGeneric("weights<-"))


#' @rdname Nuclease-class
#' @export
setGeneric("cutSites", function(object, ...) standardGeneric("cutSites"))


#' @rdname Nuclease-class
#' @export
setGeneric("isCutting", function(object) standardGeneric("isCutting"))


#' @rdname Nuclease-class
#' @export
setGeneric("isRnase", function(object) standardGeneric("isRnase"))


#' @rdname Nuclease-class
#' @export
setGeneric("isDnase", function(object) standardGeneric("isDnase"))







#### Generics for CrisprNuclease
#' @rdname CrisprNuclease-class
#' @export
setGeneric("spacerLength", function(object, ...) standardGeneric("spacerLength"))

#' @rdname CrisprNuclease-class
#' @export
setGeneric("targetLength",
           function(object, ...) standardGeneric("targetLength"))

#' @rdname CrisprNuclease-class
#' @export
setGeneric("pamLength", function(object, ...) standardGeneric("pamLength"))




#' @rdname CrisprNuclease-class
#' @export
setGeneric("spacerGap", function(object) standardGeneric("spacerGap"))


#' @rdname CrisprNuclease-class
#' @export
setGeneric("hasSpacerGap", function(object) standardGeneric("hasSpacerGap"))



#' @rdname CrisprNuclease-class
#' @export
setGeneric("spacerGap<-",
           function(object, value) standardGeneric("spacerGap<-"))


#' @rdname CrisprNuclease-class
#' @export
setGeneric("spacerLength<-",
           function(object, value) standardGeneric("spacerLength<-"))


#' @rdname CrisprNuclease-class
#' @export
setGeneric("pamSide", function(object, ...) standardGeneric("pamSide"))


#' @rdname CrisprNuclease-class
#' @export
setGeneric("pamSide<-", function(object, value) standardGeneric("pamSide<-"))



#' @rdname CrisprNuclease-class
#' @param ... Additional arguments for class-specific methods
#' @export
setGeneric("pams", function(object, ...) standardGeneric("pams"))

#' @rdname CrisprNuclease-class
#' @export
setGeneric("pamIndices", function(object, ...) standardGeneric("pamIndices"))

#' @rdname CrisprNuclease-class
#' @export
setGeneric("spacerIndices",
           function(object, ...) standardGeneric("spacerIndices"))

#' @rdname CrisprNuclease-class
#' @export
setGeneric("prototypeSequence",
           function(object, ...) standardGeneric("prototypeSequence"))



#' @rdname BaseEditor-class
#' @export
setGeneric("baseEditorName", function(object) standardGeneric("baseEditorName"))


#' @rdname BaseEditor-class
#' @export
setGeneric("baseEditorName<-", function(object, value) standardGeneric("baseEditorName<-"))


#' @rdname BaseEditor-class
#' @param ... Additional arguments for class-specific methods
#' @export
setGeneric("editingWeights", function(object, ...) standardGeneric("editingWeights"))


# #' @rdname BaseEditor-class
# #' @export
# setGeneric("editingWeights<-", function(object, value, ...) standardGeneric("editingWeights<-"))



#' @rdname BaseEditor-class
#' @export
setGeneric("editingStrand", function(object, ...) standardGeneric("editingStrand"))


#' @rdname BaseEditor-class
#' @export
setGeneric("editingStrand<-", function(object, value) standardGeneric("editingStrand<-"))



### For Nickase object #####



#' @rdname Nickase-class
#' @export
setGeneric("nickaseName", function(object) standardGeneric("nickaseName"))


#' @rdname Nickase-class
#' @export
setGeneric("nickaseName<-", function(object, value) standardGeneric("nickaseName<-"))


#' @rdname Nickase-class
#' @export
setGeneric("nickingStrand", function(object) standardGeneric("nickingStrand"))


#' @rdname Nickase-class
#' @export
setGeneric("nickingStrand<-", function(object, value) standardGeneric("nickingStrand<-"))

# Script to generate Cas12a PAM sequences from PMID:30742127
library(readxl)
library(tidyverse)
data <- read_excel("41587_2018_11_MOESM4_ESM.xlsx") %>% as.data.frame
data <- data[,c(1,2,8)]
colnames(data) <- c("PAM","Score", "Tier")
data <- data[-1,]
data <- data[1:256,]
data$Score <- as.numeric(data$Score)
data$Score <- data$Score/max(data$Score)
data$Tier[data$Tier=="-"] <- "Tier3"
data$Tier <- gsub("tier ", "Tier",data$Tier)
data <- data[order(data$Tier,-data$Score, data$PAM),]
rownames(data) <- NULL
cas12a.pams <- data
#save(cas12a.pams, file="../../../data/cas12a.pams.rda")
save(cas12a.pams,
     file="cas12a.pams.rda")

#' @importFrom stringr str_match
.checkRebaseMotif <- function(rebaseMotif,
                              type=c("nuclease", "nickase")
){
    type <- match.arg(type)
    choices_nickase <- c(names(Biostrings::IUPAC_CODE_MAP),
                         "^", "(", ")",
                         0:9,
                         "-")
    choices_nuclease <- c(choices_nickase, "/")
    if (type=="nuclease"){
        choices <- choices_nuclease
    } else {
        choices <- choices_nickase
    }

    symbols <- strsplit(rebaseMotif, split="")[[1]]
    if(!all(symbols %in% choices)){
        offenders <- unique(setdiff(symbols, choices))
        offenders <- paste0(offenders, collapse=",")
        stop("The following characters are not allowed: ",
             offenders)
    }

    #Checking if Rebase motif follows expected pattern:
    if (type=="nuclease"){
        pattern="(\\([0-9]+/[0-9]+\\))?([A-Z]*\\^?[A-Z]*)(\\([0-9]+/[0-9]+\\))?"
    } else {
        pattern="(\\([0-9]+\\))?([A-Z]*\\^?[A-Z]*)(\\([0-9]+\\))?"
    }
    
    if (str_match(rebaseMotif, pattern)[1]!=rebaseMotif){
        stop("Motif does not follow the notation needed for ",
             "a recognition site. See details.")
    }

    if (.isCutUpstream(rebaseMotif, type=type) & 
        .isCutDownstream(rebaseMotif, type=type)){
        stop("For nucleases cleaving outside of the recognition site, 
             only one set of parentheses should be provided. 
             Example: (9/10)ACCTG or ACCTG(9/10) are valid, 
             but not (9/10)ACCTG(9/10).")
    }
    if ((.isCutUpstream(rebaseMotif , type=type)|
         .isCutDownstream(rebaseMotif,  type=type)) &
         .isCutWithin(rebaseMotif)){
        stop("Concurrent cleavage outside of the recognition site and
             within the recognition sequence are not supported at the moment.
             Example: (9/10)ACCTG is valid, but (9/10)AC^CTG is invalid.")
    }
}

.checkRebaseMotifs <- function(rebaseMotifs,
                               type=c("nuclease", "nickase")
){
    type <- match.arg(type)
    x=lapply(rebaseMotifs, .checkRebaseMotif, type=type)
}


.isCutUpstream <- function(rebaseMotif,
                           type=c("nuclease", "nickase")
){  
    type <- match.arg(type)
    if (type=="nuclease"){
        out <- grepl("^\\([0-9]+/[0-9]+\\)", rebaseMotif)
    } else {
        out <- grepl("^\\([0-9]+\\)", rebaseMotif)
    }
    return(out)
}

.isCutDownstream <- function(rebaseMotif,
                             type=c("nuclease", "nickase")
){
    type <- match.arg(type)
    if (type=="nuclease"){
        out <- grepl("\\([0-9]+/[0-9]+\\)$", rebaseMotif)
    } else {
        out <- grepl("\\([0-9]+\\)$", rebaseMotif)
    }
    return(out)
}

.isCutWithin <- function(rebaseMotif){
    out <- grepl("\\^", rebaseMotif)
    return(out)
}

.isCutNotSpecified <- function(rebaseMotif,
                               type=c("nuclease", "nickase")
){
    type <- match.arg(type)
    !.isCutUpstream(rebaseMotif, type=type) & 
    !.isCutDownstream(rebaseMotif, type=type) &
    !.isCutWithin(rebaseMotif) 
}



#' @importFrom stringr str_match
.extractSequencesFromRebaseMotifs <- function(rebaseMotifs){
    #pattern <- "([A-Z]+\\^?[A-Z]+)"
    pattern <- "([A-Z]+)"
    seqs <- vapply(rebaseMotifs, function(xx){
        xx <- gsub("\\^", "", xx)
        return(str_match(xx, pattern)[1])
    }, FUN.VALUE="a")
    names(seqs) <- NULL
    seqs <- DNAStringSet(seqs)
    return(seqs)
}


.extractCutSitesFromRebaseMotifs <- function(rebaseMotifs,
                                             type=c("nuclease", "nickase"),
                                             strand=c("both", "fwd", "rev")
){
    strand <- match.arg(strand)
    cutSites <- lapply(rebaseMotifs, .getCutSites, type=type)
    cutSites <- do.call("cbind", cutSites)
    cutSites <- as.matrix(cutSites)
    rownames(cutSites) <- c("fwd", "rev")
    motifs <- .extractSequencesFromRebaseMotifs(rebaseMotifs)
    colnames(cutSites) <- as.character(motifs)
    if (strand=="fwd"){
        cutSites <- cutSites["fwd",,drop=FALSE]
    } else if (strand=="rev"){
        cutSites <- cutSites["rev",,drop=FALSE]
    }
    return(cutSites)
}




.getCutSites <- function(rebaseMotif,
                         type=c("nuclease", "nickase")
){
    type <- match.arg(type)
    if (.isCutWithin(rebaseMotif)){
        cutSites <- .getCutSites_within(rebaseMotif,
                                        type=type)
    } else if (.isCutUpstream(rebaseMotif,type=type)){
        cutSites <- .getCutSites_upstream(rebaseMotif,
                                          type=type)
    } else if (.isCutDownstream(rebaseMotif, type=type)){
        cutSites <- .getCutSites_downstream(rebaseMotif,
                                            type=type)
    } else if (.isCutNotSpecified(rebaseMotif, type=type)){
        cutSites <- .getCutSites_unspecified(rebaseMotif)
    }
    return(cutSites)
}


.getCutSites_unspecified <- function(rebaseMotif){
    out <- c(fwd=NA, rev=NA)
    return(out)
}

.getCutSites_upstream <- function(rebaseMotif,
                                  type=c("nuclease", "nickase")
){
    type <- match.arg(type)
    stopifnot(.isCutUpstream(rebaseMotif, type=type))
    if (type=="nuclease"){
        pattern <- "^\\([0-9]+/[0-9]+\\)"
    } else {
        pattern <- "^\\([0-9]\\)"
    }
    pos <- regexpr(pattern, rebaseMotif)
    cut_info <- substr(rebaseMotif, pos, pos+attr(pos, "match.length")-1)
    cut_info <- gsub("\\(|\\)", "", cut_info)
    if (type=="nuclease"){
        cut_pos <- as.integer(strsplit(cut_info, split="/")[[1]][[1]])
        cut_neg <- as.integer(strsplit(cut_info, split="/")[[1]][[2]])
    } else {
        cut_pos <- cut_neg <- as.integer(cut_info)
    }
    out <- c(fwd=-cut_pos, rev=-cut_neg)
    return(out)
}

.getCutSites_downstream <- function(rebaseMotif,
                                    type=c("nuclease", "nickase")
){
    type <- match.arg(type)
    stopifnot(.isCutDownstream(rebaseMotif, type=type))
    seq <- .extractSequencesFromRebaseMotifs(rebaseMotif)
    motifLength <- BiocGenerics::width(seq)
    if (type=="nuclease"){
        pattern <- "\\([0-9]+/[0-9]+\\)$"
    } else {
        pattern <- "\\([0-9]+\\)$"
    }
    pos <- regexpr(pattern, rebaseMotif)
    cut_info <- substr(rebaseMotif,
                       pos,
                       pos+attr(pos, "match.length")-1)
    cut_info <- gsub("\\(|\\)", "", cut_info)
    if (type=="nuclease"){
        cut_pos <- as.integer(strsplit(cut_info, split="/")[[1]][[1]])
        cut_neg <- as.integer(strsplit(cut_info, split="/")[[1]][[2]])
    } else {
        cut_pos <- cut_neg <- as.integer(cut_info)
    }
    out <- c(fwd=cut_pos + motifLength,
             rev=cut_neg + motifLength)
    return(out)
}


.getCutSites_within <- function(rebaseMotif,
                                type=c("nuclease", "nickase")
){
    type <- match.arg(type)
    stopifnot(.isCutWithin(rebaseMotif))
    seq <- .extractSequencesFromRebaseMotifs(rebaseMotif)
    motifLength <- BiocGenerics::width(seq)
    chars <- strsplit(rebaseMotif, split="")[[1]]
    pos <- which(chars=="^")
    if (type=="nuclease"){
        cut_pos <- pos-1
        cut_neg <- motifLength - cut_pos
    } else {
        cut_pos <- cut_neg <- pos-1
    }
    out <- c(fwd=cut_pos, rev=cut_neg)
    return(out)
}

#' An S4 class to represent a base editor
#' 
#' @slot baseEditorName Name of the base editor. 
#' @slot editingWeights Matrix of editing weights.
#' @slot editingStrand String indicating which strand with
#'     respect to the target protospacer sequence will be 
#'     edited. Must be either "original" or "opposite".
#'     "original" by default.
#' 
#' @section Constructors:
#'     Use the constructor \code{link{BaseEditor}} to create
#'     a BaseEditor object.
#' 
#' @section Accessors:
#' \describe{
#'     \item{\code{baseEditorName}:}{To get the name of the base editor.}
#'     \item{\code{editingWeights}:}{To return the matrix of editing weights.}
#'     \item{\code{editingStrand}:}{To return the editing strand.}
#' }
#' 
#' @section Setters:
#' \describe{
#'     \item{\code{baseEditorName<-}:}{To change the name of the base editor.}
#'     \item{\code{editingWeights<-}:}{To change the matrix of editing weights.}
#'     \item{\code{editingStrand<-}:}{To change the editing strand.}
#' }
#' 
#' @examples
#' # Creating an object for BE4max (C to T editor)
#' # based on experimental weights
#' 
#' ws <- c(0.7, 0.7, 0.8, 1.8, 1, 2, 1.4, 1.2, 2.3, 1.3, 2.4, 2.2, 3.4, 
#'       2.2, 2.1, 3.5, 5.8, 16.2, 31.8, 63.2, 90.3, 100, 87, 62, 31.4, 
#'       16.3, 10, 5.6, 3.3, 1.9, 1.8, 2.4, 1.7, 0.5, 0.2, 0.1)
#' ws <- matrix(ws, nrow=1, ncol=length(ws))
#' rownames(ws) <- "C2T"
#' colnames(ws) <- -36:-1
#' data(SpCas9, package="crisprBase")
#' BE4max <- BaseEditor(SpCas9,
#'                      baseEditorName="BE4max",
#'                      editingStrand="original",
#'                      editingWeights=ws)
#' metadata(BE4max)$description_base_editor <- "BE4max cytosine base editor."
#' 
#' @return A BaseEditor object
#' 
#' @export
setClass("BaseEditor",
    contains = "CrisprNuclease",
    slots = c(
        baseEditorName = "character", 
        editingWeights = "matrix",
        editingStrand = "character"),
    prototype = list(
        baseEditorName = NA_character_,
        editingWeights = NULL,
        editingStrand = "original"
    )
)



#' @describeIn BaseEditor Create a \linkS4class{BaseEditor} object
#' @param CrisprNuclease A \linkS4class{CrisprNuclease} object.
#' @param baseEditorName String specifying base editor name.
#' @param editingStrand String indicating which strand with
#'     respect to the target protospacer sequence will be 
#'     edited. Must be either "original" or "opposite".
#'     "original" by default.
#' @param editingWeights Numeric matrix of editing weights.
#'     Column names must be indicating relative position to the PAM site.
#'     Row names must be of the form "X2Y" where "X" represents the origin
#'     base, and "Y" represents the subtituted base. For instance, "C2T"
#'     indicates the row corresponding to C to T editing. 
#' @param scale Logical indicating if weights should be scaled to have a maximum of 1.
#'     TRUE by default. Should be set to FALSE if editing weights are 
#'     already representing editing probabilities. 
#' @export
BaseEditor <- function(CrisprNuclease,
                       baseEditorName = NA_character_,
                       editingStrand = c("original", "opposite"),
                       editingWeights = NULL,
                       scale=TRUE
){
    editingStrand <- match.arg(editingStrand)
    new("BaseEditor",
        CrisprNuclease,
        baseEditorName = as.character(baseEditorName),
        editingStrand = editingStrand,
        editingWeights = .buildEditingWeightsMatrix(editingWeights, scale=scale)
    )
}





#' @rdname BaseEditor-class
#' @export
setMethod("show", "BaseEditor", function(object) {
    len <- length(metadata(object))
    dnase <- isDnase(object)
    if (dnase){
        pams.line <- ("      PAMs: ")
        pams.line.distance <- "        Distance from PAM: "
        pam.side.line <- "      PAM side: "
    } else {
        pams.line <- ("      PFS: ")
        pams.line.distance <- "        Distance from PFS: "
        pam.side.line <- "      PFS side: "
    }
    cat(paste0("Class: ", is(object)[[1]]), "\n",
        "  CRISPR Nuclease name: ", nucleaseName(object), "\n",
        "      Target type: ", targetType(object), "\n",
        "      Metadata: list of length ", len, "\n",
        pams.line, .printVectorNicely(motifs(object)), "\n",
        "      Weights: ", .printVectorNicely(weights(object)), "\n",
        "      Spacer length: ",  spacerLength(object), "\n",
        pam.side.line,  pamSide(object), "\n",
        pams.line.distance, spacerGap(object), "\n",
        "      Prototype protospacers: ",
        .printVectorNicely(prototypeSequence(object, primary=FALSE)),
        "\n",
        "  Base editor name: ", baseEditorName(object), "\n",
        "      Editing strand: ", editingStrand(object), "\n",
        "      Maximum editing weight: ", .getMaxEditingWeight(object), "\n",
        sep = "")
})



.getMaxEditingWeight <- function(object){
    x <- editingWeights(object)
    ind <- which.max(x)
    ind <- arrayInd(ind, .dim=c(nrow(x), ncol(x)))
    sub <- rownames(x)[ind[1]]
    pos <- colnames(x)[ind[2]]
    paste0(sub, " at position ", pos, "")
}



#' @rdname BaseEditor-class
#' @param object \linkS4class{BaseEditor} object.
#' @export
setMethod("baseEditorName",
          "BaseEditor",function(object){
    object@baseEditorName
})


#' @rdname BaseEditor-class
#' @param value Value to replaced with.
#' @export
setMethod("baseEditorName<-",
          "BaseEditor",function(object, value){
    value <- as.character(value)
    object@baseEditorName <- value
    return(object)
})


#' @rdname BaseEditor-class
#' @param substitutions Character vector indicating which substitutions
#'     should be returned. 
#' @export
setMethod("editingWeights",
          "BaseEditor",function(object,
                                substitutions=NULL
){
    ws <- object@editingWeights
    if (is.null(substitutions)){
        substitutions <- rownames(ws)
    }
    diff <- setdiff(substitutions, rownames(ws))
    if (length(diff)!=0){
        stop("Some of the substitutions are not found.")
    }
    out <- ws[substitutions,,drop=FALSE]
    return(out)
})


# #' @rdname BaseEditor-class
# #' @export
# setMethod("editingWeights<-",
#           "BaseEditor",function(object, value, ...){
#     value <- .buildEditingWeightsMatrix(value, ...)
#     object@editingWeights <- value
#     return(object)
# })


#' @rdname BaseEditor-class
#' @export
setEditingWeights <- function(object, value, scale=TRUE) {
    value <- .buildEditingWeightsMatrix(value, scale=scale)
    object@editingWeights <- value
    return(object)
}



#' @rdname BaseEditor-class
#' @export
setMethod("editingStrand",
          "BaseEditor",function(object){
    object@editingStrand
})


#' @rdname BaseEditor-class
#' @export
setMethod("editingStrand<-",
          "BaseEditor",function(object, value){
    value <- as.character(value)
    if (value %in% c("original", "oppposite")){
        stop("value must be either 'original' or 'opposite'.")
    }
    object@editingStrand <- value
    return(object)
})









#x <- matrix(1, nrow=1, ncol=5)
#rownames(x) <- "C2T"
#colnames(x) <- -18:-14
.buildEditingWeightsMatrix <- function(x=NULL,
                                       scale=TRUE
){
    editChoices <- .getComboNames()
    posChoices <- -1000:1000
    if (is.null(x)){
        out <- matrix(0,
                      nrow=length(editChoices),
                      ncol=1)
        rownames(out) <- editChoices
        colnames(out) <- "0"
    } else if (is.matrix(x)){
        if (!all(rownames(x) %in% editChoices)){
            diff <- setdiff(rownames(x), editChoices)
            diff <- paste0(diff, collapse=";")
            stop("The following rownames are not valid",
                 " names: ", diff)
        }
        if (!all(colnames(x) %in% posChoices)){
            diff <- setdiff(colnames(x), posChoices)
            diff <- paste0(diff, collapse=";")
            stop("The following colnames are not valid",
                 " names: ", diff)
        }
        seq_start <- min(as.integer(colnames(x)))
        seq_end <- max(as.integer(colnames(x)))
        seq <- seq_start:seq_end
        out <- matrix(0,
                      nrow=length(editChoices),
                      ncol=length(seq))
        rownames(out) <- editChoices
        colnames(out) <- seq
        out[rownames(x), colnames(x)] <- x
        if (scale){
            out <- out/max(out, na.rm=TRUE)
        }
    } else {
        stop("x must be NULL or a matrix.")
    }
    return(out)
} 


.getReducedEditingMatrix <- function(ws){
    good <- rowSums(ws==0, na.rm=TRUE)!=ncol(ws)
    ws[good,,drop=FALSE]
}


.getComboNames <- function(){
    dnaLetters <- c("A", "C", "G", "T")
    combs <- expand.grid(dnaLetters, dnaLetters)
    combs <- combs[combs[,1]!=combs[,2],]
    combs <- paste0(combs[,1], "2", combs[,2])
    return(combs)
}


.getOriginBaseFromRownames <- function(x){
    substr(x,1,1)
}

.getTargetBaseFromRownames <- function(x){
    substr(x,3,3)
}




#' Quick plot to visualize editing weights 
#' 
#' Quick plot to visualize editing weights from a 
#' BaseEditor object. 
#' 
#' @param baseEditor A \code{\linkS4class{BaseEditor}} object. 
#' @param discardEmptyRows Should rows that have all weight equal
#'     to 0 be discarded? TRUE by default. 
#' @param substitutions Character vector specifying substitutions
#'     to be plotted. If NULL (default), all substitutions are shown.
#' @param ylim Vector of length 2 specifying the y plot limits.
#' @param ... Additional arguments to be passed to \code{plot}
#' 
#' @return Nothing. A plot is generated as a side effect. 
#' 
#' @examples
#' if (interactive()){
#'     data(BE4max, package="crisprBase")
#'     plotEditingWeights(BE4max)
#' }
#' @importFrom graphics legend lines
#' @export
plotEditingWeights <- function(baseEditor,
                               discardEmptyRows=TRUE,
                               substitutions=NULL,
                               ylim=c(0,1),
                               ...
){
    .isBaseEditorOrStop(baseEditor)
    choices <- .getComboNames()
    if (is.null(substitutions)){
        substitutions <- choices
    } else {
        diff <- setdiff(substitutions, choices)
        if (length(diff)!=0){
            diff <- paste0(diff, collapse=",")
            stop("The following substitutions are not valid: ",
                 diff, ".")
        }
    }
    ws <- editingWeights(baseEditor,
                         substitutions=substitutions)
    if (discardEmptyRows){
        ws <- .getReducedEditingMatrix(ws)
    }
    x <- as.numeric(colnames(ws))
    plot(x, ws[1,], col="white",
         xlab="Position relative to PAM site",
         ylab="Editing weight",
         ylim=ylim,
         ...)
    ns <- nrow(ws)
    col <- .subColors()[seq_len(ns)]
    for (k in seq_len(ns)){
        lines(x, ws[k,], col=col[k])
    }
    legend("topleft",
           legend=rownames(ws),
           col=col,
           lty=1, cex=0.75)
}




.subColors <- function(){
    c("gold3", "firebrick2", "burlywood3",
      "darkolivegreen3", "steelblue", "green",
      "darkmagenta", "tomato3", "hotpink4",
      "blue", "darkslateblue", "lightgoldenrod3")
}

#' @title Extract PAM sequences from target sequences
#' @description Extract PAM sequences from target sequences
#'     (protospacer + PAM) using information stored in a
#'     CrisprNuclease object.
#'  
#'     
#' 
#' @param targets Character vector of target sequences. 
#' @param object \code{CrisprNuclease} corresponding to the target 
#'     sequences.
#' 
#' @return Character vector of PAM sequences of length equal to that of the 
#'     \code{targets} character vector. 
#' 
#' @author Jean-Philippe Fortin
#'
#' @examples
#' data(SpCas9, AsCas12a, package="crisprBase")
#' # Extracting PAM sequences from Cas9 protospacers:
#' targets <- c("AGGTGCTGATTGTAGTGCTGCGG",
#'               "AGGTGCTGATTGTAGTGCTGAGG")
#' extractPamFromTarget(targets, SpCas9)
#' # Extracting PAM sequences from Cas12a targets:
#' targets <- c("TTTAAGGTGCTGATTGTAGTGCTGTGT",
#'              "TTTCAGGTGCTGATTGTAGTGCTGAAA")
#' extractPamFromTarget(targets, AsCas12a)
#' 
#' @export
extractPamFromTarget <- function(targets,
                                 object
){
    .isCrisprNucleaseOrStop(object)
    .validateTargets(targets, object)
    wh <- pamIndices(object)
    pams <- substr(targets,
                   wh[1],
                   wh[length(wh)])
    return(pams)
}



#' @title Extract protospacer sequences from target sequences
#' @description Extract protospacer sequences from target sequences
#'     (protospacer + PAM) using information stored in a
#'     CrisprNuclease object. 
#'     
#' 
#' @param targets Character vector of targets sequences. 
#' @param object \code{CrisprNuclease} corresponding to the targets 
#'     sequences.
#' 
#' @return Character vector of protospacer sequences of 
#'     length equal to that of the 
#'     \code{targets} character vector. 
#' 
#' @author Jean-Philippe Fortin
#'
#' @examples
#' data(SpCas9, AsCas12a, package="crisprBase")
#' # Extracting protospacer sequences from Cas9 targets:
#' targets <- c("AGGTGCTGATTGTAGTGCTGCGG",
#'              "AGGTGCTGATTGTAGTGCTGAGG")
#' extractProtospacerFromTarget(targets, SpCas9)
#' # Extracting protospacer sequences from Cas12a targets:
#' targets <- c("TTTAAGGTGCTGATTGTAGTGCTGTGT",
#'              "TTTCAGGTGCTGATTGTAGTGCTGAAA")
#' extractProtospacerFromTarget(targets, AsCas12a)
#' 
#' @export
extractProtospacerFromTarget <- function(targets,
                                         object
){
    .isCrisprNucleaseOrStop(object)
    .validateTargets(targets, object)
    wh <- spacerIndices(object)
    out <- substr(targets,
                  wh[1],
                  wh[length(wh)])
    return(out)
}





#' @title Construct a target GRanges from a list of PAM sites 
#' 
#' @description Construct a target (protospacer + PAM) GRanges
#'     from a list of PAM sites using information stored in a
#'     CrisprNuclease object. 
#'     
#' @param gr GRanges object of width 1 specifying the coordinates
#'     of the first nucleotide of the PAM sequences. 
#' @param seqnames Character vector of genomic sequence names.
#'     Ignored if \code{gr} is not NULL.
#' @param pam_site Numeric vector specifying the coordinates of the
#'     first nucleotide of the PAM sequences corresponding to the
#'     targets. Ignored if \code{gr} is not NULL.
#' @param strand Character vector specifying the strand of the target. 
#'     Ignored if \code{gr} is not NULL.
#' @param nuclease CrisprNuclease object.
#' @param spacer_len Non-negative integer to overwrite the default spacer
#'     length stored in the CrisprNuclease object.
#' 
#' @return GRanges object representing genomic coordinates of
#'     the target sequences.
#' 
#' @author Jean-Philippe Fortin
#' 
#' @examples 
#' data(SpCas9, AsCas12a, package="crisprBase")
#' library(GenomicRanges)
#' gr <- GRanges("chr10",
#'               IRanges(start=c(100,120), width=1),
#'               strand=c("+","-"))
#' getTargetRanges(gr, nuclease=SpCas9)
#' getTargetRanges(gr, nuclease=AsCas12a)
#' 
#' 
#' @export
#' @importFrom BiocGenerics start end start<- end<- strand
getTargetRanges <- function(gr=NULL,
                            seqnames=NULL,
                            pam_site=NULL,
                            strand=NULL,
                            nuclease=NULL,
                            spacer_len=NULL
){
    .isCrisprNucleaseOrStop(nuclease)
    if (!is.null(spacer_len)){
        if (length(spacer_len)>1){
            stop("spacer_len must be either NULL or of length 1.")
        }
        message("Overwriting spacerLength(nuclease) with spacer_len")
        spacerLength(nuclease) <- spacer_len
    }
    gr <- .validatePosGrOrNull(gr)
    if (is.null(gr) & 
        (is.null(seqnames) | is.null(pam_site) | is.null(strand))){
        stop("seqnames, pam_site, and strand must be provided if gr=NULL")
    }
    if (is.null(gr)){
        gr <- .buildGRFromPamSite(seqnames=seqnames,
                                  pam_site=pam_site,
                                  strand=strand)
    }
    pam_len    <- pamLength(nuclease)
    spacer_len <- spacerLength(nuclease)
    gap_len    <- spacerGap(nuclease)
    pam_side   <- pamSide(nuclease)

    r <-  as.character(BiocGenerics::strand(gr))=='-'
    if (pam_side=="3prime"){
        start    <- start(gr) - gap_len - spacer_len
        end      <- start(gr) + pam_len - 1
        start[r] <- start(gr)[r] - pam_len +1
        end[r]   <- start(gr)[r] + spacer_len + gap_len
    } else {
        start    <- start(gr)
        end      <- start(gr) + pam_len + spacer_len + gap_len - 1
        start[r] <- start(gr)[r] - spacer_len - pam_len - gap_len + 1
        end[r]   <- start(gr)[r]
    }
    gr.new <- .resetGRCoordinates(gr)
    end(gr.new)   <- end
    start(gr.new) <- start
    return(gr.new)
}






#' @title Construct a protospacer GRanges from a list of PAM sites 
#' 
#' @description Construct a protospacer GRanges from a list of PAM sites
#'     using information stored in a CrisprNuclease object. 
#'     
#' @param gr GRanges object of width 1 specifying the coordinates
#'     of the first nucleotide of the PAM sequences. 
#' @param seqnames Character vector of genomic sequence names.
#'     Ignored if \code{gr} is not NULL.
#' @param pam_site Numeric vector specifying the coordinates of the
#'     first nucleotide of the PAM sequences corresponding to the
#'     protospacers. Ignored if \code{gr} is not NULL.
#' @param strand Character vector specifying the strand of the protospacer. 
#'     Ignored if \code{gr} is not NULL.
#' @param nuclease CrisprNuclease object.
#' @param spacer_len Non-negative integer to overwrite the default spacer
#'     length stored in the CrisprNuclease object.
#' s
#' @return GRanges object representing genomic coordinates of
#'     protospacer sequences.
#' 
#' @author Jean-Philippe Fortin
#' 
#' @examples 
#' data(SpCas9, AsCas12a, package="crisprBase")
#' library(GenomicRanges)
#' gr <- GRanges("chr10",
#'               IRanges(start=c(100,120), width=1),
#'               strand=c("+","-"))
#' getProtospacerRanges(gr, nuclease=SpCas9)
#' getProtospacerRanges(gr, nuclease=AsCas12a)
#' 
#' @export
getProtospacerRanges <- function(gr=NULL,
                                 seqnames=NULL,
                                 pam_site=NULL,
                                 strand=NULL,
                                 nuclease=NULL,
                                 spacer_len=NULL
){
    .isCrisprNucleaseOrStop(nuclease)
    if (!is.null(spacer_len)){
        if (length(spacer_len)>1){
            stop("spacer_len must be either NULL or of length 1.")
        }
        message("Overwriting spacerLength(nuclease) with spacer_len")
        spacerLength(nuclease) <- spacer_len
    }
    gr <- .validatePosGrOrNull(gr)
    if (is.null(gr) & 
        (is.null(seqnames) | is.null(pam_site) | is.null(strand))){
        stop("seqnames, pam_site, and strand must be provided if gr=NULL")
    }
    if (is.null(gr)){
        gr <- .buildGRFromPamSite(seqnames=seqnames,
                                  pam_site=pam_site,
                                  strand=strand)
    }
    pam_len    <- pamLength(nuclease)
    spacer_len <- spacerLength(nuclease)
    gap_len    <- spacerGap(nuclease)
    pam_side   <- pamSide(nuclease)

    r <-  as.character(BiocGenerics::strand(gr))=='-'
    if (pam_side=="3prime"){
        start    <- start(gr) - gap_len - spacer_len
        end      <- start(gr) - gap_len - 1
        start[r] <- start(gr)[r] + gap_len +1
        end[r]   <- start(gr)[r] + spacer_len + gap_len
    } else {
        start    <- start(gr) + pam_len + gap_len
        end      <- start(gr) + pam_len + spacer_len + gap_len - 1
        start[r] <- start(gr)[r] - spacer_len - pam_len - gap_len + 1
        end[r]   <- start(gr)[r] - pam_len - gap_len
    }
    gr.new <- .resetGRCoordinates(gr)
    end(gr.new)   <- end
    start(gr.new) <- start
    return(gr.new)
}


#' @title Construct a PAM GRanges from a list of PAM sites 
#' 
#' @description Construct a PAM GRanges from a list of PAM sites
#'     using information stored in a CrisprNuclease object. 
#'     
#' @param gr GRanges object of width 1 specifying the coordinates
#'     of the first nucleotide of the PAM sequences. 
#' @param seqnames Character vector of genomic sequence names.
#'     Ignored if \code{gr} is not NULL.
#' @param pam_site Numeric vector specifying the coordinates of the
#'     first nucleotide of the PAM sequences corresponding to the
#'     PAM sequences. Ignored if \code{gr} is not NULL.
#' @param strand Character vector specifying the strand of the PAM. 
#'     Ignored if \code{gr} is not NULL.
#' @param nuclease CrisprNuclease object.
#' 
#' @return GRanges object representing genomic coordinates of PAM sequences.
#' 
#' @author Jean-Philippe Fortin
#' 
#' @examples
#' data(SpCas9, AsCas12a, package="crisprBase")
#' library(GenomicRanges)
#' gr <- GRanges("chr10",
#'               IRanges(start=c(100,120), width=1),
#'               strand=c("+","-"))
#' getPamRanges(gr, nuclease=SpCas9)
#' getPamRanges(gr, nuclease=AsCas12a)
#'
#' @export
getPamRanges <- function(gr=NULL,
                         seqnames=NULL,
                         pam_site=NULL,
                         strand=NULL,
                         nuclease=NULL
){
    .isCrisprNucleaseOrStop(nuclease)
    gr <- .validatePosGrOrNull(gr)
    if (is.null(gr) & 
        (is.null(seqnames) | is.null(pam_site) | is.null(strand))){
        stop("seqnames, pam_site, and strand must be provided if gr=NULL")
    }
    if (is.null(gr)){
        gr <- .buildGRFromPamSite(seqnames=seqnames,
                                  pam_site=pam_site,
                                  strand=strand)
    }
    r <-  as.character(BiocGenerics::strand(gr))=='-'
    pam_len  <- pamLength(nuclease)
    start    <- start(gr)     
    end      <- start(gr) + pam_len - 1 
    start[r] <- start(gr)[r] - pam_len + 1 
    end[r]   <- start(gr)[r]
  
    gr.new <- .resetGRCoordinates(gr)
    end(gr.new)   <- end
    start(gr.new) <- start
    return(gr.new)
}




#' @title Construct a cut site GRanges from a list of PAM sites 
#' 
#' @description Construct a cut site GRanges from a list of PAM sites 
#'     using information stored in a CrisprNuclease object. 
#'     
#' @param gr GRanges object of width 1 specifying the coordinates
#'     of the first nucleotide of the PAM sequences. 
#' @param seqnames Character vector of genomic sequence names.
#'     Ignored if \code{gr} is not NULL.
#' @param pam_site Numeric vector specifying the coordinates of the
#'     first nucleotide of the PAM sequences corresponding to the
#'     PAM sequences. Ignored if \code{gr} is not NULL.
#' @param strand Character vector specifying the strand of the PAM. 
#'     Ignored if \code{gr} is not NULL.
#' @param nuclease CrisprNuclease object.
#' 
#' @return GRanges object representing genomic coordinates of the cut sites.
#' 
#' @author Jean-Philippe Fortin
#' 
#' @examples
#' data(SpCas9, AsCas12a, package="crisprBase")
#' library(GenomicRanges)
#' gr <- GRanges("chr10",
#'               IRanges(start=c(100,120), width=1),
#'               strand=c("+","-"))
#' getCutSiteRanges(gr, nuclease=SpCas9)
#' getCutSiteRanges(gr, nuclease=AsCas12a)
#'
#' @export
getCutSiteRanges <- function(gr=NULL,
                             seqnames=NULL,
                             pam_site=NULL,
                             strand=NULL,
                             nuclease=NULL
){
    .isCrisprNucleaseOrStop(nuclease)
    gr <- .validatePosGrOrNull(gr)
    if (is.null(gr) & 
        (is.null(seqnames) | is.null(pam_site) | is.null(strand))){
        stop("seqnames, pam_site, and strand must be provided if gr=NULL")
    }
    if (is.null(gr)){
        gr <- .buildGRFromPamSite(seqnames=seqnames,
                                  pam_site=pam_site,
                                  strand=strand)
    }
    pamSites <- BiocGenerics::start(gr)
    strand <- as.character(strand(gr))
    cutSites <- getCutSiteFromPamSite(pam_site=pamSites,
                                      strand=strand,
                                      nuclease=nuclease)

    gr.new <- .resetGRCoordinates(gr)
    BiocGenerics::start(gr.new) <- BiocGenerics::end(gr.new) <- cutSites
    return(gr.new)
}








#' @title Return cut site coordinates from PAM site coordinates
#' 
#' @description Return cut site coordinates from PAM site coordinates.
#'     
#' @param pam_site Coordinate of the first nucleotide of the PAM sequence.
#' @param strand Either "+" or "-".
#' @param nuclease A \linkS4class{CrisprNuclease} object.
#' 
#' @return numeric vector of cut sites
#' 
#' @author Jean-Philippe Fortin
#' 
#' @examples
#' data(SpCas9, package="crisprBase")
#' getCutSiteFromPamSite(pam_site=100, strand="+", nuclease=SpCas9)
#' getCutSiteFromPamSite(pam_site=100, strand="-", nuclease=SpCas9)
#' 
#' @export
getCutSiteFromPamSite <- function(pam_site,
                                  strand,
                                  nuclease=NULL
){
    .isCrisprNucleaseOrStop(nuclease)
    strand <- .validateStrand(strand)
    stopifnot(length(pam_site)==length(strand))
    cut_offset <- cutSites(nuclease, middle=TRUE)
    cut_site <- pam_site
    cut_site[strand=='+'] <- pam_site[strand=='+'] + cut_offset
    cut_site[strand=='-'] <- pam_site[strand=='-'] - cut_offset
    return(cut_site)
}




#' @title Return optimal editing site coordinates from PAM site coordinates
#' 
#' @description Return optimal editing site coordinates from PAM 
#'     site coordinates. 
#'     
#' @param pam_site Coordinate of the first nucleotide of the PAM sequence.
#' @param strand Either "+" or "-".
#' @param baseEditor A \linkS4class{BaseEditor} object.
#' @param substitution String indicating which substitution
#'     should be used to estimate the optimal editing position. 
#'     E.g. "C2T" will return the optimal editing position for C to T
#'     editing. 
#' 
#' @return numeric vector of editing sites.
#' 
#' @author Jean-Philippe Fortin
#' 
#' @examples
#' data(BE4max, package="crisprBase")
#' getEditingSiteFromPamSite(pam_site=100, strand="+", baseEditor=BE4max, "C2T")
#' 
#' @export
getEditingSiteFromPamSite <- function(pam_site,
                                      strand,
                                      baseEditor=NULL,
                                      substitution=NULL
){
    .isBaseEditorOrStop(baseEditor)
    strand <- .validateStrand(strand)
    stopifnot(length(pam_site)==length(strand))
    if (is.null(substitution)){
        stop("[getEditingSiteFromPamSite] 'substitution' must be specified. ")
    }
    if (length(substitution)!=1){
        stop("[getEditingSiteFromPamSite] 'substitution' must have length 1.")
    }
    ws <- editingWeights(baseEditor)
    if (!substitution %in% rownames(ws)){
        stop("[getEditingSiteFromPamSite] 'substitution' not found in the",
             " matrix of editing weights.")
    }
    ws <- ws[substitution,,drop=FALSE]
    maxEditing <- colnames(ws)[which.max(ws)]
    editing_offset <- as.integer(maxEditing)
    editing_site <- pam_site
    editing_site[strand=='+'] <- editing_site[strand=='+'] + editing_offset
    editing_site[strand=='-'] <- editing_site[strand=='-'] - editing_offset
    return(editing_site)
}







.validateTargets <- function(targets,
                             object
){
    .isCrisprNucleaseOrStop(object)
    target.len <- targetLength(object)
    n <- unique(nchar(targets))
    if (n!=target.len){
        stop("provided targets are of length ",n,
             ", but it should be ", target.len, 
             " for the provided ", nucleaseName(object))  
    } 
    return(targets)
}

context('Testing arithmetic functions')

data(SpCas9, package="crisprBase")
data(AsCas12a, package="crisprBase")
data(enAsCas12a, package="crisprBase")

targets_cas9   <- c("ATGGTGGTAGTCTCTCGATACGG",
                         "ATGGGTTTAGTCTAAACGATAGG")
targets_cas12a <- c("TTTAATGGTGGTAGTCTCTCGATACGG",
                         "TTTCATGGGTTTAGTCTAAACGATAGG")
spacers_cas9   <- c("ATGGTGGTAGTCTCTCGATA",
                    "ATGGGTTTAGTCTAAACGAT")
spacers_cas12a <- c("ATGGTGGTAGTCTCTCGATACGG",
                    "ATGGGTTTAGTCTAAACGATAGG")
pams_cas9   <- c("CGG", "AGG")
pams_cas12a <- c("TTTA", "TTTC")

# Grangesstuff:
chr <- c("chr10", "chr11")                    
pam_site <- c(1998467, 220000)
strand <- c("+", "-")
gr <- GenomicRanges::GRanges(chr,
                             IRanges::IRanges(start=pam_site,
                                              width=1),
                             strand=strand)

gr_pam_cas9 <- GenomicRanges::GRanges(chr,
                       strand=strand,
                       IRanges::IRanges(start=c(1998467, 219998),
                               end=c(1998469,220000)))
gr_pam_cas12a <- GenomicRanges::GRanges(chr,
                       strand=strand,
                       IRanges::IRanges(start=c(1998467, 219997),
                               end=c(1998470,220000)))

gr_spacer_cas9 <- GenomicRanges::GRanges(chr,
                       strand=strand,
                       IRanges::IRanges(start=c(1998447, 220001),
                               end=c(1998466,220020)))
gr_spacer_cas12a <- GenomicRanges::GRanges(chr,
                       strand=strand,
                       IRanges::IRanges(start=c(1998471, 219974),
                               end=c(1998493,219996)))
gr_target_cas9 <- GenomicRanges::GRanges(chr,
                       strand=strand,
                       IRanges::IRanges(start=c(1998447, 219998),
                               end=c(1998469,220020)))
gr_target_cas12a <- GenomicRanges::GRanges(chr,
                       strand=strand,
                       IRanges::IRanges(start=c(1998467, 219974),
                               end=c(1998493,220000)))

gr_spacer_cas9_long <- GenomicRanges::GRanges(chr,
                       strand=strand,
                       IRanges::IRanges(start=c(1998367, 220001),
                               end=c(1998466,220100)))
gr_spacer_cas12a_long <- GenomicRanges::GRanges(chr,
                       strand=strand,
                       IRanges::IRanges(start=c(1998471, 219897),
                               end=c(1998570,219996)))

gr_target_cas9_long <- GenomicRanges::GRanges(chr,
                       strand=strand,
                       IRanges::IRanges(start=c(1998367, 219998),
                               end=c(1998469,220100)))
gr_target_cas12a_long <- GenomicRanges::GRanges(chr,
                       strand=strand,
                       IRanges::IRanges(start=c(1998467, 219897),
                               end=c(1998570,220000)))



test_that('Extraction functions', {
    expect_equal(extractProtospacerFromTarget(targets_cas9, SpCas9), spacers_cas9)
    expect_equal(extractProtospacerFromTarget(targets_cas12a, AsCas12a), spacers_cas12a)
    expect_equal(extractPamFromTarget(targets_cas9, SpCas9), pams_cas9)
    expect_equal(extractPamFromTarget(targets_cas12a, AsCas12a), pams_cas12a)
})

test_that('Genomic ranges functions', {
    # Using GRanges as inputs:
    expect_equal(getPamRanges(gr, nuclease=SpCas9), gr_pam_cas9)
    expect_equal(getPamRanges(gr, nuclease=AsCas12a), gr_pam_cas12a)
    expect_equal(getProtospacerRanges(gr, nuclease=SpCas9), gr_spacer_cas9)
    expect_equal(getProtospacerRanges(gr, nuclease=AsCas12a), gr_spacer_cas12a)
    expect_equal(getTargetRanges(gr, nuclease=SpCas9), gr_target_cas9)
    expect_equal(getTargetRanges(gr, nuclease=AsCas12a), gr_target_cas12a)

    # Using coordinates as inputs:
    expect_equal(getPamRanges(seqnames=chr, pam_site=pam_site, strand=strand, nuclease=SpCas9), gr_pam_cas9)
    expect_equal(getPamRanges(seqnames=chr, pam_site=pam_site, strand=strand, nuclease=AsCas12a), gr_pam_cas12a)
    expect_equal(getProtospacerRanges(seqnames=chr, pam_site=pam_site, strand=strand, nuclease=SpCas9), gr_spacer_cas9)
    expect_equal(getProtospacerRanges(seqnames=chr, pam_site=pam_site, strand=strand, nuclease=AsCas12a), gr_spacer_cas12a)
    expect_equal(getTargetRanges(seqnames=chr, pam_site=pam_site, strand=strand, nuclease=SpCas9), gr_target_cas9)
    expect_equal(getTargetRanges(seqnames=chr, pam_site=pam_site, strand=strand, nuclease=AsCas12a), gr_target_cas12a)

    # Different spacer length
    expect_equal(getProtospacerRanges(gr, nuclease=SpCas9, spacer_len=100), gr_spacer_cas9_long)
    expect_equal(getProtospacerRanges(gr, nuclease=AsCas12a, spacer_len=100), gr_spacer_cas12a_long)
    expect_equal(getTargetRanges(gr, nuclease=SpCas9, spacer_len=100), gr_target_cas9_long)
    expect_equal(getTargetRanges(gr, nuclease=AsCas12a, spacer_len=100), gr_target_cas12a_long)
})

context('Testing CrisprNuclease class')

data(SpCas9, package="crisprBase")
data(AsCas12a, package="crisprBase")
data(enAsCas12a, package="crisprBase")

test_that('PAM', {
    pams_cas9 <- c("AGG", "CGG", "GGG", "TGG")
    pams_cas9_extended <- c("AGG", "CGG", "GGG", "TGG",
                            "AAG", "CAG", "GAG", "TAG",
                            "AGA", "CGA", "GGA", "TGA")
    names(pams_cas9) <- rep("NGG", 4)
    names(pams_cas9_extended) <- c(rep("NGG", 4),
                                   rep("NAG", 4),
                                   rep("NGA", 4))
    expect_true(pamLength(SpCas9)==3)
    expect_true(pamLength(AsCas12a)==4)
    expect_equal(sort(pams(SpCas9, as.character=TRUE)), sort(pams_cas9))
    expect_equal(sort(pams(SpCas9, primary=FALSE, as.character=TRUE)), sort(pams_cas9_extended))
    expect_equal(pamIndices(SpCas9), 21:23)
    expect_equal(pamIndices(AsCas12a), 1:4)
    expect_true(pamSide(SpCas9)=="3prime")
    expect_true(pamSide(AsCas12a)=="5prime")
})


test_that('Spacer', {
    expect_true(spacerLength(SpCas9)==20)
    expect_true(spacerLength(AsCas12a)==23)
    expect_equal(spacerIndices(SpCas9), 1:20)
    expect_equal(spacerIndices(AsCas12a), 5:27)
    expect_true(pamSide(SpCas9)=="3prime")
    expect_true(pamSide(AsCas12a)=="5prime")
})

test_that('Target', {
    expect_true(targetLength(SpCas9)==23)
    expect_true(targetLength(AsCas12a)==27)
})

#Required inkscape to be installed
ink enzymes.pdf --export-plain-svg=enzymes.svg
ink nucleases.pdf --export-plain-svg=nucleases.svg
ink nickases.pdf --export-plain-svg=nickases.svg
ink nucleasesBaseEditor.pdf --export-plain-svg=nucleasesBaseEditor.svg
ink cut_sites.pdf --export-plain-svg=cut_sites.svg

---
title: "Base functions and classes for CRISPR gRNA design"
author: 
- name: Jean-Philippe Fortin
  affiliation: Department of Data Science and Statistical Computing, gRED,
   Genentech
  email: fortin946@gmail.com
date: "`r Sys.Date()`"
output: 
  BiocStyle::html_document:
    toc_float: true
    theme: paper
    number_sections: true
vignette: >
  %\VignetteIndexEntry{Introduction to crisprBase}
  %\VignetteEngine{knitr::rmarkdown}
  \usepackage[utf8]{inputenc}
bibliography: references.bib
---

```{r, echo=FALSE, results="hide"}
options("knitr.graphics.auto_pdf"=TRUE, eval=TRUE)
```

# Overview

The `crisprBase` package is a core package of the [crisprVerse ecosystem](https://github.com/crisprVerse) that provides S4 classes for
representing CRISPR nucleases and base editors. It also provides arithmetic 
functions to extract genomic ranges to help with the design and manipulation 
of CRISPR guide-RNAs (gRNAs). The classes and functions are designed to work 
with a broad spectrum of nucleases and applications, including 
PAM-free CRISPR nucleases, RNA-targeting nucleases, and the more
general class of restriction enzymes. It also includes functionalities for
CRISPR nickases. 

It provides a language and convention for our gRNA design ecosystem 
described in our recent bioRxiv preprint:
["The crisprVerse: a comprehensive Bioconductor ecosystem for the design of CRISPR guide RNAs across nucleases and technologies"](https://www.biorxiv.org/content/10.1101/2022.04.21.488824v3)


# Installation

## Software requirements

### OS Requirements

This package is supported for macOS, Linux and Windows machines.
It was developed and tested on R version 4.2.

## Installation

`crisprBase` can be installed from the Bioconductor devel branch by typing the
following commands inside of an R session:

```r
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install(version="devel")
BiocManager::install("crisprBase")
```


### Getting started

We load `crisprBase` in the usual way:

```{r, warnings=FALSE, message=FALSE}
library(crisprBase)
```


# Nuclease class

The `Nuclease` class is designed to store minimal information about the
recognition sites of general nucleases, such as restriction enzymes. 
The `Nuclease` class has 5 fields: `nucleaseName`, `targetType`,
`metadata`, `motifs` and `weights`. 
The `nucleaseName` field is a string specifying a name
for the nuclease.
The `targetType` specifies if the nuclease targets "DNA" (deoxyribonucleases)
or "RNA" (ribonucleases). The `metadata` field is a `list` of arbitrary length
to store additional information about the nuclease.

The `motifs` field is a character vector that specify one of several DNA
sequence motifs that are recognized by the nuclease for cleavage (always in 
the 5' to 3' direction). The optional `weights` field is a numeric vector
specifying relative cleavage probabilities corresponding to the motifs 
specified by `motifs`. Note that we use DNA to represent motifs irrespectively
of the target type for simplicity. 

We use the Rebase convention to represent motif sequences [@rebase]. 
For enzymes that cleave within the recognition site, 
we add the symbol `^` within the recognition sequence to specify 
the cleavage site, always in the 5' to 3' direction. For enzymes that 
cleave away from the recognition site, we specify the distance of the cleavage
site using a `(x/y)` notation where `x`
represents the number of nucleotides away from the recognition sequence on the
original strand, and `y` represents the number of nucleotides away from the
recognition sequence on the reverse strand. 

## Examples 

The EcoRI enzyme recognizes the palindromic motif `GAATTC`, and cuts after
the first nucleotide, which is specified using the `^` below:


```{r, warning=FALSE, message=FALSE}
library(crisprBase)

EcoRI <- Nuclease("EcoRI",
                  targetType="DNA",
                  motifs=c("G^AATTC"),
                  metadata=list(description="EcoRI restriction enzyme"))
```

The HgaI enzyme recognizes the motif `GACGC`, and cleaves DNA at 5
nucleotides downstream of the recognition sequence on the original strand, 
and at 10 nucleotides downstream of the recognition sequence on the reverse
strand:

```{r}
HgaI <- Nuclease("HgaI",
                 targetType="DNA",
                 motifs=c("GACGC(5/10)"),
                 metadata=list(description="HgaI restriction enzyme"))
```

In case the cleavage site was upstream of the recognition sequence, we would
instead specify `(5/10)GACGC`. 

Note that any nucleotide letter that is part of the extended IUPAC nucleic acid
code can be used to represent recognition motifs. For instance, we use `Y`
and `R` (pyrimidine and purine, respectively) to specify the possible
recognition sequences for PfaAI:

```{r}
PfaAI <- Nuclease("PfaAI",
                  targetType="DNA",
                  motifs=c("G^GYRCC"),
                  metadata=list(description="PfaAI restriction enzyme"))
```

## Accessor functions

The accessor function `motifs` retrieve the motif
sequences:


```{r}
motifs(PfaAI)
```

To expand the motif sequence into all combinations of valid sequences with only
A/C/T/G nucleotides, users can use `expand=TRUE`. 

```{r}
motifs(PfaAI, expand=TRUE)
```


```{r, echo=FALSE, fig.cap="Examples of restriction enzymes"}
knitr::include_graphics("./figures/enzymes.svg")
```


# CrisprNuclease class

CRISPR nucleases are examples of RNA-guided nucleases. For cleavage, it
requires two binding components. For CRISPR nucleases targeting DNA,
the nuclease needs to first recognize a
constant nucleotide motif in the target DNA called the protospacer adjacent 
motif (PAM) sequence. Second, the guide-RNA (gRNA), which guides the nuclease
to the target sequence, needs to bind to a complementary sequence adjacent
to the PAM sequence (protospacer sequence). The latter can be thought of a variable binding motif 
that can be specified by designing corresponding gRNA sequences. For CRISPR
nucleases targeting RNA, the equivalent of the PAM sequence is 
called the Protospacer Flanking Sequence (PFS). We use the terms PAM and PFS
interchangeably as it should be clear from context. 

The `CrisprNuclease` class allows to characterize both binding components by
extending the `Nuclease` class to contain information about the gRNA
sequences.The PAM sequence characteristics, and the cleavage distance with
respect to the PAM sequence, are specified using the motif nomenclature
described in the Nuclease section above. 

3 additional fields are required: `pam_side`, `spacer_length` and
`spacer_gap`. The `pam_side` field can only take 2 values, `5prime` and
`3prime`, and specifies on which side the PAM sequence is located with 
respect to the protospacer sequence. While it would be more appropriate to use
the terminology `pfs_side` for RNA-targeting nucleases, we still use the term
`pam_side` for simplicity.


The `spacer_length` specifies
a default spacer length, and the `spacer_gap` specifies a distance
(in nucleotides) between the PAM (or PFS) sequence and spacer sequence.
For most nucleases,`spacer_gap=0` as the spacer sequence is located directly
next to the PAM/PFS sequence. 

We show how we construct a `CrisprNuclease` object for the commonly-used Cas9
nuclease (Streptococcus pyogenes Cas9):

```{r}
SpCas9 <- CrisprNuclease("SpCas9",
                         targetType="DNA",
                         pams=c("(3/3)NGG", "(3/3)NAG", "(3/3)NGA"),
                         weights=c(1, 0.2593, 0.0694),
                         metadata=list(description="Wildtype Streptococcus pyogenes Cas9 (SpCas9) nuclease"),
                         pam_side="3prime",
                         spacer_length=20)
SpCas9
```

Similar to the `Nuclease` class, we can specify PAM sequences using the 
extended nucleotide code. SaCas9 serves as a good example:

```{r}
SaCas9 <- CrisprNuclease("SaCas9",
                         targetType="DNA",
                         pams=c("(3/3)NNGRRT"),
                         metadata=list(description="Wildtype Staphylococcus 
                         aureus Cas9 (SaCas9) nuclease"),
                         pam_side="3prime",
                         spacer_length=21)
SaCas9
```


Here is another example where we construct a `CrisprNuclease` object for the
commonly-used Cas12a nuclease (AsCas12a):

```{r}
AsCas12a <- CrisprNuclease("AsCas12a",
                           targetType="DNA",
                           pams="TTTV(18/23)",
                           metadata=list(description="Wildtype Acidaminococcus
                           Cas12a (AsCas12a) nuclease."),
                           pam_side="5prime",
                           spacer_length=23)
AsCas12a
```

## CrisprNuclease objects provided in CrisprBase

Several already-constructed `crisprNuclease` objects are available 
in `crisprBase`, see `data(package="crisprBase")`.




# CRISPR arithmetics

## CRISPR terminology


The terms **spacer** and **protospacer** are not interchangeable. **spacer**
refers to the sequence used in the gRNA construct to guide the Cas nuclease to
the target **protospacer** sequence in the host genome / transcriptome.
The **protospacer** sequence is adjacent to the PAM sequence /  PFS sequence.
We use the terminology **target** sequence to refer to the protospacer and PAM sequence taken together. For DNA-targeting nucleases such as Cas9 and Cas12a, the spacer and protospacer sequences are identical from a nucleotide point of view. For RNA-targeting nucleases such as Cas13d, the spacer and protospacer sequences are the reverse complement of each other. 

An gRNA spacer sequence does not always uniquely target the host genome 
(a given sgRNA spacer can map to multiple protospacers in the genome). 
However, for a given reference genome, protospacer sequences can be uniquely
identified using a combination of 3 attributes: 

- **chr**: chromosome name 
- **strand**: forward (+) or reverse (-)
- **pam_site**: genomic coordinate of the first nucleotide of the
nuclease-specific PAM sequence. For SpCas9, this corresponds to the genomic
coordinate of N in the NGG PAM sequence. For AsCas12a, this corresponds to the
genomic coordinate of the first T nucleotide in the TTTV PAM sequence. 
For RNA-targeting nucleases, this corresponds to the first nucleotide of 
the PFS (we do not use `pfs_site` for simplicity).


```{r, echo=FALSE, fig.cap="Examples of CRISPR nucleases"}
knitr::include_graphics("./figures/nucleases.svg")
```

## Cut site

For convention, we used the nucleotide directly downstream of the DNA cut to
represent the cut site nucleotide position. For instance, for SpCas9 
(blunt-ended dsDNA break), the cut site occurs at position -3 with respect to
the PAM site. For AsCas12a, the 5nt overhang dsDNA break occurs at 18 
nucleotides after the PAM sequence on the targeted strand. Therefore the cute
site on the forward strand occurs at position 22 with respect to the PAM site,
and at position 27 on the reverse strand.

The convenience function `cutSites` extracts the cut site coordinates
relative to the PAM site:

```{r}
data(SpCas9, package="crisprBase")
data(AsCas12a, package="crisprBase")
cutSites(SpCas9)
cutSites(SpCas9, strand="-")
cutSites(AsCas12a)
cutSites(AsCas12a, strand="-")
```

Below is an illustration of how different motif sequences and cut patterns
translate into cut site coordinates with respect to a PAM sequence NGG:

```{r, echo=FALSE, fig.cap="Examples of cut site coordinates"}
knitr::include_graphics("./figures/cut_sites.svg")
```



## Obtaining spacer and PAM sequences from target sequences

Given a list of target sequences (protospacer + PAM) and a `CrisprNuclease` object, one can extract protospacer and PAM sequences using the functions
`extractProtospacerFromTarget` and `extractPamFromTarget`, respectively.

```{r}
targets <- c("AGGTGCTGATTGTAGTGCTGCGG",
             "AGGTGCTGATTGTAGTGCTGAGG")
extractPamFromTarget(targets, SpCas9)
extractProtospacerFromTarget(targets, SpCas9)
```


## Obtaining genomic coordinates of protospacer sequences using PAM site coordinates


Given a PAM coordinate, there are several functions in `crisprBase` that 
allows to get get coordinates of the full PAM sequence, protospacer sequence, and target sequence: `getPamRanges`, `getTargetRanges`, and
`getProtospacerRanges`, respectively. The output objects are `GRanges`:

```{r}
chr      <- rep("chr7",2)
pam_site <- rep(200,2)
strand   <- c("+", "-")
gr_pam <- getPamRanges(seqnames=chr,
                       pam_site=pam_site,
                       strand=strand,
                       nuclease=SpCas9)
gr_protospacer <- getProtospacerRanges(seqnames=chr,
                                       pam_site=pam_site,
                                       strand=strand,
                                       nuclease=SpCas9)
gr_target <- getTargetRanges(seqnames=chr,
                             pam_site=pam_site,
                             strand=strand,
                             nuclease=SpCas9)
gr_pam
gr_protospacer
gr_target
```

and for AsCas12a:


```{r}
gr_pam <- getPamRanges(seqnames=chr,
                       pam_site=pam_site,
                       strand=strand,
                       nuclease=AsCas12a)
gr_protospacer <- getProtospacerRanges(seqnames=chr,
                                       pam_site=pam_site,
                                       strand=strand,
                                       nuclease=AsCas12a)
gr_target <- getTargetRanges(seqnames=chr,
                             pam_site=pam_site,
                             strand=strand,
                             nuclease=AsCas12a)
gr_pam
gr_protospacer
gr_target
```

# BaseEditor class

Base editors are inactive Cas nucleases coupled with a specific deaminase.
For instance, the first cytosine base editor (CBE) was obtained by coupling
a cytidine deaminase with dCas9 to convert Cs to Ts [@komor].


```{r, echo=FALSE, fig.cap="Examples of base editors."}
knitr::include_graphics("./figures/nucleasesBaseEditor.svg")
```


We provide in `crisprBase` a S4 class, `BaseEditor`, to represent base editors.
It extends the `CrisprNuclase` class with 3 additional fields:

- `baseEditorName`: string specifying the name of the base editor.
- `editingStrand`: strand where the editing happens with respect to the target
protospacer sequence ("original" or "opposite").
- `editingWeights`: a matrix of experimentally-derived editing weights. 

We now show how to build a `BaseEditor` object with the CBE base editor BE4max
with weights obtained from @behive.


We first obtain a matrix of weights for the BE4max editor stored in 
the package `crisprBase`:

```{r}
# Creating weight matrix
weightsFile <- system.file("be/b4max.csv",
                           package="crisprBase",
                           mustWork=TRUE)
ws <- t(read.csv(weightsFile))
ws <- as.data.frame(ws)
```

The row names of the matrix must correspond to the nucleotide substitutions
Nucleotide substitutions that are not present in the matrix will have weight
assigned to 0.

```{r}
rownames(ws)
```

The column names must correspond to the relative position with respect
to the PAM site. 

```{r}
colnames(ws) <- ws["Position",]
ws <- ws[-c(match("Position", rownames(ws))),,drop=FALSE]
ws <- as.matrix(ws)
head(ws)
```

Since BE4max uses Cas9, we can use the SpCas9 `CrisprNuclease` object
available in `crisprBase` to build the `BaseEditor` object:

```{r}
data(SpCas9, package="crisprBase")
BE4max <- BaseEditor(SpCas9,
                     baseEditorName="BE4max",
                     editingStrand="original",
                     editingWeights=ws,
                     scale=TRUE)
metadata(BE4max)$description_base_editor <- "BE4max cytosine base editor."
BE4max
```

The `scale=TRUE` forces the editing weights to be scaled
between 0 and 1 by dividing all weights by the largest weight value. 
This can be set to `FALSE` if the editing weights are already representing
true editing probabilities, for instance. 


One can quickly visualize the editing weights using the function 
`plotEditingWeights`:

```{r}
plotEditingWeights(BE4max)
```


# CrisprNickase class

CRISPR nickases can be created by mutating one of the two nuclease domains
of a CRISPR nuclease. They create single-strand breaks instead of double-strand
breaks.

For instance, the D10A mutation of SpCas9 inactivates the RuvC domain,
and the resulting CRISPR nickase (Cas9D10A) cleaves only the strand opposite
to the protospacer sequence. The H840A mutation of SpCas9 inactivates the 
HNN domain, and the resulting CRISPR nickase (Cas9H840A) cleaves only 
the strand that contains the protospacer sequence. See Figure below.

```{r, echo=FALSE, fig.cap="Examples of CRISPR nickases."}
knitr::include_graphics("./figures/nickases.svg")
```

The `CrisprNickase` class in `crisprBase` works similar to the `CrisprNuclease`
class:

```{r}
Cas9D10A <- CrisprNickase("Cas9D10A",
                           nickingStrand="opposite",
                           pams=c("(3)NGG", "(3)NAG", "(3)NGA"),
                           weights=c(1, 0.2593, 0.0694),
                           metadata=list(description="D10A-mutated Streptococcus
                                         pyogenes Cas9 (SpCas9) nickase"),
                           pam_side="3prime",
                           spacer_length=20)
 
Cas9H840A <- CrisprNickase("Cas9H840A",
                            nickingStrand="original",
                            pams=c("(3)NGG", "(3)NAG", "(3)NGA"),
                            weights=c(1, 0.2593, 0.0694),
                            metadata=list(description="H840A-mutated Streptococcus
                                          pyogenes Cas9 (SpCas9) nickase"),
                            pam_side="3prime",
                            spacer_length=20)
```

The `nickingStrand` field indicates which strand is being cleaved by the
nickase.

# RNA-targeting nucleases

RNA-targeting CRISPR nucleases, such as the Cas13 family of nucleases and Csm
complexes, target single-stranded RNA (ssRNA) instead of dsDNA as the 
name suggests.The equivalent of the PAM sequence is called
Protospacer Flanking Sequence (PFS). 

For RNA-targeting CRISPR nucleases, the spacer sequence is 
the reverse complement of the protospacer sequence. This differs from 
DNA-targeting CRISPR nucleases, for which the spacer and 
protospacer sequences are identical.

We can construct an RNA-targeting nuclease in way similar to a 
DNA-targeting nuclease by specifying `target="RNA"`. As an example,
we construct below a CrisprNuclease object for the CasRx nuclease (Cas13d 
from Ruminococcus flavefaciens strain XPD3002):


```{r}
CasRx <- CrisprNuclease("CasRx",
                        targetType="RNA",
                        pams="N",
                        metadata=list(description="CasRx nuclease"),
                        pam_side="3prime",
                        spacer_length=23)
CasRx
```

The `CasRx` and `Csm` nucleases are readily available in `crisprBase`. 

# Additional notes

## dCas9 and other "dead" nucleases

The CRISPR inhibition (CRISPRi) and CRISPR activation (CRISPRa) technologies
uses modified versions of CRISPR nucleases that lack endonuclease activity,
often referred to as "dead Cas" nucleases, such as the dCas9. 

While fully-active Cas nucleases and dCas nucleases differ in terms of
applications and type of genomic perturbations, the gRNA design remains
unchanged in terms of spacer sequence search and genomic coordinates. Therefore
it is convenient to use the fully-active version of the nuclease throughout
`crisprBase`. 




# License

The project as a whole is covered by the MIT license. 

# Reproducibility

```{r}
sessionInfo()
```

# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{enAsCas12a}
\alias{enAsCas12a}
\title{enAsCas12a CrisprNuclease object}
\format{
CrisprNuclease object.
}
\usage{
data(enAsCas12a, package="crisprBase")
}
\description{
CrisprNuclease object for the Enhanced Acidaminococcus Cas12a (AsCas12a)
    nuclease.
}
\details{
The enAsCas12a nuclease recognizes an extended set of PAM sequences
    beyong the canonical TTTV sequence for AsCas12a. Spacer sequences must 
    be located downstream of PAM sequences.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/arithmetics.R
\name{getCutSiteFromPamSite}
\alias{getCutSiteFromPamSite}
\title{Return cut site coordinates from PAM site coordinates}
\usage{
getCutSiteFromPamSite(pam_site, strand, nuclease = NULL)
}
\arguments{
\item{pam_site}{Coordinate of the first nucleotide of the PAM sequence.}

\item{strand}{Either "+" or "-".}

\item{nuclease}{A \linkS4class{CrisprNuclease} object.}
}
\value{
numeric vector of cut sites
}
\description{
Return cut site coordinates from PAM site coordinates.
}
\examples{
data(SpCas9, package="crisprBase")
getCutSiteFromPamSite(pam_site=100, strand="+", nuclease=SpCas9)
getCutSiteFromPamSite(pam_site=100, strand="-", nuclease=SpCas9)

}
\author{
Jean-Philippe Fortin
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{restrictionEnzymes}
\alias{restrictionEnzymes}
\title{List of Nuclease objects representing common restriction enzymes}
\format{
List of Nuclease objects.
}
\usage{
data(restrictionEnzymes, package="crisprBase")
}
\description{
List of Nuclease objects representing common restriction enzymes
    from REBASE database.
}
\details{
List of Nuclease objects representing common restriction enzymes
    from REBASE database.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Nuclease-class.R
\docType{class}
\name{motifs}
\alias{motifs}
\alias{motifLength}
\alias{nucleaseName}
\alias{targetType}
\alias{weights}
\alias{nucleaseName<-}
\alias{targetType<-}
\alias{weights<-}
\alias{cutSites}
\alias{isCutting}
\alias{isRnase}
\alias{isDnase}
\alias{Nuclease-class}
\alias{Nuclease}
\alias{show,Nuclease-method}
\alias{nucleaseName,Nuclease-method}
\alias{nucleaseName<-,Nuclease-method}
\alias{targetType,Nuclease-method}
\alias{targetType<-,Nuclease-method}
\alias{weights,Nuclease-method}
\alias{weights<-,Nuclease-method}
\alias{isCutting,Nuclease-method}
\alias{isRnase,Nuclease-method}
\alias{isDnase,Nuclease-method}
\alias{motifs,Nuclease-method}
\alias{motifLength,Nuclease-method}
\alias{cutSites,Nuclease-method}
\title{An S4 class to represent a nuclease.}
\usage{
motifs(object, ...)

motifLength(object, ...)

nucleaseName(object)

targetType(object)

weights(object, ...)

nucleaseName(object) <- value

targetType(object) <- value

weights(object) <- value

cutSites(object, ...)

isCutting(object)

isRnase(object)

isDnase(object)

Nuclease(
  nucleaseName,
  targetType = c("DNA", "RNA"),
  motifs = NULL,
  cutSites = NULL,
  weights = rep(1, length(motifs)),
  metadata = list()
)

\S4method{show}{Nuclease}(object)

\S4method{nucleaseName}{Nuclease}(object)

\S4method{nucleaseName}{Nuclease}(object) <- value

\S4method{targetType}{Nuclease}(object)

\S4method{targetType}{Nuclease}(object) <- value

\S4method{weights}{Nuclease}(object, expand = FALSE)

\S4method{weights}{Nuclease}(object) <- value

\S4method{isCutting}{Nuclease}(object)

\S4method{isRnase}{Nuclease}(object)

\S4method{isDnase}{Nuclease}(object)

\S4method{motifs}{Nuclease}(
  object,
  primary = FALSE,
  strand = c("+", "-"),
  expand = FALSE,
  as.character = FALSE
)

\S4method{motifLength}{Nuclease}(object)

\S4method{cutSites}{Nuclease}(object, strand = c("+", "-", "both"), combine = TRUE, middle = FALSE)
}
\arguments{
\item{object}{\linkS4class{Nuclease} object.}

\item{...}{Additional arguments for class-specific methods}

\item{value}{New value to pass to the setter functions.}

\item{nucleaseName}{Name of the nuclease.}

\item{targetType}{String specifying target type ("DNA" or "RNA").}

\item{motifs}{Character vector of recognition sequence motifs
written from 5' to 3' written in Rebase convention.
If the point of cleavage has been determined, the
precise site is marked with ^. Only letters in the
IUPAC code are accepted. For nucleases that cleave
away from their recognition sequence, the cleavage
sites are indicated in parentheses. See details for
more information.}

\item{cutSites}{Matrix with 2 rows (+ and - strand, respectively)
specifying the cleavage coordinates relative to the first
nucleotide of the motif sequence. Each column corresponds
to a motif specified in the \code{motifs} slot.}

\item{weights}{Optional numeric vector specifying relative weights
for the recognition motifs to specify cleavage probabilities.}

\item{metadata}{Optional list providing global metadata information.}

\item{expand}{Should sequences be expanded to only contain ATCG nucleotides?
FALSE by default.}

\item{primary}{Should only the motif with the highest weight be returned?
FALSE by default. Only relevant if weights are stored in the 
\linkS4class{Nuclease} object.}

\item{strand}{Strand to allow reverse complementation of the motif.
"+" by default.}

\item{as.character}{Should the motif sequences be returned as a 
character vector? FALSE by default.}

\item{combine}{Should only unique values be considered?
TRUE by default.}

\item{middle}{For staggered cuts, should the middle point between
the cut on the forward strand and the cut on the reverse strand
be considered as the cut site? FALSE by default.}
}
\value{
A Nuclease object
}
\description{
Return motif string representations of recognition sites.

Return length of the recognition sites sequences.
}
\section{Functions}{
\itemize{
\item \code{Nuclease()}: Create a \linkS4class{Nuclease} object

}}
\section{Slots}{

\describe{
\item{\code{nucleaseName}}{Name of the nuclease.}

\item{\code{targetType}}{Character string indicationg target type ("DNA" or "RNA").}

\item{\code{motifs}}{DNAStringSet of recognition sequence motifs
written from 5' to 3'.}

\item{\code{cutSites}}{Matrix with 2 rows (+ and - strand, respectively)
specifying the cleavage coordinates relative to the first
nucleotide of the motif sequence. Each column corresponds
to a motif specified in the \code{motifs} slot.}

\item{\code{weights}}{Optional numeric vector specifying relative weights
for the motifs corresponding to cleavage probabilities.}

\item{\code{metadata}}{Optional string providing a description of the nuclease.}
}}

\section{Constructors}{

    Use the constructor \code{link{Nuclease}} to create a Nuclease object.
}

\section{Accessors}{

\describe{
    \item{\code{nucleaseName}:}{To get the name of the nuclease.} 
    \item{\code{targetType}:}{To get the target type ("DNA" or "RNA").}
    \item{\code{metadata}:}{To get the metadata list of the nuclease.} 
    \item{\code{motifs}:}{To get the recognition mofif
         nucleotide sequences.}
    \item{\code{weights}:}{To get nuclease weights.} 
    \item{\code{cutSites}:}{To get nuclease cut sites.} 
}
}

\examples{
EcoRI <- Nuclease("EcoRI",
                  motifs=c("G^AATTC"),
                  metadata=list(description="EcoRI restriction enzyme"))

}
\seealso{
See the \linkS4class{CrisprNuclease} for CRISPR-specific nucleases.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/CrisprNickase-class.R
\docType{class}
\name{CrisprNickase-class}
\alias{CrisprNickase-class}
\alias{CrisprNickase}
\alias{show,CrisprNickase-method}
\alias{pamLength,CrisprNickase-method}
\alias{spacerLength,CrisprNickase-method}
\alias{spacerLength<-,CrisprNickase-method}
\alias{pamSide,CrisprNickase-method}
\alias{pamSide<-,CrisprNickase-method}
\alias{spacerGap,CrisprNickase-method}
\alias{spacerGap<-,CrisprNickase-method}
\alias{hasSpacerGap,CrisprNickase-method}
\alias{targetLength,CrisprNickase-method}
\alias{pams,CrisprNickase-method}
\alias{pamIndices,CrisprNickase-method}
\alias{spacerIndices,CrisprNickase-method}
\alias{prototypeSequence,CrisprNickase-method}
\title{An S4 class to represent a CRISPR nickase.}
\usage{
CrisprNickase(
  nickaseName,
  nickingStrand = c("original", "opposite"),
  pams = NA_character_,
  weights = rep(1, length(pams)),
  metadata = list(),
  pam_side = NA_character_,
  spacer_gap = 0L,
  spacer_length = NA_integer_
)

\S4method{show}{CrisprNickase}(object)

\S4method{pamLength}{CrisprNickase}(object)

\S4method{spacerLength}{CrisprNickase}(object)

\S4method{spacerLength}{CrisprNickase}(object) <- value

\S4method{pamSide}{CrisprNickase}(object)

\S4method{pamSide}{CrisprNickase}(object) <- value

\S4method{spacerGap}{CrisprNickase}(object)

\S4method{spacerGap}{CrisprNickase}(object) <- value

\S4method{hasSpacerGap}{CrisprNickase}(object)

\S4method{targetLength}{CrisprNickase}(object)

\S4method{pams}{CrisprNickase}(object, primary = TRUE, ignore_pam = FALSE, as.character = FALSE)

\S4method{pamIndices}{CrisprNickase}(object)

\S4method{spacerIndices}{CrisprNickase}(object)

\S4method{prototypeSequence}{CrisprNickase}(object, primary = TRUE)
}
\arguments{
\item{nickaseName}{Name of the CRISPR nickase.}

\item{nickingStrand}{String specifying with strand with respect
to the motif sequence (5' to 3') is nicked.
Must be either "original" (default) or "opposite".}

\item{pams}{Character vector of PAM sequence motifs
written from 5' to 3. If the point of cleavage has
been determined, the precise site is marked with ^.
Only letters in the IUPAC code are accepted.
For nickases that cleave away from their
recognition sequence, the cleavage sites are indicated
in parentheses. See details for more information.}

\item{weights}{Optional numeric vector specifying relative weights
of the PAM sequences to specify cleavage probabilities.}

\item{metadata}{Optional list providing global metadata information.}

\item{pam_side}{String specifying the side of the PAM sequence
sequence with respect to the protospacer sequence. Must be either 
'3prime' (e.g. Cas9) or '5prime' (e.g. Cas12a)}

\item{spacer_gap}{Integer specifying the length (in nucleotides) between
the spacer sequence and the PAM sequence (e.g. 0 for Cas9 and Cas12a).}

\item{spacer_length}{Integer specifying the length of the spacer sequence}

\item{object}{\linkS4class{CrisprNickase} object.}

\item{value}{For \code{spacerLength<-} and \code{gapLength<-}, must be 
a non-negative integer. For \code{pamSide}, must be either
'5prime' or '3prime'.}

\item{primary}{Should only the PAM sequence with the heighest weight
be returned? If no cleavage weights are stored in the
\linkS4class{CrisprNickase} object, all sequences are returned.
TRUE by default.}

\item{ignore_pam}{Should all possible k-mer sequences for a given PAM length
be returned, irrespetively of the PAM sequence motifs stored in the
\linkS4class{CrisprNickase} object? FALSE by default.}

\item{as.character}{Should the PAM sequences be returned as a 
character vector? FALSE by default.}
}
\value{
A CrisprNickase object
}
\description{
An S4 class to represent a CRISPR nickase.
}
\section{Functions}{
\itemize{
\item \code{CrisprNickase()}: Create a \linkS4class{CrisprNickase} object

}}
\section{Slots}{

\describe{
\item{\code{pam_side}}{String specifying the side of the PAM sequence
with respect to the protospacer sequence. Must be either 
'3prime' (e.g. SpCas9) or '5prime' (e.g. AsCas12a)}

\item{\code{spacer_length}}{Integer specifying the
length of the spacer sequence}

\item{\code{spacer_gap}}{Integer specifying the length (in nucleotides)
between the spacer sequence and the PAM sequence
(e.g. 0 for SpCas9 and AsCas12a).}
}}

\section{Constructors}{

    Use the constructor \code{link{CrisprNickase}} to create
        a CrisprNickase object.
}

\section{Accessors}{

\describe{
    \item{\code{nickaseName}:}{To get the name of the CRISPR nickase.} 
    \item{\code{spacerLength}:}{To return the length of the
        spacer sequence.}
    \item{\code{targetLength}:}{To return the length of the
        target sequence (protospacer + pam).}
    \item{\code{pamLength}:}{To return the length of the PAM sequence.}
    \item{\code{pamSide}:}{To return the side of the PAM sequence with
        respect to the spacer sequence.}
    \item{\code{spacerGap}:}{To return the length of the gap between the
        PAM and spacer sequences.}
    \item{\code{pams}:}{To return the list of PAM sequences.}
}
}

\section{Setters}{

\describe{
    \item{\code{spacerGap<-}:}{To change the length of the gap between the
        PAM and spacer sequences.}
    \item{\code{pamSide<-}:}{To change the side of the PAM sequence
        with respect to the protospacer sequence.}
    \item{\code{spacerLength<-}:}{To change the length of the spacer
        sequence.}
}
}

\section{Utility functions for genomic arithmetics}{

\describe{
    \item{\code{pamIndices}:}{To return the relative coordinates of the
        PAM sequence within the protospacer sequence.}
    \item{\code{spacerIndices}:}{To return the relatiive coordinates of
        the spacer sequence within the protospacer sequence.}
}
}

\examples{
Cas9D10A <- CrisprNickase("Cas9D10A",
                          nickingStrand="opposite",
                          pams=c("(3)NGG", "(3)NAG", "(3)NGA"),
                          weights=c(1, 0.2593, 0.0694),
                          metadata=list(description="D10A-mutated  Streptococcus
                                        pyogenes Cas9 (SpCas9) nickase"),
                          pam_side="3prime",
                          spacer_length=20)

Cas9H840A <- CrisprNickase("Cas9H840A",
                           nickingStrand="original",
                           pams=c("(3)NGG", "(3)NAG", "(3)NGA"),
                           weights=c(1, 0.2593, 0.0694),
                           metadata=list(description="H840A-mutated  Streptococcus
                                         pyogenes Cas9 (SpCas9) nickase"),
                           pam_side="3prime",
                           spacer_length=20)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/arithmetics.R
\name{getPamRanges}
\alias{getPamRanges}
\title{Construct a PAM GRanges from a list of PAM sites}
\usage{
getPamRanges(
  gr = NULL,
  seqnames = NULL,
  pam_site = NULL,
  strand = NULL,
  nuclease = NULL
)
}
\arguments{
\item{gr}{GRanges object of width 1 specifying the coordinates
of the first nucleotide of the PAM sequences.}

\item{seqnames}{Character vector of genomic sequence names.
Ignored if \code{gr} is not NULL.}

\item{pam_site}{Numeric vector specifying the coordinates of the
first nucleotide of the PAM sequences corresponding to the
PAM sequences. Ignored if \code{gr} is not NULL.}

\item{strand}{Character vector specifying the strand of the PAM. 
Ignored if \code{gr} is not NULL.}

\item{nuclease}{CrisprNuclease object.}
}
\value{
GRanges object representing genomic coordinates of PAM sequences.
}
\description{
Construct a PAM GRanges from a list of PAM sites
    using information stored in a CrisprNuclease object.
}
\examples{
data(SpCas9, AsCas12a, package="crisprBase")
library(GenomicRanges)
gr <- GRanges("chr10",
              IRanges(start=c(100,120), width=1),
              strand=c("+","-"))
getPamRanges(gr, nuclease=SpCas9)
getPamRanges(gr, nuclease=AsCas12a)

}
\author{
Jean-Philippe Fortin
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/CrisprNuclease-class.R
\docType{class}
\name{spacerLength}
\alias{spacerLength}
\alias{targetLength}
\alias{pamLength}
\alias{spacerGap}
\alias{hasSpacerGap}
\alias{spacerGap<-}
\alias{spacerLength<-}
\alias{pamSide}
\alias{pamSide<-}
\alias{pams}
\alias{pamIndices}
\alias{spacerIndices}
\alias{prototypeSequence}
\alias{CrisprNuclease-class}
\alias{CrisprNuclease}
\alias{show,CrisprNuclease-method}
\alias{pamLength,CrisprNuclease-method}
\alias{spacerLength,CrisprNuclease-method}
\alias{spacerLength<-,CrisprNuclease-method}
\alias{pamSide,CrisprNuclease-method}
\alias{pamSide<-,CrisprNuclease-method}
\alias{spacerGap,CrisprNuclease-method}
\alias{spacerGap<-,CrisprNuclease-method}
\alias{hasSpacerGap,CrisprNuclease-method}
\alias{targetLength,CrisprNuclease-method}
\alias{pams,CrisprNuclease-method}
\alias{pamIndices,CrisprNuclease-method}
\alias{spacerIndices,CrisprNuclease-method}
\alias{prototypeSequence,CrisprNuclease-method}
\title{An S4 class to represent a CRISPR nuclease.}
\usage{
spacerLength(object, ...)

targetLength(object, ...)

pamLength(object, ...)

spacerGap(object)

hasSpacerGap(object)

spacerGap(object) <- value

spacerLength(object) <- value

pamSide(object, ...)

pamSide(object) <- value

pams(object, ...)

pamIndices(object, ...)

spacerIndices(object, ...)

prototypeSequence(object, ...)

CrisprNuclease(
  nucleaseName,
  targetType = c("DNA", "RNA"),
  pams = NA_character_,
  weights = rep(1, length(pams)),
  metadata = list(),
  pam_side = NA_character_,
  spacer_gap = 0L,
  spacer_length = NA_integer_
)

\S4method{show}{CrisprNuclease}(object)

\S4method{pamLength}{CrisprNuclease}(object)

\S4method{spacerLength}{CrisprNuclease}(object)

\S4method{spacerLength}{CrisprNuclease}(object) <- value

\S4method{pamSide}{CrisprNuclease}(object)

\S4method{pamSide}{CrisprNuclease}(object) <- value

\S4method{spacerGap}{CrisprNuclease}(object)

\S4method{spacerGap}{CrisprNuclease}(object) <- value

\S4method{hasSpacerGap}{CrisprNuclease}(object)

\S4method{targetLength}{CrisprNuclease}(object)

\S4method{pams}{CrisprNuclease}(object, primary = TRUE, ignore_pam = FALSE, as.character = FALSE)

\S4method{pamIndices}{CrisprNuclease}(object)

\S4method{spacerIndices}{CrisprNuclease}(object)

\S4method{prototypeSequence}{CrisprNuclease}(object, primary = TRUE)
}
\arguments{
\item{object}{\linkS4class{CrisprNuclease} object.}

\item{...}{Additional arguments for class-specific methods}

\item{value}{For \code{spacerLength<-} and \code{gapLength<-}, must be 
a non-negative integer. For \code{pamSide}, must be either
'5prime' or '3prime'.}

\item{nucleaseName}{Name of the CRISPR nuclease.}

\item{targetType}{String specifying target type ("DNA" or "RNA").}

\item{pams}{Character vector of PAM sequence motifs
written from 5' to 3. If the point of cleavage has
been determined, the precise site is marked with ^.
Only letters in the IUPAC code are accepted.
For nucleases that cleave away from their
recognition sequence, the cleavage sites are indicated
in parentheses. See details for more information.}

\item{weights}{Optional numeric vector specifying relative weights
of the PAM sequences to specify cleavage probabilities.}

\item{metadata}{Optional list providing global metadata information.}

\item{pam_side}{String specifying the side of the PAM sequence
sequence with respect to the protospacer sequence. Must be either 
'3prime' (e.g. Cas9) or '5prime' (e.g. Cas12a)}

\item{spacer_gap}{Integer specifying the length (in nucleotides) between
the spacer sequence and the PAM sequence (e.g. 0 for Cas9 and Cas12a).}

\item{spacer_length}{Integer specifying the length of the spacer sequence}

\item{primary}{Should only the PAM sequence with the heighest weight
be returned? If no cleavage weights are stored in the
\linkS4class{CrisprNuclease} object, all sequences are returned.
TRUE by default.}

\item{ignore_pam}{Should all possible k-mer sequences for a given PAM length
be returned, irrespetively of the PAM sequence motifs stored in the
\linkS4class{CrisprNuclease} object? FALSE by default.}

\item{as.character}{Should the PAM sequences be returned as a 
character vector? FALSE by default.}
}
\value{
A CrisprNuclease object
}
\description{
An S4 class to represent a CRISPR nuclease.
}
\section{Functions}{
\itemize{
\item \code{CrisprNuclease()}: Create a \linkS4class{CrisprNuclease} object

}}
\section{Slots}{

\describe{
\item{\code{pam_side}}{String specifying the side of the PAM sequence
with respect to the protospacer sequence. Must be either 
'3prime' (e.g. SpCas9) or '5prime' (e.g. AsCas12a)}

\item{\code{spacer_length}}{Integer specifying the
length of the spacer sequence}

\item{\code{spacer_gap}}{Integer specifying the length (in nucleotides)
between the spacer sequence and the PAM sequence
(e.g. 0 for SpCas9 and AsCas12a).}
}}

\section{Constructors}{

    Use the constructor \code{link{CrisprNuclease}} to create
        a CrisprNuclease object.
}

\section{Accessors}{

\describe{
    \item{\code{nucleaseName}:}{To get the name of the CRISPR nuclease.} 
    \item{\code{spacerLength}:}{To return the length of the
        spacer sequence.}
    \item{\code{targetLength}:}{To return the length of the
        target sequence (protospacer + pam).}
    \item{\code{pamLength}:}{To return the length of the PAM sequence.}
    \item{\code{pamSide}:}{To return the side of the PAM sequence with
        respect to the spacer sequence.}
    \item{\code{spacerGap}:}{To return the length of the gap between the
        PAM and spacer sequences.}
    \item{\code{pams}:}{To return the list of PAM sequences.}
}
}

\section{Setters}{

\describe{
    \item{\code{spacerGap<-}:}{To change the length of the gap between the
        PAM and spacer sequences.}
    \item{\code{pamSide<-}:}{To change the side of the PAM sequence
        with respect to the protospacer sequence.}
    \item{\code{spacerLength<-}:}{To change the length of the spacer
        sequence.}
}
}

\section{Utility functions for genomic arithmetics}{

\describe{
    \item{\code{pamIndices}:}{To return the relative coordinates of the
        PAM sequence within the target sequence.}
    \item{\code{spacerIndices}:}{To return the relatiive coordinates of
        the spacer sequence within the target sequence.}
}
}

\examples{
SpCas9 <- CrisprNuclease("SpCas9",
                         pams=c("(3/3)NGG", "(3/3)NAG", "(3/3)NGA"),
                         weights=c(1, 0.2593, 0.0694),
                         metadata=list(description="Wildtype Streptococcus
                                       pyogenes Cas9 (SpCas9) nuclease"),
                         pam_side="3prime",
                         spacer_length=20)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{getAvailableCrisprNucleases}
\alias{getAvailableCrisprNucleases}
\title{Return list of available CrisprNuclease objects in crisprBase}
\usage{
getAvailableCrisprNucleases()
}
\value{
Character vector of available \code{CrisprNuclease} objects found
    in \code{crisprBase}.
}
\description{
Return list of available CrisprNuclease objects in crisprBase.
}
\examples{
getAvailableCrisprNucleases()

}
\author{
Jean-Philippe Fortin
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{SpG}
\alias{SpG}
\title{SpG CrisprNuclease object}
\format{
CrisprNuclease object.
}
\usage{
data(SpG, package="crisprBase")
}
\description{
CrisprNuclease object for the engineered Streptococcus pyogenes Cas9
    SpG nuclease.
}
\details{
The SpG nuclease recognizes NGN PAM sequences. Spacer
    sequences must be located upstream of PAM sequences. Editing weights 
    were obtained from \url{doi:10.1038/s41467-022-28884-7}.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{AsCas12a}
\alias{AsCas12a}
\title{AsCas12a CrisprNuclease object}
\format{
CrisprNuclease object.
}
\usage{
data(AsCas12a, package="crisprBase")
}
\description{
CrisprNuclease object for the Wildtype Acidaminococcus Cas12a (AsCas12a)
    nuclease.
}
\details{
The AsCas12a nuclease recognizes TTTV PAM sequences. Spacer
    sequences must be located downstream of PAM sequences.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{Csm}
\alias{Csm}
\title{Csm CrisprNuclease object}
\format{
CrisprNuclease object.
}
\usage{
data(Csm, package="crisprBase")
}
\description{
CrisprNuclease object for the RNA-targeting
    Csm complex from Streptococcus thermophilus
}
\details{
The specific Csm complex is an RNA-targeting nuclease derived from 
    Streptococcus thermophilus. There is no preferred PAM sequences,
    and the default (optimal) spacer length is 32nt. 
    See \url{https://doi.org/10.1038/s41587-022-01649-9}.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{SpCas9}
\alias{SpCas9}
\title{SpCas9 CrisprNuclease object}
\format{
CrisprNuclease object.
}
\usage{
data(SpCas9, package="crisprBase")
}
\description{
CrisprNuclease object for the wildtype Streptococcus pyogenes Cas9 (SpCas9)
    nuclease.
}
\details{
The SpCas9 nuclease recognizes NGG PAM sequences. Spacer
    sequences must be located upstream of PAM sequences.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/arithmetics.R
\name{extractProtospacerFromTarget}
\alias{extractProtospacerFromTarget}
\title{Extract protospacer sequences from target sequences}
\usage{
extractProtospacerFromTarget(targets, object)
}
\arguments{
\item{targets}{Character vector of targets sequences.}

\item{object}{\code{CrisprNuclease} corresponding to the targets 
sequences.}
}
\value{
Character vector of protospacer sequences of 
    length equal to that of the 
    \code{targets} character vector.
}
\description{
Extract protospacer sequences from target sequences
    (protospacer + PAM) using information stored in a
    CrisprNuclease object.
}
\examples{
data(SpCas9, AsCas12a, package="crisprBase")
# Extracting protospacer sequences from Cas9 targets:
targets <- c("AGGTGCTGATTGTAGTGCTGCGG",
             "AGGTGCTGATTGTAGTGCTGAGG")
extractProtospacerFromTarget(targets, SpCas9)
# Extracting protospacer sequences from Cas12a targets:
targets <- c("TTTAAGGTGCTGATTGTAGTGCTGTGT",
             "TTTCAGGTGCTGATTGTAGTGCTGAAA")
extractProtospacerFromTarget(targets, AsCas12a)

}
\author{
Jean-Philippe Fortin
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{MAD7}
\alias{MAD7}
\title{MAD7 CrisprNuclease object}
\format{
CrisprNuclease object.
}
\usage{
data(MAD7, package="crisprBase")
}
\description{
CrisprNuclease object for the MAD7 nuclease (Cas12a-like nuclease)
}
\details{
The MAD7 nuclease recognizes YTTV PAM sequences. Spacer
    sequences must be located downstream of PAM sequences.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/arithmetics.R
\name{getEditingSiteFromPamSite}
\alias{getEditingSiteFromPamSite}
\title{Return optimal editing site coordinates from PAM site coordinates}
\usage{
getEditingSiteFromPamSite(
  pam_site,
  strand,
  baseEditor = NULL,
  substitution = NULL
)
}
\arguments{
\item{pam_site}{Coordinate of the first nucleotide of the PAM sequence.}

\item{strand}{Either "+" or "-".}

\item{baseEditor}{A \linkS4class{BaseEditor} object.}

\item{substitution}{String indicating which substitution
should be used to estimate the optimal editing position. 
E.g. "C2T" will return the optimal editing position for C to T
editing.}
}
\value{
numeric vector of editing sites.
}
\description{
Return optimal editing site coordinates from PAM 
    site coordinates.
}
\examples{
data(BE4max, package="crisprBase")
getEditingSiteFromPamSite(pam_site=100, strand="+", baseEditor=BE4max, "C2T")

}
\author{
Jean-Philippe Fortin
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{BE4max}
\alias{BE4max}
\title{BE4max BaseEditor object}
\format{
BaseEditor object.
}
\usage{
data(BE4max, package="crisprBase")
}
\description{
BaseEditor for the cytosine base editor CRISPR/Cas9 system
    BE4max. Editing weights were obtained from
    https://doi.org/10.1016/j.cell.2020.05.037
}
\details{
BaseEditor for the cytosine base editor
    CRISPR/Cas9 system BE4max. Editing weights were obtained from
    \url{https://doi.org/10.1016/j.cell.2020.05.037}.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/annotateMismatches.R
\name{annotateMismatches}
\alias{annotateMismatches}
\title{Annotate mismatches between spacer and protospacer sequences}
\usage{
annotateMismatches(spacers, protospacers, rnase = FALSE)
}
\arguments{
\item{spacers}{A character vector specifying spacer sequences (gRNA).}

\item{protospacers}{A character vector specifying protospacer sequences
(target DNA).}

\item{rnase}{Is it for an RNAse? FALSE by default.
If TRUE, spacers and protospacers are expected to be
the reverse complement of each other.}
}
\value{
A data.frame storing spacer and protospacer columns,
    as well as number of mismatches, and positions for 
    the different mismatches, if any.
    Positions are relative to the 5' end of the 
    spacer sequences. For RNAses (e.g. CasRx), this means
    that a mismatch at position 1 corresponds to the last
    nucleotide of the protospacer sequence.
}
\description{
Annotate mismatches between spacer and protospacer sequences.
}
\examples{
spacers <- c("CCGGAGCGAGTTGCAGTAAGCAG",
    "GCCGGAGCGAGTTGCAGTAAGCA", 
    "GGCCGGAGCGAGTTGCAGTAAGC")

protospacers=c("CTGCTTACTGCAACTCGCTCTGG",
    "TGCTTAATGCAACCCGCTCCGGC", 
    "GCTTACTGCAACTCGCTCCGGCC")

ann <- annotateMismatches(spacers,
    protospacers,
    rnase=TRUE)

}
\author{
Jean-Philippe Fortin
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{CasRx}
\alias{CasRx}
\title{CasRx CrisprNuclease object}
\format{
CrisprNuclease object.
}
\usage{
data(CasRx, package="crisprBase")
}
\description{
CrisprNuclease object for the Cas13d-NLS from Ruminococcus
    flavefaciens strain XPD3002 nuclease (RNase).
}
\details{
The CasRx nuclease was derived from Cas13d Ruminococcus
    flavefaciens string XPD3002. See \url{10.1016/j.cell.2018.02.033}.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/BaseEditor-class.R
\docType{class}
\name{baseEditorName}
\alias{baseEditorName}
\alias{baseEditorName<-}
\alias{editingWeights}
\alias{editingStrand}
\alias{editingStrand<-}
\alias{BaseEditor-class}
\alias{BaseEditor}
\alias{show,BaseEditor-method}
\alias{baseEditorName,BaseEditor-method}
\alias{baseEditorName<-,BaseEditor-method}
\alias{editingWeights,BaseEditor-method}
\alias{setEditingWeights}
\alias{editingStrand,BaseEditor-method}
\alias{editingStrand<-,BaseEditor-method}
\title{An S4 class to represent a base editor}
\usage{
baseEditorName(object)

baseEditorName(object) <- value

editingWeights(object, ...)

editingStrand(object, ...)

editingStrand(object) <- value

BaseEditor(
  CrisprNuclease,
  baseEditorName = NA_character_,
  editingStrand = c("original", "opposite"),
  editingWeights = NULL,
  scale = TRUE
)

\S4method{show}{BaseEditor}(object)

\S4method{baseEditorName}{BaseEditor}(object)

\S4method{baseEditorName}{BaseEditor}(object) <- value

\S4method{editingWeights}{BaseEditor}(object, substitutions = NULL)

setEditingWeights(object, value, scale = TRUE)

\S4method{editingStrand}{BaseEditor}(object)

\S4method{editingStrand}{BaseEditor}(object) <- value
}
\arguments{
\item{object}{\linkS4class{BaseEditor} object.}

\item{value}{Value to replaced with.}

\item{...}{Additional arguments for class-specific methods}

\item{CrisprNuclease}{A \linkS4class{CrisprNuclease} object.}

\item{baseEditorName}{String specifying base editor name.}

\item{editingStrand}{String indicating which strand with
respect to the target protospacer sequence will be 
edited. Must be either "original" or "opposite".
"original" by default.}

\item{editingWeights}{Numeric matrix of editing weights.
Column names must be indicating relative position to the PAM site.
Row names must be of the form "X2Y" where "X" represents the origin
base, and "Y" represents the subtituted base. For instance, "C2T"
indicates the row corresponding to C to T editing.}

\item{scale}{Logical indicating if weights should be scaled to have a maximum of 1.
TRUE by default. Should be set to FALSE if editing weights are 
already representing editing probabilities.}

\item{substitutions}{Character vector indicating which substitutions
should be returned.}
}
\value{
A BaseEditor object
}
\description{
An S4 class to represent a base editor
}
\section{Functions}{
\itemize{
\item \code{BaseEditor()}: Create a \linkS4class{BaseEditor} object

}}
\section{Slots}{

\describe{
\item{\code{baseEditorName}}{Name of the base editor.}

\item{\code{editingWeights}}{Matrix of editing weights.}

\item{\code{editingStrand}}{String indicating which strand with
respect to the target protospacer sequence will be 
edited. Must be either "original" or "opposite".
"original" by default.}
}}

\section{Constructors}{

    Use the constructor \code{link{BaseEditor}} to create
    a BaseEditor object.
}

\section{Accessors}{

\describe{
    \item{\code{baseEditorName}:}{To get the name of the base editor.}
    \item{\code{editingWeights}:}{To return the matrix of editing weights.}
    \item{\code{editingStrand}:}{To return the editing strand.}
}
}

\section{Setters}{

\describe{
    \item{\code{baseEditorName<-}:}{To change the name of the base editor.}
    \item{\code{editingWeights<-}:}{To change the matrix of editing weights.}
    \item{\code{editingStrand<-}:}{To change the editing strand.}
}
}

\examples{
# Creating an object for BE4max (C to T editor)
# based on experimental weights

ws <- c(0.7, 0.7, 0.8, 1.8, 1, 2, 1.4, 1.2, 2.3, 1.3, 2.4, 2.2, 3.4, 
      2.2, 2.1, 3.5, 5.8, 16.2, 31.8, 63.2, 90.3, 100, 87, 62, 31.4, 
      16.3, 10, 5.6, 3.3, 1.9, 1.8, 2.4, 1.7, 0.5, 0.2, 0.1)
ws <- matrix(ws, nrow=1, ncol=length(ws))
rownames(ws) <- "C2T"
colnames(ws) <- -36:-1
data(SpCas9, package="crisprBase")
BE4max <- BaseEditor(SpCas9,
                     baseEditorName="BE4max",
                     editingStrand="original",
                     editingWeights=ws)
metadata(BE4max)$description_base_editor <- "BE4max cytosine base editor."

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{SaCas9}
\alias{SaCas9}
\title{SaCas9 CrisprNuclease object}
\format{
CrisprNuclease object.
}
\usage{
data(SaCas9, package="crisprBase")
}
\description{
CrisprNuclease object for the wildtype Staphylococcus aureus Cas9 (SaCas9)
    nuclease.
}
\details{
The AsCas9 nuclease recognizes NNGRRT PAM sequences. Spacer
    sequences must be located upstream of PAM sequences. Editing weights 
    were obtained from \url{doi:10.1038/nature14299}.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/BaseEditor-class.R
\name{plotEditingWeights}
\alias{plotEditingWeights}
\title{Quick plot to visualize editing weights}
\usage{
plotEditingWeights(
  baseEditor,
  discardEmptyRows = TRUE,
  substitutions = NULL,
  ylim = c(0, 1),
  ...
)
}
\arguments{
\item{baseEditor}{A \code{\linkS4class{BaseEditor}} object.}

\item{discardEmptyRows}{Should rows that have all weight equal
to 0 be discarded? TRUE by default.}

\item{substitutions}{Character vector specifying substitutions
to be plotted. If NULL (default), all substitutions are shown.}

\item{ylim}{Vector of length 2 specifying the y plot limits.}

\item{...}{Additional arguments to be passed to \code{plot}}
}
\value{
Nothing. A plot is generated as a side effect.
}
\description{
Quick plot to visualize editing weights from a 
BaseEditor object.
}
\examples{
if (interactive()){
    data(BE4max, package="crisprBase")
    plotEditingWeights(BE4max)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/Nickase-class.R
\docType{class}
\name{nickaseName}
\alias{nickaseName}
\alias{nickaseName<-}
\alias{nickingStrand}
\alias{nickingStrand<-}
\alias{Nickase-class}
\alias{Nickase}
\alias{show,Nickase-method}
\alias{nickaseName,Nickase-method}
\alias{nickaseName<-,Nickase-method}
\alias{nickingStrand,Nickase-method}
\alias{nickingStrand<-,Nickase-method}
\alias{weights,Nickase-method}
\alias{weights<-,Nickase-method}
\alias{isCutting,Nickase-method}
\alias{motifs,Nickase-method}
\alias{motifLength,Nickase-method}
\alias{cutSites,Nickase-method}
\title{An S4 class to represent a nickase}
\usage{
nickaseName(object)

nickaseName(object) <- value

nickingStrand(object)

nickingStrand(object) <- value

Nickase(
  nickaseName,
  nickingStrand = c("original", "opposite"),
  motifs = NULL,
  cutSites = NULL,
  weights = rep(1, length(motifs)),
  metadata = list()
)

\S4method{show}{Nickase}(object)

\S4method{nickaseName}{Nickase}(object)

\S4method{nickaseName}{Nickase}(object) <- value

\S4method{nickingStrand}{Nickase}(object)

\S4method{nickingStrand}{Nickase}(object) <- value

\S4method{weights}{Nickase}(object, expand = FALSE)

\S4method{weights}{Nickase}(object) <- value

\S4method{isCutting}{Nickase}(object)

\S4method{motifs}{Nickase}(
  object,
  primary = FALSE,
  strand = c("+", "-"),
  expand = FALSE,
  as.character = FALSE
)

\S4method{motifLength}{Nickase}(object)

\S4method{cutSites}{Nickase}(object, combine = TRUE)
}
\arguments{
\item{object}{\linkS4class{Nickase} object.}

\item{value}{New value to pass to the setter functions.}

\item{nickaseName}{Name of the nickase.}

\item{nickingStrand}{String specifying with strand with respect
to the motif sequence (5' to 3') is nicked.
Must be either "original" (default) or "opposite".}

\item{motifs}{Character vector of recognition sequence motifs
written from 5' to 3' written in Rebase convention.
If the point of cleavage has been determined, the
precise site is marked with ^. Only letters in the
IUPAC code are accepted. For nickases that cleave
away from their recognition sequence, the cleavage
sites are indicated in parentheses. See details for
more information.}

\item{cutSites}{Vector specifying the cleavage coordinates relative
to the first nucleotide of the motif sequence. Each column corresponds
to a motif specified in the \code{motifs} slot.}

\item{weights}{Optional numeric vector specifying relative weights
for the recognition motifs to specify cleavage probabilities.}

\item{metadata}{Optional list providing global metadata information.}

\item{expand}{Should sequences be expanded to only contain ATCG nucleotides?
FALSE by default.}

\item{primary}{Should only the motif with the highest weight be returned?
FALSE by default. Only relevant if weights are stored in the 
\linkS4class{Nickase} object.}

\item{strand}{Strand to allow reverse complementation of the motif.
"+" by default.}

\item{as.character}{Should the motif sequences be returned as a 
character vector? FALSE by default.}

\item{combine}{Should only unique values be considered?
TRUE by default.}
}
\value{
A Nickase object
}
\description{
An S4 class to represent a nickase
}
\section{Functions}{
\itemize{
\item \code{Nickase()}: Create a \linkS4class{Nickase} object

}}
\section{Slots}{

\describe{
\item{\code{nickaseName}}{Name of the nickase}

\item{\code{motifs}}{DNAStringSet of recognition sequence motifs
written from 5' to 3'.}

\item{\code{nickingStrand}}{String specifying with strand with respect
to the motif sequence (5' to 3') is nicked.
Must be either "original" (default) or "opposite".}

\item{\code{cutSites}}{Vector specifying the cleavage coordinates relative
to the first nucleotide of the motif sequence.
Each column corresponds to a motif specified in the \code{motifs} slot.}

\item{\code{weights}}{Optional numeric vector specifying relative weights
for the motifs corresponding to cleavage probabilities.}

\item{\code{metadata}}{Optional string providing a description of the nickase.}
}}

\section{Constructors}{

    Use the constructor \code{link{Nickase}} to create a Nickase object.
}

\section{Accessors}{

\describe{
    \item{\code{nickaseName}:}{To get the name of the nickase.} 
    \item{\code{nickingStrand}:}{To get the nicking strand.} 
    \item{\code{metadata}:}{To get the metadata list of the nickase} 
    \item{\code{motifs}:}{To get the recognition mofif
         nucleotide sequences.}
    \item{\code{weights}:}{To get nickase weights.} 
    \item{\code{cutSites}:}{To get nickase cut sites.} 
}
}

\examples{
Nb.BsmI <- Nickase("Nb.BsmI",
                   motifs=c("GAATG^C"),
                   nickingStrand="opposite",
                   metadata=list(description="Nb.BsmI nicking enzyme."))

}
\seealso{
See the \linkS4class{CrisprNickase} for CRISPR-specific nickases.
}
